#ifndef UDGDICOMDICTIONARYH
#define UDGDICOMDICTIONARYH

#include "dicomtag.h"

namespace udg {
/*
** Defined SOP UIDs according to 2004 DICOM edition
*/

// Storage
const char* const UIDStoredPrintStorage                                     = "1.2.840.10008.5.1.1.27";
const char* const UIDHardcopyGrayscaleImageStorage                          = "1.2.840.10008.5.1.1.29";
const char* const UIDHardcopyColorImageStorage                              = "1.2.840.10008.5.1.1.30";
const char* const UIDComputedRadiographyImageStorage                        = "1.2.840.10008.5.1.4.1.1.1";
const char* const UIDDigitalXRayImageStorageForPresentation                 = "1.2.840.10008.5.1.4.1.1.1.1";
const char* const UIDDigitalXRayImageStorageForProcessing                   = "1.2.840.10008.5.1.4.1.1.1.1.1";
const char* const UIDDigitalMammographyXRayImageStorageForPresentation      = "1.2.840.10008.5.1.4.1.1.1.2";
const char* const UIDDigitalMammographyXRayImageStorageForProcessing        = "1.2.840.10008.5.1.4.1.1.1.2.1";
const char* const UIDDigitalIntraOralXRayImageStorageForPresentation        = "1.2.840.10008.5.1.4.1.1.1.3";
const char* const UIDDigitalIntraOralXRayImageStorageForProcessing          = "1.2.840.10008.5.1.4.1.1.1.3.1";
const char* const UIDRETIREDStandaloneModalityLUTStorage                    = "1.2.840.10008.5.1.4.1.1.10";
const char* const UIDRETIREDStandaloneVOILUTStorage                         = "1.2.840.10008.5.1.4.1.1.11";
const char* const UIDGrayscaleSoftcopyPresentationStateStorage              = "1.2.840.10008.5.1.4.1.1.11.1";
const char* const UIDXRayAngiographicImageStorage                           = "1.2.840.10008.5.1.4.1.1.12.1";
const char* const UIDXRayRadioFluoroscopicImageStorage                      = "1.2.840.10008.5.1.4.1.1.12.2";
const char* const UIDRETIREDXRayAngiographicBiPlaneImageStorage             = "1.2.840.10008.5.1.4.1.1.12.3";
const char* const UIDPositronEmissionTomographyImageStorage                 = "1.2.840.10008.5.1.4.1.1.128";
const char* const UIDRETIREDStandalonePETCurveStorage                       = "1.2.840.10008.5.1.4.1.1.129";
const char* const UIDCTImageStorage                                         = "1.2.840.10008.5.1.4.1.1.2";
const char* const UIDEnhancedCTImageStorage                                 = "1.2.840.10008.5.1.4.1.1.2.1";
const char* const UIDNuclearMedicineImageStorage                            = "1.2.840.10008.5.1.4.1.1.20";
const char* const UIDRETIREDUltrasoundMultiframeImageStorage                = "1.2.840.10008.5.1.4.1.1.3";
const char* const UIDUltrasoundMultiframeImageStorage                       = "1.2.840.10008.5.1.4.1.1.3.1";
const char* const UIDMRImageStorage                                         = "1.2.840.10008.5.1.4.1.1.4";
const char* const UIDEnhancedMRImageStorage                                 = "1.2.840.10008.5.1.4.1.1.4.1";
const char* const UIDMRSpectroscopyStorage                                  = "1.2.840.10008.5.1.4.1.1.4.2";
const char* const UIDRTImageStorage                                         = "1.2.840.10008.5.1.4.1.1.481.1";
const char* const UIDRTDoseStorage                                          = "1.2.840.10008.5.1.4.1.1.481.2";
const char* const UIDRTStructureSetStorage                                  = "1.2.840.10008.5.1.4.1.1.481.3";
const char* const UIDRTBeamsTreatmentRecordStorage                          = "1.2.840.10008.5.1.4.1.1.481.4";
const char* const UIDRTPlanStorage                                          = "1.2.840.10008.5.1.4.1.1.481.5";
const char* const UIDRTBrachyTreatmentRecordStorage                         = "1.2.840.10008.5.1.4.1.1.481.6";
const char* const UIDRTTreatmentSummaryRecordStorage                        = "1.2.840.10008.5.1.4.1.1.481.7";
const char* const UIDRETIREDNuclearMedicineImageStorage                     = "1.2.840.10008.5.1.4.1.1.5";
const char* const UIDRETIREDUltrasoundImageStorage                          = "1.2.840.10008.5.1.4.1.1.6";
const char* const UIDUltrasoundImageStorage                                 = "1.2.840.10008.5.1.4.1.1.6.1";
const char* const UIDRawDataStorage                                         = "1.2.840.10008.5.1.4.1.1.66";
const char* const UIDSpatialRegistrationStorage                             = "1.2.840.10008.5.1.4.1.1.66.1";
const char* const UIDSpatialFiducialsStorage                                = "1.2.840.10008.5.1.4.1.1.66.2";
const char* const UIDSecondaryCaptureImageStorage                           = "1.2.840.10008.5.1.4.1.1.7";
const char* const UIDMultiframeSingleBitSecondaryCaptureImageStorage        = "1.2.840.10008.5.1.4.1.1.7.1";
const char* const UIDMultiframeGrayscaleByteSecondaryCaptureImageStorage    = "1.2.840.10008.5.1.4.1.1.7.2";
const char* const UIDMultiframeGrayscaleWordSecondaryCaptureImageStorage    = "1.2.840.10008.5.1.4.1.1.7.3";
const char* const UIDMultiframeTrueColorSecondaryCaptureImageStorage        = "1.2.840.10008.5.1.4.1.1.7.4";
const char* const UIDRETIREDVLImageStorage                                  = "1.2.840.10008.5.1.4.1.1.77.1";
const char* const UIDVLEndoscopicImageStorage                               = "1.2.840.10008.5.1.4.1.1.77.1.1";
const char* const UIDVideoEndoscopicImageStorage                            = "1.2.840.10008.5.1.4.1.1.77.1.1.1";
const char* const UIDVLMicroscopicImageStorage                              = "1.2.840.10008.5.1.4.1.1.77.1.2";
const char* const UIDVideoMicroscopicImageStorage                           = "1.2.840.10008.5.1.4.1.1.77.1.2.1";
const char* const UIDVLSlideCoordinatesMicroscopicImageStorage              = "1.2.840.10008.5.1.4.1.1.77.1.3";
const char* const UIDVLPhotographicImageStorage                             = "1.2.840.10008.5.1.4.1.1.77.1.4";
const char* const UIDVideoPhotographicImageStorage                          = "1.2.840.10008.5.1.4.1.1.77.1.4.1";
const char* const UIDOphthalmicPhotography8BitImageStorage                  = "1.2.840.10008.5.1.4.1.1.77.1.5.1";
const char* const UIDOphthalmicPhotography16BitImageStorage                 = "1.2.840.10008.5.1.4.1.1.77.1.5.2";
const char* const UIDStereometricRelationshipStorage                        = "1.2.840.10008.5.1.4.1.1.77.1.5.3";
const char* const UIDRETIREDVLMultiFrameImageStorage                        = "1.2.840.10008.5.1.4.1.1.77.2";
const char* const UIDRETIREDStandaloneOverlayStorage                        = "1.2.840.10008.5.1.4.1.1.8";
const char* const UIDBasicTextSRStorage                                     = "1.2.840.10008.5.1.4.1.1.88.11";
const char* const UIDEnhancedSRStorage                                      = "1.2.840.10008.5.1.4.1.1.88.22";
const char* const UIDComprehensiveSRStorage                                 = "1.2.840.10008.5.1.4.1.1.88.33";
const char* const UIDProcedureLogStorage                                    = "1.2.840.10008.5.1.4.1.1.88.40";
const char* const UIDMammographyCADSRStorage                                = "1.2.840.10008.5.1.4.1.1.88.50";
const char* const UIDKeyObjectSelectionDocumentStorage                      = "1.2.840.10008.5.1.4.1.1.88.59";
const char* const UIDChestCADSRStorage                                      = "1.2.840.10008.5.1.4.1.1.88.65";
const char* const UIDRETIREDStandaloneCurveStorage                          = "1.2.840.10008.5.1.4.1.1.9";
const char* const UIDTwelveLeadECGWaveformStorage                           = "1.2.840.10008.5.1.4.1.1.9.1.1";
const char* const UIDGeneralECGWaveformStorage                              = "1.2.840.10008.5.1.4.1.1.9.1.2";
const char* const UIDAmbulatoryECGWaveformStorage                           = "1.2.840.10008.5.1.4.1.1.9.1.3";
const char* const UIDHemodynamicWaveformStorage                             = "1.2.840.10008.5.1.4.1.1.9.2.1";
const char* const UIDCardiacElectrophysiologyWaveformStorage                = "1.2.840.10008.5.1.4.1.1.9.3.1";
const char* const UIDBasicVoiceAudioWaveformStorage                         = "1.2.840.10008.5.1.4.1.1.9.4.1";

const char* const UIDEnhancedXAImageStorage                                 = "1.2.840.10008.5.1.4.1.1.12.1.1";
const char* const UIDEnhancedXRFImageStorage                                = "1.2.840.10008.5.1.4.1.1.12.2.1";
const char* const UIDColorSoftcopyPresentationStateStorage                  = "1.2.840.10008.5.1.4.1.1.11.2";
const char* const UIDPseudoColorSoftcopyPresentationStateStorage            = "1.2.840.10008.5.1.4.1.1.11.3";
const char* const UIDBlendingSoftcopyPresentationStateStorage               = "1.2.840.10008.5.1.4.1.1.11.4";
const char* const UIDEncapsulatedPDFStorage                                 = "1.2.840.10008.5.1.4.1.1.104.1";
const char* const UIDRealWorldValueMappingStorage                           = "1.2.840.10008.5.1.4.1.1.67";
const char* const UIDXRayRadiationDoseSRStorage                             = "1.2.840.10008.5.1.4.1.1.88.67";
// UIDs Presents a l'edici del 2009
const char* const UIDEnhancedUSVolumeStorage                                = "1.2.840.10008.5.1.4.1.1.6.2";
const char* const UIDEnhancedMRColorImageStorage                            = "1.2.840.10008.5.1.4.1.1.4.3";
const char* const UIDEnhancedPETImageStorage                                = "1.2.840.10008.5.1.4.1.1.130";

// 2011
const char* const UIDGeneralAudioWaveformStorage                            = "1.2.840.10008.5.1.4.1.1.9.4.2";
const char* const UIDArterialPulseWaveformStorage                           = "1.2.840.10008.5.1.4.1.1.9.5.1";
const char* const UIDRespiratoryWaveformStorage                             = "1.2.840.10008.5.1.4.1.1.9.6.1";
const char* const UIDXAXRFGrayscaleSoftcopyPresentationStateStorage         = "1.2.840.10008.5.1.4.1.1.11.5";
const char* const UIDXRay3DAngiographicImageStorage                         = "1.2.840.10008.5.1.4.1.1.13.1.1";
const char* const UIDXRay3DCraniofacialImageStorage                         = "1.2.840.10008.5.1.4.1.1.13.1.2";
const char* const UIDBreastTomosynthesisImageStorage                        = "1.2.840.10008.5.1.4.1.1.13.1.3";
const char* const UIDIntravascularOpticalCoherenceTomographyImageStorageForPresentation = "1.2.840.10008.5.1.4.1.1.14.1";
const char* const UIDIntravascularOpticalCoherenceTomographyImageStorageForProcessing   = "1.2.840.10008.5.1.4.1.1.14.2";
const char* const UIDDeformableSpatialRegistrationStorage                  = "1.2.840.10008.5.1.4.1.1.66.3";
const char* const UIDSegmentationStorage                                   = "1.2.840.10008.5.1.4.1.1.66.4";
const char* const UIDSurfaceSegmentationStorage                            = "1.2.840.10008.5.1.4.1.1.66.5";
const char* const UIDOphthalmicTomographyImageStorage                      = "1.2.840.10008.5.1.4.1.1.77.1.5.4";
const char* const UIDVLWholeSlideMicroscopyImageStorage                    = "1.2.840.10008.5.1.4.1.1.77.1.6";
const char* const UIDLensometryMeasurementsStorage                         = "1.2.840.10008.5.1.4.1.1.78.1";
const char* const UIDAutorefractionMeasurementsStorage                     = "1.2.840.10008.5.1.4.1.1.78.2";
const char* const UIDKeratometryMeasurementsStorage                        = "1.2.840.10008.5.1.4.1.1.78.3";
const char* const UIDSubjectiveRefractionMeasurementsStorage               = "1.2.840.10008.5.1.4.1.1.78.4";
const char* const UIDVisualAcuityMeasurementsStorage                       = "1.2.840.10008.5.1.4.1.1.78.5";
const char* const UIDSpectaclePrescriptionReportStorage                    = "1.2.840.10008.5.1.4.1.1.78.6";
const char* const UIDOphthalmicAxialMeasurementsStorage                    = "1.2.840.10008.5.1.4.1.1.78.7";
const char* const UIDIntraocularLensCalculationsStorage                    = "1.2.840.10008.5.1.4.1.1.78.8";
const char* const UIDMacularGridThicknessAndVolumeReportStorage            = "1.2.840.10008.5.1.4.1.1.79.1";
const char* const UIDOphthalmicVisualFieldStaticPerimetryMeasurementsStorage            = "1.2.840.10008.5.1.4.1.1.80.1";
const char* const UIDOphthalmicThicknessMapStorage                         = "1.2.840.10008.5.1.4.1.1.81.1";
const char* const UIDColonCADSRStorage                                     = "1.2.840.10008.5.1.4.1.1.88.69";
const char* const UIDImplantationPlanSRDocumentStorage                     = "1.2.840.10008.5.1.4.1.1.88.70";
const char* const UIDEncapsulatedCDAStorage                                = "1.2.840.10008.5.1.4.1.1.104.2";
const char* const UIDBasicStructuredDisplayStorage                         = "1.2.840.10008.5.1.4.1.1.131";
const char* const UIDRTIonPlanStorage                                      = "1.2.840.10008.5.1.4.1.1.481.8";
const char* const UIDRTIonBeamsTreatmentRecordStorage                      = "1.2.840.10008.5.1.4.1.1.481.9";
const char* const UIDGenericImplantTemplateStorage                         = "1.2.840.10008.5.1.4.43.1";
const char* const UIDImplantAssemblyTemplateStorage                        = "1.2.840.10008.5.1.4.44.1";
const char* const UIDImplantTemplateGroupStorage                           = "1.2.840.10008.5.1.4.45.1";

// Tag dictionary
// Number of entries: 3604
// Tags with a repeating component (repeating tags) are listed afterwards
const DICOMTag DICOMCommandGroupLength (0x0000, 0x0000);
const DICOMTag DICOMRETIREDCommandLengthToEnd (0x0000, 0x0001);
const DICOMTag DICOMAffectedSOPClassUID (0x0000, 0x0002);
const DICOMTag DICOMRequestedSOPClassUID (0x0000, 0x0003);
const DICOMTag DICOMRETIREDCommandRecognitionCode (0x0000, 0x0010);
const DICOMTag DICOMCommandField (0x0000, 0x0100);
const DICOMTag DICOMMessageID (0x0000, 0x0110);
const DICOMTag DICOMMessageIDBeingRespondedTo (0x0000, 0x0120);
const DICOMTag DICOMRETIREDInitiator (0x0000, 0x0200);
const DICOMTag DICOMRETIREDReceiver (0x0000, 0x0300);
const DICOMTag DICOMRETIREDFindLocation (0x0000, 0x0400);
const DICOMTag DICOMMoveDestination (0x0000, 0x0600);
const DICOMTag DICOMPriority (0x0000, 0x0700);
const DICOMTag DICOMDataSetType (0x0000, 0x0800);
const DICOMTag DICOMRETIREDNumberOfMatches (0x0000, 0x0850);
const DICOMTag DICOMRETIREDResponseSequenceNumber (0x0000, 0x0860);
const DICOMTag DICOMStatus (0x0000, 0x0900);
const DICOMTag DICOMOffendingElement (0x0000, 0x0901);
const DICOMTag DICOMErrorComment (0x0000, 0x0902);
const DICOMTag DICOMErrorID (0x0000, 0x0903);
const DICOMTag DICOMAffectedSOPInstanceUID (0x0000, 0x1000);
const DICOMTag DICOMRequestedSOPInstanceUID (0x0000, 0x1001);
const DICOMTag DICOMEventTypeID (0x0000, 0x1002);
const DICOMTag DICOMAttributeIdentifierList (0x0000, 0x1005);
const DICOMTag DICOMActionTypeID (0x0000, 0x1008);
const DICOMTag DICOMNumberOfRemainingSubOperations (0x0000, 0x1020);
const DICOMTag DICOMNumberOfCompletedSubOperations (0x0000, 0x1021);
const DICOMTag DICOMNumberOfFailedSubOperations (0x0000, 0x1022);
const DICOMTag DICOMNumberOfWarningSubOperations (0x0000, 0x1023);
const DICOMTag DICOMMoveOriginatorApplicationEntityTitle (0x0000, 0x1030);
const DICOMTag DICOMMoveOriginatorMessageID (0x0000, 0x1031);
const DICOMTag DICOMRETIREDDialogReceiver (0x0000, 0x4000);
const DICOMTag DICOMRETIREDTerminalType (0x0000, 0x4010);
const DICOMTag DICOMRETIREDMessageSetID (0x0000, 0x5010);
const DICOMTag DICOMRETIREDEndMessageID (0x0000, 0x5020);
const DICOMTag DICOMRETIREDDisplayFormat (0x0000, 0x5110);
const DICOMTag DICOMRETIREDPagePositionID (0x0000, 0x5120);
const DICOMTag DICOMRETIREDTextFormatID (0x0000, 0x5130);
const DICOMTag DICOMRETIREDNormalReverse (0x0000, 0x5140);
const DICOMTag DICOMRETIREDAddGrayScale (0x0000, 0x5150);
const DICOMTag DICOMRETIREDBorders (0x0000, 0x5160);
const DICOMTag DICOMRETIREDCopies (0x0000, 0x5170);
const DICOMTag DICOMRETIREDCommandMagnificationType (0x0000, 0x5180);
const DICOMTag DICOMRETIREDErase (0x0000, 0x5190);
const DICOMTag DICOMRETIREDPrint (0x0000, 0x51a0);
const DICOMTag DICOMRETIREDOverlays (0x0000, 0x51b0);
const DICOMTag DICOMFileMetaInformationGroupLength (0x0002, 0x0000);
const DICOMTag DICOMFileMetaInformationVersion (0x0002, 0x0001);
const DICOMTag DICOMMediaStorageSOPClassUID (0x0002, 0x0002);
const DICOMTag DICOMMediaStorageSOPInstanceUID (0x0002, 0x0003);
const DICOMTag DICOMTransferSyntaxUID (0x0002, 0x0010);
const DICOMTag DICOMImplementationClassUID (0x0002, 0x0012);
const DICOMTag DICOMImplementationVersionName (0x0002, 0x0013);
const DICOMTag DICOMSourceApplicationEntityTitle (0x0002, 0x0016);
const DICOMTag DICOMPrivateInformationCreatorUID (0x0002, 0x0100);
const DICOMTag DICOMPrivateInformation (0x0002, 0x0102);
const DICOMTag DICOMFileSetID (0x0004, 0x1130);
const DICOMTag DICOMFileSetDescriptorFileID (0x0004, 0x1141);
const DICOMTag DICOMSpecificCharacterSetOfFileSetDescriptorFile (0x0004, 0x1142);
const DICOMTag DICOMOffsetOfTheFirstDirectoryRecordOfTheRootDirectoryEntity (0x0004, 0x1200);
const DICOMTag DICOMOffsetOfTheLastDirectoryRecordOfTheRootDirectoryEntity (0x0004, 0x1202);
const DICOMTag DICOMFileSetConsistencyFlag (0x0004, 0x1212);
const DICOMTag DICOMDirectoryRecordSequence (0x0004, 0x1220);
const DICOMTag DICOMOffsetOfTheNextDirectoryRecord (0x0004, 0x1400);
const DICOMTag DICOMRecordInUseFlag (0x0004, 0x1410);
const DICOMTag DICOMOffsetOfReferencedLowerLevelDirectoryEntity (0x0004, 0x1420);
const DICOMTag DICOMDirectoryRecordType (0x0004, 0x1430);
const DICOMTag DICOMPrivateRecordUID (0x0004, 0x1432);
const DICOMTag DICOMReferencedFileID (0x0004, 0x1500);
const DICOMTag DICOMRETIREDMRDRDirectoryRecordOffset (0x0004, 0x1504);
const DICOMTag DICOMReferencedSOPClassUIDInFile (0x0004, 0x1510);
const DICOMTag DICOMReferencedSOPInstanceUIDInFile (0x0004, 0x1511);
const DICOMTag DICOMReferencedTransferSyntaxUIDInFile (0x0004, 0x1512);
const DICOMTag DICOMReferencedRelatedGeneralSOPClassUIDInFile (0x0004, 0x151a);
const DICOMTag DICOMRETIREDNumberOfReferences (0x0004, 0x1600);
const DICOMTag DICOMRETIREDLengthToEnd (0x0008, 0x0001);
const DICOMTag DICOMSpecificCharacterSet (0x0008, 0x0005);
const DICOMTag DICOMLanguageCodeSequence (0x0008, 0x0006);
const DICOMTag DICOMImageType (0x0008, 0x0008);
const DICOMTag DICOMRETIREDRecognitionCode (0x0008, 0x0010);
const DICOMTag DICOMInstanceCreationDate (0x0008, 0x0012);
const DICOMTag DICOMInstanceCreationTime (0x0008, 0x0013);
const DICOMTag DICOMInstanceCreatorUID (0x0008, 0x0014);
const DICOMTag DICOMSOPClassUID (0x0008, 0x0016);
const DICOMTag DICOMSOPInstanceUID (0x0008, 0x0018);
const DICOMTag DICOMRelatedGeneralSOPClassUID (0x0008, 0x001a);
const DICOMTag DICOMOriginalSpecializedSOPClassUID (0x0008, 0x001b);
const DICOMTag DICOMStudyDate (0x0008, 0x0020);
const DICOMTag DICOMSeriesDate (0x0008, 0x0021);
const DICOMTag DICOMAcquisitionDate (0x0008, 0x0022);
const DICOMTag DICOMContentDate (0x0008, 0x0023);
const DICOMTag DICOMRETIREDOverlayDate (0x0008, 0x0024);
const DICOMTag DICOMRETIREDCurveDate (0x0008, 0x0025);
const DICOMTag DICOMAcquisitionDateTime (0x0008, 0x002a);
const DICOMTag DICOMStudyTime (0x0008, 0x0030);
const DICOMTag DICOMSeriesTime (0x0008, 0x0031);
const DICOMTag DICOMAcquisitionTime (0x0008, 0x0032);
const DICOMTag DICOMContentTime (0x0008, 0x0033);
const DICOMTag DICOMRETIREDOverlayTime (0x0008, 0x0034);
const DICOMTag DICOMRETIREDCurveTime (0x0008, 0x0035);
const DICOMTag DICOMRETIREDDataSetType (0x0008, 0x0040);
const DICOMTag DICOMRETIREDDataSetSubtype (0x0008, 0x0041);
const DICOMTag DICOMRETIREDNuclearMedicineSeriesType (0x0008, 0x0042);
const DICOMTag DICOMAccessionNumber (0x0008, 0x0050);
const DICOMTag DICOMIssuerOfAccessionNumberSequence (0x0008, 0x0051);
const DICOMTag DICOMQueryRetrieveLevel (0x0008, 0x0052);
const DICOMTag DICOMRetrieveAETitle (0x0008, 0x0054);
const DICOMTag DICOMInstanceAvailability (0x0008, 0x0056);
const DICOMTag DICOMFailedSOPInstanceUIDList (0x0008, 0x0058);
const DICOMTag DICOMModality (0x0008, 0x0060);
const DICOMTag DICOMModalitiesInStudy (0x0008, 0x0061);
const DICOMTag DICOMSOPClassesInStudy (0x0008, 0x0062);
const DICOMTag DICOMConversionType (0x0008, 0x0064);
const DICOMTag DICOMPresentationIntentType (0x0008, 0x0068);
const DICOMTag DICOMManufacturer (0x0008, 0x0070);
const DICOMTag DICOMInstitutionName (0x0008, 0x0080);
const DICOMTag DICOMInstitutionAddress (0x0008, 0x0081);
const DICOMTag DICOMInstitutionCodeSequence (0x0008, 0x0082);
const DICOMTag DICOMReferringPhysicianName (0x0008, 0x0090);
const DICOMTag DICOMReferringPhysicianAddress (0x0008, 0x0092);
const DICOMTag DICOMReferringPhysicianTelephoneNumbers (0x0008, 0x0094);
const DICOMTag DICOMReferringPhysicianIdentificationSequence (0x0008, 0x0096);
const DICOMTag DICOMCodeValue (0x0008, 0x0100);
const DICOMTag DICOMCodingSchemeDesignator (0x0008, 0x0102);
const DICOMTag DICOMCodingSchemeVersion (0x0008, 0x0103);
const DICOMTag DICOMCodeMeaning (0x0008, 0x0104);
const DICOMTag DICOMMappingResource (0x0008, 0x0105);
const DICOMTag DICOMContextGroupVersion (0x0008, 0x0106);
const DICOMTag DICOMContextGroupLocalVersion (0x0008, 0x0107);
const DICOMTag DICOMContextGroupExtensionFlag (0x0008, 0x010b);
const DICOMTag DICOMCodingSchemeUID (0x0008, 0x010c);
const DICOMTag DICOMContextGroupExtensionCreatorUID (0x0008, 0x010d);
const DICOMTag DICOMContextIdentifier (0x0008, 0x010f);
const DICOMTag DICOMCodingSchemeIdentificationSequence (0x0008, 0x0110);
const DICOMTag DICOMCodingSchemeRegistry (0x0008, 0x0112);
const DICOMTag DICOMCodingSchemeExternalID (0x0008, 0x0114);
const DICOMTag DICOMCodingSchemeName (0x0008, 0x0115);
const DICOMTag DICOMCodingSchemeResponsibleOrganization (0x0008, 0x0116);
const DICOMTag DICOMContextUID (0x0008, 0x0117);
const DICOMTag DICOMTimezoneOffsetFromUTC (0x0008, 0x0201);
const DICOMTag DICOMRETIREDNetworkID (0x0008, 0x1000);
const DICOMTag DICOMStationName (0x0008, 0x1010);
const DICOMTag DICOMStudyDescription (0x0008, 0x1030);
const DICOMTag DICOMProcedureCodeSequence (0x0008, 0x1032);
const DICOMTag DICOMSeriesDescription (0x0008, 0x103e);
const DICOMTag DICOMSeriesDescriptionCodeSequence (0x0008, 0x103f);
const DICOMTag DICOMInstitutionalDepartmentName (0x0008, 0x1040);
const DICOMTag DICOMPhysiciansOfRecord (0x0008, 0x1048);
const DICOMTag DICOMPhysiciansOfRecordIdentificationSequence (0x0008, 0x1049);
const DICOMTag DICOMPerformingPhysicianName (0x0008, 0x1050);
const DICOMTag DICOMPerformingPhysicianIdentificationSequence (0x0008, 0x1052);
const DICOMTag DICOMNameOfPhysiciansReadingStudy (0x0008, 0x1060);
const DICOMTag DICOMPhysiciansReadingStudyIdentificationSequence (0x0008, 0x1062);
const DICOMTag DICOMOperatorsName (0x0008, 0x1070);
const DICOMTag DICOMOperatorIdentificationSequence (0x0008, 0x1072);
const DICOMTag DICOMAdmittingDiagnosesDescription (0x0008, 0x1080);
const DICOMTag DICOMAdmittingDiagnosesCodeSequence (0x0008, 0x1084);
const DICOMTag DICOMManufacturerModelName (0x0008, 0x1090);
const DICOMTag DICOMRETIREDReferencedResultsSequence (0x0008, 0x1100);
const DICOMTag DICOMReferencedStudySequence (0x0008, 0x1110);
const DICOMTag DICOMReferencedPerformedProcedureStepSequence (0x0008, 0x1111);
const DICOMTag DICOMReferencedSeriesSequence (0x0008, 0x1115);
const DICOMTag DICOMReferencedPatientSequence (0x0008, 0x1120);
const DICOMTag DICOMReferencedVisitSequence (0x0008, 0x1125);
const DICOMTag DICOMRETIREDReferencedOverlaySequence (0x0008, 0x1130);
const DICOMTag DICOMReferencedStereometricInstanceSequence (0x0008, 0x1134);
const DICOMTag DICOMReferencedWaveformSequence (0x0008, 0x113a);
const DICOMTag DICOMReferencedImageSequence (0x0008, 0x1140);
const DICOMTag DICOMRETIREDReferencedCurveSequence (0x0008, 0x1145);
const DICOMTag DICOMReferencedInstanceSequence (0x0008, 0x114a);
const DICOMTag DICOMReferencedRealWorldValueMappingInstanceSequence (0x0008, 0x114b);
const DICOMTag DICOMReferencedSOPClassUID (0x0008, 0x1150);
const DICOMTag DICOMReferencedSOPInstanceUID (0x0008, 0x1155);
const DICOMTag DICOMSOPClassesSupported (0x0008, 0x115a);
const DICOMTag DICOMReferencedFrameNumber (0x0008, 0x1160);
const DICOMTag DICOMSimpleFrameList (0x0008, 0x1161);
const DICOMTag DICOMCalculatedFrameList (0x0008, 0x1162);
const DICOMTag DICOMTimeRange (0x0008, 0x1163);
const DICOMTag DICOMFrameExtractionSequence (0x0008, 0x1164);
const DICOMTag DICOMMultiFrameSourceSOPInstanceUID (0x0008, 0x1167);
const DICOMTag DICOMTransactionUID (0x0008, 0x1195);
const DICOMTag DICOMFailureReason (0x0008, 0x1197);
const DICOMTag DICOMFailedSOPSequence (0x0008, 0x1198);
const DICOMTag DICOMReferencedSOPSequence (0x0008, 0x1199);
const DICOMTag DICOMStudiesContainingOtherReferencedInstancesSequence (0x0008, 0x1200);
const DICOMTag DICOMRelatedSeriesSequence (0x0008, 0x1250);
const DICOMTag DICOMRETIREDLossyImageCompressionRetired (0x0008, 0x2110);
const DICOMTag DICOMDerivationDescription (0x0008, 0x2111);
const DICOMTag DICOMSourceImageSequence (0x0008, 0x2112);
const DICOMTag DICOMStageName (0x0008, 0x2120);
const DICOMTag DICOMStageNumber (0x0008, 0x2122);
const DICOMTag DICOMNumberOfStages (0x0008, 0x2124);
const DICOMTag DICOMViewName (0x0008, 0x2127);
const DICOMTag DICOMViewNumber (0x0008, 0x2128);
const DICOMTag DICOMNumberOfEventTimers (0x0008, 0x2129);
const DICOMTag DICOMNumberOfViewsInStage (0x0008, 0x212a);
const DICOMTag DICOMEventElapsedTimes (0x0008, 0x2130);
const DICOMTag DICOMEventTimerNames (0x0008, 0x2132);
const DICOMTag DICOMEventTimerSequence (0x0008, 0x2133);
const DICOMTag DICOMEventTimeOffset (0x0008, 0x2134);
const DICOMTag DICOMEventCodeSequence (0x0008, 0x2135);
const DICOMTag DICOMStartTrim (0x0008, 0x2142);
const DICOMTag DICOMStopTrim (0x0008, 0x2143);
const DICOMTag DICOMRecommendedDisplayFrameRate (0x0008, 0x2144);
const DICOMTag DICOMRETIREDTransducerPosition (0x0008, 0x2200);
const DICOMTag DICOMRETIREDTransducerOrientation (0x0008, 0x2204);
const DICOMTag DICOMRETIREDAnatomicStructure (0x0008, 0x2208);
const DICOMTag DICOMAnatomicRegionSequence (0x0008, 0x2218);
const DICOMTag DICOMAnatomicRegionModifierSequence (0x0008, 0x2220);
const DICOMTag DICOMPrimaryAnatomicStructureSequence (0x0008, 0x2228);
const DICOMTag DICOMAnatomicStructureSpaceOrRegionSequence (0x0008, 0x2229);
const DICOMTag DICOMPrimaryAnatomicStructureModifierSequence (0x0008, 0x2230);
const DICOMTag DICOMRETIREDTransducerPositionSequence (0x0008, 0x2240);
const DICOMTag DICOMRETIREDTransducerPositionModifierSequence (0x0008, 0x2242);
const DICOMTag DICOMRETIREDTransducerOrientationSequence (0x0008, 0x2244);
const DICOMTag DICOMRETIREDTransducerOrientationModifierSequence (0x0008, 0x2246);
const DICOMTag DICOMRETIREDAnatomicStructureSpaceOrRegionCodeSequenceTrial (0x0008, 0x2251);
const DICOMTag DICOMRETIREDAnatomicPortalOfEntranceCodeSequenceTrial (0x0008, 0x2253);
const DICOMTag DICOMRETIREDAnatomicApproachDirectionCodeSequenceTrial (0x0008, 0x2255);
const DICOMTag DICOMRETIREDAnatomicPerspectiveDescriptionTrial (0x0008, 0x2256);
const DICOMTag DICOMRETIREDAnatomicPerspectiveCodeSequenceTrial (0x0008, 0x2257);
const DICOMTag DICOMRETIREDAnatomicLocationOfExaminingInstrumentDescriptionTrial (0x0008, 0x2258);
const DICOMTag DICOMRETIREDAnatomicLocationOfExaminingInstrumentCodeSequenceTrial (0x0008, 0x2259);
const DICOMTag DICOMRETIREDAnatomicStructureSpaceOrRegionModifierCodeSequenceTrial (0x0008, 0x225a);
const DICOMTag DICOMRETIREDOnAxisBackgroundAnatomicStructureCodeSequenceTrial (0x0008, 0x225c);
const DICOMTag DICOMAlternateRepresentationSequence (0x0008, 0x3001);
const DICOMTag DICOMIrradiationEventUID (0x0008, 0x3010);
const DICOMTag DICOMRETIREDIdentifyingComments (0x0008, 0x4000);
const DICOMTag DICOMFrameType (0x0008, 0x9007);
const DICOMTag DICOMReferencedImageEvidenceSequence (0x0008, 0x9092);
const DICOMTag DICOMReferencedRawDataSequence (0x0008, 0x9121);
const DICOMTag DICOMCreatorVersionUID (0x0008, 0x9123);
const DICOMTag DICOMDerivationImageSequence (0x0008, 0x9124);
const DICOMTag DICOMSourceImageEvidenceSequence (0x0008, 0x9154);
const DICOMTag DICOMPixelPresentation (0x0008, 0x9205);
const DICOMTag DICOMVolumetricProperties (0x0008, 0x9206);
const DICOMTag DICOMVolumeBasedCalculationTechnique (0x0008, 0x9207);
const DICOMTag DICOMComplexImageComponent (0x0008, 0x9208);
const DICOMTag DICOMAcquisitionContrast (0x0008, 0x9209);
const DICOMTag DICOMDerivationCodeSequence (0x0008, 0x9215);
const DICOMTag DICOMReferencedPresentationStateSequence (0x0008, 0x9237);
const DICOMTag DICOMReferencedOtherPlaneSequence (0x0008, 0x9410);
const DICOMTag DICOMFrameDisplaySequence (0x0008, 0x9458);
const DICOMTag DICOMRecommendedDisplayFrameRateInFloat (0x0008, 0x9459);
const DICOMTag DICOMSkipFrameRangeFlag (0x0008, 0x9460);
const DICOMTag DICOMPatientName (0x0010, 0x0010);
const DICOMTag DICOMPatientID (0x0010, 0x0020);
const DICOMTag DICOMIssuerOfPatientID (0x0010, 0x0021);
const DICOMTag DICOMTypeOfPatientID (0x0010, 0x0022);
const DICOMTag DICOMIssuerOfPatientIDQualifiersSequence (0x0010, 0x0024);
const DICOMTag DICOMPatientBirthDate (0x0010, 0x0030);
const DICOMTag DICOMPatientBirthTime (0x0010, 0x0032);
const DICOMTag DICOMPatientSex (0x0010, 0x0040);
const DICOMTag DICOMPatientInsurancePlanCodeSequence (0x0010, 0x0050);
const DICOMTag DICOMPatientPrimaryLanguageCodeSequence (0x0010, 0x0101);
const DICOMTag DICOMPatientPrimaryLanguageModifierCodeSequence (0x0010, 0x0102);
const DICOMTag DICOMQualityControlSubject (0x0010, 0x0200);
const DICOMTag DICOMOtherPatientIDs (0x0010, 0x1000);
const DICOMTag DICOMOtherPatientNames (0x0010, 0x1001);
const DICOMTag DICOMOtherPatientIDsSequence (0x0010, 0x1002);
const DICOMTag DICOMPatientBirthName (0x0010, 0x1005);
const DICOMTag DICOMPatientAge (0x0010, 0x1010);
const DICOMTag DICOMPatientSize (0x0010, 0x1020);
const DICOMTag DICOMPatientSizeCodeSequence (0x0010, 0x1021);
const DICOMTag DICOMPatientWeight (0x0010, 0x1030);
const DICOMTag DICOMPatientAddress (0x0010, 0x1040);
const DICOMTag DICOMRETIREDInsurancePlanIdentification (0x0010, 0x1050);
const DICOMTag DICOMPatientMotherBirthName (0x0010, 0x1060);
const DICOMTag DICOMMilitaryRank (0x0010, 0x1080);
const DICOMTag DICOMBranchOfService (0x0010, 0x1081);
const DICOMTag DICOMMedicalRecordLocator (0x0010, 0x1090);
const DICOMTag DICOMMedicalAlerts (0x0010, 0x2000);
const DICOMTag DICOMAllergies (0x0010, 0x2110);
const DICOMTag DICOMCountryOfResidence (0x0010, 0x2150);
const DICOMTag DICOMRegionOfResidence (0x0010, 0x2152);
const DICOMTag DICOMPatientTelephoneNumbers (0x0010, 0x2154);
const DICOMTag DICOMEthnicGroup (0x0010, 0x2160);
const DICOMTag DICOMOccupation (0x0010, 0x2180);
const DICOMTag DICOMSmokingStatus (0x0010, 0x21a0);
const DICOMTag DICOMAdditionalPatientHistory (0x0010, 0x21b0);
const DICOMTag DICOMPregnancyStatus (0x0010, 0x21c0);
const DICOMTag DICOMLastMenstrualDate (0x0010, 0x21d0);
const DICOMTag DICOMPatientReligiousPreference (0x0010, 0x21f0);
const DICOMTag DICOMPatientSpeciesDescription (0x0010, 0x2201);
const DICOMTag DICOMPatientSpeciesCodeSequence (0x0010, 0x2202);
const DICOMTag DICOMPatientSexNeutered (0x0010, 0x2203);
const DICOMTag DICOMAnatomicalOrientationType (0x0010, 0x2210);
const DICOMTag DICOMPatientBreedDescription (0x0010, 0x2292);
const DICOMTag DICOMPatientBreedCodeSequence (0x0010, 0x2293);
const DICOMTag DICOMBreedRegistrationSequence (0x0010, 0x2294);
const DICOMTag DICOMBreedRegistrationNumber (0x0010, 0x2295);
const DICOMTag DICOMBreedRegistryCodeSequence (0x0010, 0x2296);
const DICOMTag DICOMResponsiblePerson (0x0010, 0x2297);
const DICOMTag DICOMResponsiblePersonRole (0x0010, 0x2298);
const DICOMTag DICOMResponsibleOrganization (0x0010, 0x2299);
const DICOMTag DICOMPatientComments (0x0010, 0x4000);
const DICOMTag DICOMExaminedBodyThickness (0x0010, 0x9431);
const DICOMTag DICOMClinicalTrialSponsorName (0x0012, 0x0010);
const DICOMTag DICOMClinicalTrialProtocolID (0x0012, 0x0020);
const DICOMTag DICOMClinicalTrialProtocolName (0x0012, 0x0021);
const DICOMTag DICOMClinicalTrialSiteID (0x0012, 0x0030);
const DICOMTag DICOMClinicalTrialSiteName (0x0012, 0x0031);
const DICOMTag DICOMClinicalTrialSubjectID (0x0012, 0x0040);
const DICOMTag DICOMClinicalTrialSubjectReadingID (0x0012, 0x0042);
const DICOMTag DICOMClinicalTrialTimePointID (0x0012, 0x0050);
const DICOMTag DICOMClinicalTrialTimePointDescription (0x0012, 0x0051);
const DICOMTag DICOMClinicalTrialCoordinatingCenterName (0x0012, 0x0060);
const DICOMTag DICOMPatientIdentityRemoved (0x0012, 0x0062);
const DICOMTag DICOMDeidentificationMethod (0x0012, 0x0063);
const DICOMTag DICOMDeidentificationMethodCodeSequence (0x0012, 0x0064);
const DICOMTag DICOMClinicalTrialSeriesID (0x0012, 0x0071);
const DICOMTag DICOMClinicalTrialSeriesDescription (0x0012, 0x0072);
const DICOMTag DICOMClinicalTrialProtocolEthicsCommitteeName (0x0012, 0x0081);
const DICOMTag DICOMClinicalTrialProtocolEthicsCommitteeApprovalNumber (0x0012, 0x0082);
const DICOMTag DICOMConsentForClinicalTrialUseSequence (0x0012, 0x0083);
const DICOMTag DICOMDistributionType (0x0012, 0x0084);
const DICOMTag DICOMConsentForDistributionFlag (0x0012, 0x0085);
const DICOMTag DICOMCADFileFormat (0x0014, 0x0023);
const DICOMTag DICOMComponentReferenceSystem (0x0014, 0x0024);
const DICOMTag DICOMComponentManufacturingProcedure (0x0014, 0x0025);
const DICOMTag DICOMComponentManufacturer (0x0014, 0x0028);
const DICOMTag DICOMMaterialThickness (0x0014, 0x0030);
const DICOMTag DICOMMaterialPipeDiameter (0x0014, 0x0032);
const DICOMTag DICOMMaterialIsolationDiameter (0x0014, 0x0034);
const DICOMTag DICOMMaterialGrade (0x0014, 0x0042);
const DICOMTag DICOMMaterialPropertiesFileID (0x0014, 0x0044);
const DICOMTag DICOMMaterialPropertiesFileFormat (0x0014, 0x0045);
const DICOMTag DICOMMaterialNotes (0x0014, 0x0046);
const DICOMTag DICOMComponentShape (0x0014, 0x0050);
const DICOMTag DICOMCurvatureType (0x0014, 0x0052);
const DICOMTag DICOMOuterDiameter (0x0014, 0x0054);
const DICOMTag DICOMInnerDiameter (0x0014, 0x0056);
const DICOMTag DICOMActualEnvironmentalConditions (0x0014, 0x1010);
const DICOMTag DICOMExpiryDate (0x0014, 0x1020);
const DICOMTag DICOMEnvironmentalConditions (0x0014, 0x1040);
const DICOMTag DICOMEvaluatorSequence (0x0014, 0x2002);
const DICOMTag DICOMEvaluatorNumber (0x0014, 0x2004);
const DICOMTag DICOMEvaluatorName (0x0014, 0x2006);
const DICOMTag DICOMEvaluationAttempt (0x0014, 0x2008);
const DICOMTag DICOMIndicationSequence (0x0014, 0x2012);
const DICOMTag DICOMIndicationNumber (0x0014, 0x2014);
const DICOMTag DICOMIndicationLabel (0x0014, 0x2016);
const DICOMTag DICOMIndicationDescription (0x0014, 0x2018);
const DICOMTag DICOMIndicationType (0x0014, 0x201a);
const DICOMTag DICOMIndicationDisposition (0x0014, 0x201c);
const DICOMTag DICOMIndicationROISequence (0x0014, 0x201e);
const DICOMTag DICOMIndicationPhysicalPropertySequence (0x0014, 0x2030);
const DICOMTag DICOMPropertyLabel (0x0014, 0x2032);
const DICOMTag DICOMCoordinateSystemNumberOfAxes (0x0014, 0x2202);
const DICOMTag DICOMCoordinateSystemAxesSequence (0x0014, 0x2204);
const DICOMTag DICOMCoordinateSystemAxisDescription (0x0014, 0x2206);
const DICOMTag DICOMCoordinateSystemDataSetMapping (0x0014, 0x2208);
const DICOMTag DICOMCoordinateSystemAxisNumber (0x0014, 0x220a);
const DICOMTag DICOMCoordinateSystemAxisType (0x0014, 0x220c);
const DICOMTag DICOMCoordinateSystemAxisUnits (0x0014, 0x220e);
const DICOMTag DICOMCoordinateSystemAxisValues (0x0014, 0x2210);
const DICOMTag DICOMCoordinateSystemTransformSequence (0x0014, 0x2220);
const DICOMTag DICOMTransformDescription (0x0014, 0x2222);
const DICOMTag DICOMTransformNumberOfAxes (0x0014, 0x2224);
const DICOMTag DICOMTransformOrderOfAxes (0x0014, 0x2226);
const DICOMTag DICOMTransformedAxisUnits (0x0014, 0x2228);
const DICOMTag DICOMCoordinateSystemTransformRotationAndScaleMatrix (0x0014, 0x222a);
const DICOMTag DICOMCoordinateSystemTransformTranslationMatrix (0x0014, 0x222c);
const DICOMTag DICOMInternalDetectorFrameTime (0x0014, 0x3011);
const DICOMTag DICOMNumberOfFramesIntegrated (0x0014, 0x3012);
const DICOMTag DICOMDetectorTemperatureSequence (0x0014, 0x3020);
const DICOMTag DICOMSensorName (0x0014, 0x3022);
const DICOMTag DICOMHorizontalOffsetOfSensor (0x0014, 0x3024);
const DICOMTag DICOMVerticalOffsetOfSensor (0x0014, 0x3026);
const DICOMTag DICOMSensorTemperature (0x0014, 0x3028);
const DICOMTag DICOMDarkCurrentSequence (0x0014, 0x3040);
const DICOMTag DICOMDarkCurrentCounts (0x0014, 0x3050);
const DICOMTag DICOMGainCorrectionReferenceSequence (0x0014, 0x3060);
const DICOMTag DICOMAirCounts (0x0014, 0x3070);
const DICOMTag DICOMKVUsedInGainCalibration (0x0014, 0x3071);
const DICOMTag DICOMMAUsedInGainCalibration (0x0014, 0x3072);
const DICOMTag DICOMNumberOfFramesUsedForIntegration (0x0014, 0x3073);
const DICOMTag DICOMFilterMaterialUsedInGainCalibration (0x0014, 0x3074);
const DICOMTag DICOMFilterThicknessUsedInGainCalibration (0x0014, 0x3075);
const DICOMTag DICOMDateOfGainCalibration (0x0014, 0x3076);
const DICOMTag DICOMTimeOfGainCalibration (0x0014, 0x3077);
const DICOMTag DICOMBadPixelImage (0x0014, 0x3080);
const DICOMTag DICOMCalibrationNotes (0x0014, 0x3099);
const DICOMTag DICOMPulserEquipmentSequence (0x0014, 0x4002);
const DICOMTag DICOMPulserType (0x0014, 0x4004);
const DICOMTag DICOMPulserNotes (0x0014, 0x4006);
const DICOMTag DICOMReceiverEquipmentSequence (0x0014, 0x4008);
const DICOMTag DICOMAmplifierType (0x0014, 0x400a);
const DICOMTag DICOMReceiverNotes (0x0014, 0x400c);
const DICOMTag DICOMPreAmplifierEquipmentSequence (0x0014, 0x400e);
const DICOMTag DICOMPreAmplifierNotes (0x0014, 0x400f);
const DICOMTag DICOMTransmitTransducerSequence (0x0014, 0x4010);
const DICOMTag DICOMReceiveTransducerSequence (0x0014, 0x4011);
const DICOMTag DICOMNumberOfElements (0x0014, 0x4012);
const DICOMTag DICOMElementShape (0x0014, 0x4013);
const DICOMTag DICOMElementDimensionA (0x0014, 0x4014);
const DICOMTag DICOMElementDimensionB (0x0014, 0x4015);
const DICOMTag DICOMElementPitch (0x0014, 0x4016);
const DICOMTag DICOMMeasuredBeamDimensionA (0x0014, 0x4017);
const DICOMTag DICOMMeasuredBeamDimensionB (0x0014, 0x4018);
const DICOMTag DICOMLocationOfMeasuredBeamDiameter (0x0014, 0x4019);
const DICOMTag DICOMNominalFrequency (0x0014, 0x401a);
const DICOMTag DICOMMeasuredCenterFrequency (0x0014, 0x401b);
const DICOMTag DICOMMeasuredBandwidth (0x0014, 0x401c);
const DICOMTag DICOMPulserSettingsSequence (0x0014, 0x4020);
const DICOMTag DICOMPulseWidth (0x0014, 0x4022);
const DICOMTag DICOMExcitationFrequency (0x0014, 0x4024);
const DICOMTag DICOMModulationType (0x0014, 0x4026);
const DICOMTag DICOMDamping (0x0014, 0x4028);
const DICOMTag DICOMReceiverSettingsSequence (0x0014, 0x4030);
const DICOMTag DICOMAcquiredSoundpathLength (0x0014, 0x4031);
const DICOMTag DICOMAcquisitionCompressionType (0x0014, 0x4032);
const DICOMTag DICOMAcquisitionSampleSize (0x0014, 0x4033);
const DICOMTag DICOMRectifierSmoothing (0x0014, 0x4034);
const DICOMTag DICOMDACSequence (0x0014, 0x4035);
const DICOMTag DICOMDACType (0x0014, 0x4036);
const DICOMTag DICOMDACGainPoints (0x0014, 0x4038);
const DICOMTag DICOMDACTimePoints (0x0014, 0x403a);
const DICOMTag DICOMDACAmplitude (0x0014, 0x403c);
const DICOMTag DICOMPreAmplifierSettingsSequence (0x0014, 0x4040);
const DICOMTag DICOMTransmitTransducerSettingsSequence (0x0014, 0x4050);
const DICOMTag DICOMReceiveTransducerSettingsSequence (0x0014, 0x4051);
const DICOMTag DICOMIncidentAngle (0x0014, 0x4052);
const DICOMTag DICOMCouplingTechnique (0x0014, 0x4054);
const DICOMTag DICOMCouplingMedium (0x0014, 0x4056);
const DICOMTag DICOMCouplingVelocity (0x0014, 0x4057);
const DICOMTag DICOMCrystalCenterLocationX (0x0014, 0x4058);
const DICOMTag DICOMCrystalCenterLocationZ (0x0014, 0x4059);
const DICOMTag DICOMSoundPathLength (0x0014, 0x405a);
const DICOMTag DICOMDelayLawIdentifier (0x0014, 0x405c);
const DICOMTag DICOMGateSettingsSequence (0x0014, 0x4060);
const DICOMTag DICOMGateThreshold (0x0014, 0x4062);
const DICOMTag DICOMVelocityOfSound (0x0014, 0x4064);
const DICOMTag DICOMCalibrationSettingsSequence (0x0014, 0x4070);
const DICOMTag DICOMCalibrationProcedure (0x0014, 0x4072);
const DICOMTag DICOMProcedureVersion (0x0014, 0x4074);
const DICOMTag DICOMProcedureCreationDate (0x0014, 0x4076);
const DICOMTag DICOMProcedureExpirationDate (0x0014, 0x4078);
const DICOMTag DICOMProcedureLastModifiedDate (0x0014, 0x407a);
const DICOMTag DICOMCalibrationTime (0x0014, 0x407c);
const DICOMTag DICOMCalibrationDate (0x0014, 0x407e);
const DICOMTag DICOMLINACEnergy (0x0014, 0x5002);
const DICOMTag DICOMLINACOutput (0x0014, 0x5004);
const DICOMTag DICOMContrastBolusAgent (0x0018, 0x0010);
const DICOMTag DICOMContrastBolusAgentSequence (0x0018, 0x0012);
const DICOMTag DICOMContrastBolusAdministrationRouteSequence (0x0018, 0x0014);
const DICOMTag DICOMBodyPartExamined (0x0018, 0x0015);
const DICOMTag DICOMScanningSequence (0x0018, 0x0020);
const DICOMTag DICOMSequenceVariant (0x0018, 0x0021);
const DICOMTag DICOMScanOptions (0x0018, 0x0022);
const DICOMTag DICOMMRAcquisitionType (0x0018, 0x0023);
const DICOMTag DICOMSequenceName (0x0018, 0x0024);
const DICOMTag DICOMAngioFlag (0x0018, 0x0025);
const DICOMTag DICOMInterventionDrugInformationSequence (0x0018, 0x0026);
const DICOMTag DICOMInterventionDrugStopTime (0x0018, 0x0027);
const DICOMTag DICOMInterventionDrugDose (0x0018, 0x0028);
const DICOMTag DICOMInterventionDrugCodeSequence (0x0018, 0x0029);
const DICOMTag DICOMAdditionalDrugSequence (0x0018, 0x002a);
const DICOMTag DICOMRETIREDRadionuclide (0x0018, 0x0030);
const DICOMTag DICOMRadiopharmaceutical (0x0018, 0x0031);
const DICOMTag DICOMRETIREDEnergyWindowCenterline (0x0018, 0x0032);
const DICOMTag DICOMRETIREDEnergyWindowTotalWidth (0x0018, 0x0033);
const DICOMTag DICOMInterventionDrugName (0x0018, 0x0034);
const DICOMTag DICOMInterventionDrugStartTime (0x0018, 0x0035);
const DICOMTag DICOMInterventionSequence (0x0018, 0x0036);
const DICOMTag DICOMRETIREDTherapyType (0x0018, 0x0037);
const DICOMTag DICOMInterventionStatus (0x0018, 0x0038);
const DICOMTag DICOMRETIREDTherapyDescription (0x0018, 0x0039);
const DICOMTag DICOMInterventionDescription (0x0018, 0x003a);
const DICOMTag DICOMCineRate (0x0018, 0x0040);
const DICOMTag DICOMInitialCineRunState (0x0018, 0x0042);
const DICOMTag DICOMSliceThickness (0x0018, 0x0050);
const DICOMTag DICOMKVP (0x0018, 0x0060);
const DICOMTag DICOMCountsAccumulated (0x0018, 0x0070);
const DICOMTag DICOMAcquisitionTerminationCondition (0x0018, 0x0071);
const DICOMTag DICOMEffectiveDuration (0x0018, 0x0072);
const DICOMTag DICOMAcquisitionStartCondition (0x0018, 0x0073);
const DICOMTag DICOMAcquisitionStartConditionData (0x0018, 0x0074);
const DICOMTag DICOMAcquisitionTerminationConditionData (0x0018, 0x0075);
const DICOMTag DICOMRepetitionTime (0x0018, 0x0080);
const DICOMTag DICOMEchoTime (0x0018, 0x0081);
const DICOMTag DICOMInversionTime (0x0018, 0x0082);
const DICOMTag DICOMNumberOfAverages (0x0018, 0x0083);
const DICOMTag DICOMImagingFrequency (0x0018, 0x0084);
const DICOMTag DICOMImagedNucleus (0x0018, 0x0085);
const DICOMTag DICOMEchoNumbers (0x0018, 0x0086);
const DICOMTag DICOMMagneticFieldStrength (0x0018, 0x0087);
const DICOMTag DICOMSpacingBetweenSlices (0x0018, 0x0088);
const DICOMTag DICOMNumberOfPhaseEncodingSteps (0x0018, 0x0089);
const DICOMTag DICOMDataCollectionDiameter (0x0018, 0x0090);
const DICOMTag DICOMEchoTrainLength (0x0018, 0x0091);
const DICOMTag DICOMPercentSampling (0x0018, 0x0093);
const DICOMTag DICOMPercentPhaseFieldOfView (0x0018, 0x0094);
const DICOMTag DICOMPixelBandwidth (0x0018, 0x0095);
const DICOMTag DICOMDeviceSerialNumber (0x0018, 0x1000);
const DICOMTag DICOMDeviceUID (0x0018, 0x1002);
const DICOMTag DICOMDeviceID (0x0018, 0x1003);
const DICOMTag DICOMPlateID (0x0018, 0x1004);
const DICOMTag DICOMGeneratorID (0x0018, 0x1005);
const DICOMTag DICOMGridID (0x0018, 0x1006);
const DICOMTag DICOMCassetteID (0x0018, 0x1007);
const DICOMTag DICOMGantryID (0x0018, 0x1008);
const DICOMTag DICOMSecondaryCaptureDeviceID (0x0018, 0x1010);
const DICOMTag DICOMRETIREDHardcopyCreationDeviceID (0x0018, 0x1011);
const DICOMTag DICOMDateOfSecondaryCapture (0x0018, 0x1012);
const DICOMTag DICOMTimeOfSecondaryCapture (0x0018, 0x1014);
const DICOMTag DICOMSecondaryCaptureDeviceManufacturer (0x0018, 0x1016);
const DICOMTag DICOMRETIREDHardcopyDeviceManufacturer (0x0018, 0x1017);
const DICOMTag DICOMSecondaryCaptureDeviceManufacturerModelName (0x0018, 0x1018);
const DICOMTag DICOMSecondaryCaptureDeviceSoftwareVersions (0x0018, 0x1019);
const DICOMTag DICOMRETIREDHardcopyDeviceSoftwareVersion (0x0018, 0x101a);
const DICOMTag DICOMRETIREDHardcopyDeviceManufacturerModelName (0x0018, 0x101b);
const DICOMTag DICOMSoftwareVersions (0x0018, 0x1020);
const DICOMTag DICOMVideoImageFormatAcquired (0x0018, 0x1022);
const DICOMTag DICOMDigitalImageFormatAcquired (0x0018, 0x1023);
const DICOMTag DICOMProtocolName (0x0018, 0x1030);
const DICOMTag DICOMContrastBolusRoute (0x0018, 0x1040);
const DICOMTag DICOMContrastBolusVolume (0x0018, 0x1041);
const DICOMTag DICOMContrastBolusStartTime (0x0018, 0x1042);
const DICOMTag DICOMContrastBolusStopTime (0x0018, 0x1043);
const DICOMTag DICOMContrastBolusTotalDose (0x0018, 0x1044);
const DICOMTag DICOMSyringeCounts (0x0018, 0x1045);
const DICOMTag DICOMContrastFlowRate (0x0018, 0x1046);
const DICOMTag DICOMContrastFlowDuration (0x0018, 0x1047);
const DICOMTag DICOMContrastBolusIngredient (0x0018, 0x1048);
const DICOMTag DICOMContrastBolusIngredientConcentration (0x0018, 0x1049);
const DICOMTag DICOMSpatialResolution (0x0018, 0x1050);
const DICOMTag DICOMTriggerTime (0x0018, 0x1060);
const DICOMTag DICOMTriggerSourceOrType (0x0018, 0x1061);
const DICOMTag DICOMNominalInterval (0x0018, 0x1062);
const DICOMTag DICOMFrameTime (0x0018, 0x1063);
const DICOMTag DICOMCardiacFramingType (0x0018, 0x1064);
const DICOMTag DICOMFrameTimeVector (0x0018, 0x1065);
const DICOMTag DICOMFrameDelay (0x0018, 0x1066);
const DICOMTag DICOMImageTriggerDelay (0x0018, 0x1067);
const DICOMTag DICOMMultiplexGroupTimeOffset (0x0018, 0x1068);
const DICOMTag DICOMTriggerTimeOffset (0x0018, 0x1069);
const DICOMTag DICOMSynchronizationTrigger (0x0018, 0x106a);
const DICOMTag DICOMSynchronizationChannel (0x0018, 0x106c);
const DICOMTag DICOMTriggerSamplePosition (0x0018, 0x106e);
const DICOMTag DICOMRadiopharmaceuticalRoute (0x0018, 0x1070);
const DICOMTag DICOMRadiopharmaceuticalVolume (0x0018, 0x1071);
const DICOMTag DICOMRadiopharmaceuticalStartTime (0x0018, 0x1072);
const DICOMTag DICOMRadiopharmaceuticalStopTime (0x0018, 0x1073);
const DICOMTag DICOMRadionuclideTotalDose (0x0018, 0x1074);
const DICOMTag DICOMRadionuclideHalfLife (0x0018, 0x1075);
const DICOMTag DICOMRadionuclidePositronFraction (0x0018, 0x1076);
const DICOMTag DICOMRadiopharmaceuticalSpecificActivity (0x0018, 0x1077);
const DICOMTag DICOMRadiopharmaceuticalStartDateTime (0x0018, 0x1078);
const DICOMTag DICOMRadiopharmaceuticalStopDateTime (0x0018, 0x1079);
const DICOMTag DICOMBeatRejectionFlag (0x0018, 0x1080);
const DICOMTag DICOMLowRRValue (0x0018, 0x1081);
const DICOMTag DICOMHighRRValue (0x0018, 0x1082);
const DICOMTag DICOMIntervalsAcquired (0x0018, 0x1083);
const DICOMTag DICOMIntervalsRejected (0x0018, 0x1084);
const DICOMTag DICOMPVCRejection (0x0018, 0x1085);
const DICOMTag DICOMSkipBeats (0x0018, 0x1086);
const DICOMTag DICOMHeartRate (0x0018, 0x1088);
const DICOMTag DICOMCardiacNumberOfImages (0x0018, 0x1090);
const DICOMTag DICOMTriggerWindow (0x0018, 0x1094);
const DICOMTag DICOMReconstructionDiameter (0x0018, 0x1100);
const DICOMTag DICOMDistanceSourceToDetector (0x0018, 0x1110);
const DICOMTag DICOMDistanceSourceToPatient (0x0018, 0x1111);
const DICOMTag DICOMEstimatedRadiographicMagnificationFactor (0x0018, 0x1114);
const DICOMTag DICOMGantryDetectorTilt (0x0018, 0x1120);
const DICOMTag DICOMGantryDetectorSlew (0x0018, 0x1121);
const DICOMTag DICOMTableHeight (0x0018, 0x1130);
const DICOMTag DICOMTableTraverse (0x0018, 0x1131);
const DICOMTag DICOMTableMotion (0x0018, 0x1134);
const DICOMTag DICOMTableVerticalIncrement (0x0018, 0x1135);
const DICOMTag DICOMTableLateralIncrement (0x0018, 0x1136);
const DICOMTag DICOMTableLongitudinalIncrement (0x0018, 0x1137);
const DICOMTag DICOMTableAngle (0x0018, 0x1138);
const DICOMTag DICOMTableType (0x0018, 0x113a);
const DICOMTag DICOMRotationDirection (0x0018, 0x1140);
const DICOMTag DICOMRETIREDAngularPosition (0x0018, 0x1141);
const DICOMTag DICOMRadialPosition (0x0018, 0x1142);
const DICOMTag DICOMScanArc (0x0018, 0x1143);
const DICOMTag DICOMAngularStep (0x0018, 0x1144);
const DICOMTag DICOMCenterOfRotationOffset (0x0018, 0x1145);
const DICOMTag DICOMRETIREDRotationOffset (0x0018, 0x1146);
const DICOMTag DICOMFieldOfViewShape (0x0018, 0x1147);
const DICOMTag DICOMFieldOfViewDimensions (0x0018, 0x1149);
const DICOMTag DICOMExposureTime (0x0018, 0x1150);
const DICOMTag DICOMXRayTubeCurrent (0x0018, 0x1151);
const DICOMTag DICOMExposure (0x0018, 0x1152);
const DICOMTag DICOMExposureInuAs (0x0018, 0x1153);
const DICOMTag DICOMAveragePulseWidth (0x0018, 0x1154);
const DICOMTag DICOMRadiationSetting (0x0018, 0x1155);
const DICOMTag DICOMRectificationType (0x0018, 0x1156);
const DICOMTag DICOMRadiationMode (0x0018, 0x115a);
const DICOMTag DICOMImageAndFluoroscopyAreaDoseProduct (0x0018, 0x115e);
const DICOMTag DICOMFilterType (0x0018, 0x1160);
const DICOMTag DICOMTypeOfFilters (0x0018, 0x1161);
const DICOMTag DICOMIntensifierSize (0x0018, 0x1162);
const DICOMTag DICOMImagerPixelSpacing (0x0018, 0x1164);
const DICOMTag DICOMGrid (0x0018, 0x1166);
const DICOMTag DICOMGeneratorPower (0x0018, 0x1170);
const DICOMTag DICOMCollimatorGridName (0x0018, 0x1180);
const DICOMTag DICOMCollimatorType (0x0018, 0x1181);
const DICOMTag DICOMFocalDistance (0x0018, 0x1182);
const DICOMTag DICOMXFocusCenter (0x0018, 0x1183);
const DICOMTag DICOMYFocusCenter (0x0018, 0x1184);
const DICOMTag DICOMFocalSpots (0x0018, 0x1190);
const DICOMTag DICOMAnodeTargetMaterial (0x0018, 0x1191);
const DICOMTag DICOMBodyPartThickness (0x0018, 0x11a0);
const DICOMTag DICOMCompressionForce (0x0018, 0x11a2);
const DICOMTag DICOMDateOfLastCalibration (0x0018, 0x1200);
const DICOMTag DICOMTimeOfLastCalibration (0x0018, 0x1201);
const DICOMTag DICOMConvolutionKernel (0x0018, 0x1210);
const DICOMTag DICOMRETIREDUpperLowerPixelValues (0x0018, 0x1240);
const DICOMTag DICOMActualFrameDuration (0x0018, 0x1242);
const DICOMTag DICOMCountRate (0x0018, 0x1243);
const DICOMTag DICOMPreferredPlaybackSequencing (0x0018, 0x1244);
const DICOMTag DICOMReceiveCoilName (0x0018, 0x1250);
const DICOMTag DICOMTransmitCoilName (0x0018, 0x1251);
const DICOMTag DICOMPlateType (0x0018, 0x1260);
const DICOMTag DICOMPhosphorType (0x0018, 0x1261);
const DICOMTag DICOMScanVelocity (0x0018, 0x1300);
const DICOMTag DICOMWholeBodyTechnique (0x0018, 0x1301);
const DICOMTag DICOMScanLength (0x0018, 0x1302);
const DICOMTag DICOMAcquisitionMatrix (0x0018, 0x1310);
const DICOMTag DICOMInPlanePhaseEncodingDirection (0x0018, 0x1312);
const DICOMTag DICOMFlipAngle (0x0018, 0x1314);
const DICOMTag DICOMVariableFlipAngleFlag (0x0018, 0x1315);
const DICOMTag DICOMSAR (0x0018, 0x1316);
const DICOMTag DICOMdBdt (0x0018, 0x1318);
const DICOMTag DICOMAcquisitionDeviceProcessingDescription (0x0018, 0x1400);
const DICOMTag DICOMAcquisitionDeviceProcessingCode (0x0018, 0x1401);
const DICOMTag DICOMCassetteOrientation (0x0018, 0x1402);
const DICOMTag DICOMCassetteSize (0x0018, 0x1403);
const DICOMTag DICOMExposuresOnPlate (0x0018, 0x1404);
const DICOMTag DICOMRelativeXRayExposure (0x0018, 0x1405);
const DICOMTag DICOMExposureIndex (0x0018, 0x1411);
const DICOMTag DICOMTargetExposureIndex (0x0018, 0x1412);
const DICOMTag DICOMDeviationIndex (0x0018, 0x1413);
const DICOMTag DICOMColumnAngulation (0x0018, 0x1450);
const DICOMTag DICOMTomoLayerHeight (0x0018, 0x1460);
const DICOMTag DICOMTomoAngle (0x0018, 0x1470);
const DICOMTag DICOMTomoTime (0x0018, 0x1480);
const DICOMTag DICOMTomoType (0x0018, 0x1490);
const DICOMTag DICOMTomoClass (0x0018, 0x1491);
const DICOMTag DICOMNumberOfTomosynthesisSourceImages (0x0018, 0x1495);
const DICOMTag DICOMPositionerMotion (0x0018, 0x1500);
const DICOMTag DICOMPositionerType (0x0018, 0x1508);
const DICOMTag DICOMPositionerPrimaryAngle (0x0018, 0x1510);
const DICOMTag DICOMPositionerSecondaryAngle (0x0018, 0x1511);
const DICOMTag DICOMPositionerPrimaryAngleIncrement (0x0018, 0x1520);
const DICOMTag DICOMPositionerSecondaryAngleIncrement (0x0018, 0x1521);
const DICOMTag DICOMDetectorPrimaryAngle (0x0018, 0x1530);
const DICOMTag DICOMDetectorSecondaryAngle (0x0018, 0x1531);
const DICOMTag DICOMShutterShape (0x0018, 0x1600);
const DICOMTag DICOMShutterLeftVerticalEdge (0x0018, 0x1602);
const DICOMTag DICOMShutterRightVerticalEdge (0x0018, 0x1604);
const DICOMTag DICOMShutterUpperHorizontalEdge (0x0018, 0x1606);
const DICOMTag DICOMShutterLowerHorizontalEdge (0x0018, 0x1608);
const DICOMTag DICOMCenterOfCircularShutter (0x0018, 0x1610);
const DICOMTag DICOMRadiusOfCircularShutter (0x0018, 0x1612);
const DICOMTag DICOMVerticesOfThePolygonalShutter (0x0018, 0x1620);
const DICOMTag DICOMShutterPresentationValue (0x0018, 0x1622);
const DICOMTag DICOMShutterOverlayGroup (0x0018, 0x1623);
const DICOMTag DICOMShutterPresentationColorCIELabValue (0x0018, 0x1624);
const DICOMTag DICOMCollimatorShape (0x0018, 0x1700);
const DICOMTag DICOMCollimatorLeftVerticalEdge (0x0018, 0x1702);
const DICOMTag DICOMCollimatorRightVerticalEdge (0x0018, 0x1704);
const DICOMTag DICOMCollimatorUpperHorizontalEdge (0x0018, 0x1706);
const DICOMTag DICOMCollimatorLowerHorizontalEdge (0x0018, 0x1708);
const DICOMTag DICOMCenterOfCircularCollimator (0x0018, 0x1710);
const DICOMTag DICOMRadiusOfCircularCollimator (0x0018, 0x1712);
const DICOMTag DICOMVerticesOfThePolygonalCollimator (0x0018, 0x1720);
const DICOMTag DICOMAcquisitionTimeSynchronized (0x0018, 0x1800);
const DICOMTag DICOMTimeSource (0x0018, 0x1801);
const DICOMTag DICOMTimeDistributionProtocol (0x0018, 0x1802);
const DICOMTag DICOMNTPSourceAddress (0x0018, 0x1803);
const DICOMTag DICOMPageNumberVector (0x0018, 0x2001);
const DICOMTag DICOMFrameLabelVector (0x0018, 0x2002);
const DICOMTag DICOMFramePrimaryAngleVector (0x0018, 0x2003);
const DICOMTag DICOMFrameSecondaryAngleVector (0x0018, 0x2004);
const DICOMTag DICOMSliceLocationVector (0x0018, 0x2005);
const DICOMTag DICOMDisplayWindowLabelVector (0x0018, 0x2006);
const DICOMTag DICOMNominalScannedPixelSpacing (0x0018, 0x2010);
const DICOMTag DICOMDigitizingDeviceTransportDirection (0x0018, 0x2020);
const DICOMTag DICOMRotationOfScannedFilm (0x0018, 0x2030);
const DICOMTag DICOMIVUSAcquisition (0x0018, 0x3100);
const DICOMTag DICOMIVUSPullbackRate (0x0018, 0x3101);
const DICOMTag DICOMIVUSGatedRate (0x0018, 0x3102);
const DICOMTag DICOMIVUSPullbackStartFrameNumber (0x0018, 0x3103);
const DICOMTag DICOMIVUSPullbackStopFrameNumber (0x0018, 0x3104);
const DICOMTag DICOMLesionNumber (0x0018, 0x3105);
const DICOMTag DICOMRETIREDAcquisitionComments (0x0018, 0x4000);
const DICOMTag DICOMOutputPower (0x0018, 0x5000);
const DICOMTag DICOMTransducerData (0x0018, 0x5010);
const DICOMTag DICOMFocusDepth (0x0018, 0x5012);
const DICOMTag DICOMProcessingFunction (0x0018, 0x5020);
const DICOMTag DICOMRETIREDPostprocessingFunction (0x0018, 0x5021);
const DICOMTag DICOMMechanicalIndex (0x0018, 0x5022);
const DICOMTag DICOMBoneThermalIndex (0x0018, 0x5024);
const DICOMTag DICOMCranialThermalIndex (0x0018, 0x5026);
const DICOMTag DICOMSoftTissueThermalIndex (0x0018, 0x5027);
const DICOMTag DICOMSoftTissueFocusThermalIndex (0x0018, 0x5028);
const DICOMTag DICOMSoftTissueSurfaceThermalIndex (0x0018, 0x5029);
const DICOMTag DICOMRETIREDDynamicRange (0x0018, 0x5030);
const DICOMTag DICOMRETIREDTotalGain (0x0018, 0x5040);
const DICOMTag DICOMDepthOfScanField (0x0018, 0x5050);
const DICOMTag DICOMPatientPosition (0x0018, 0x5100);
const DICOMTag DICOMViewPosition (0x0018, 0x5101);
const DICOMTag DICOMProjectionEponymousNameCodeSequence (0x0018, 0x5104);
const DICOMTag DICOMRETIREDImageTransformationMatrix (0x0018, 0x5210);
const DICOMTag DICOMRETIREDImageTranslationVector (0x0018, 0x5212);
const DICOMTag DICOMSensitivity (0x0018, 0x6000);
const DICOMTag DICOMSequenceOfUltrasoundRegions (0x0018, 0x6011);
const DICOMTag DICOMRegionSpatialFormat (0x0018, 0x6012);
const DICOMTag DICOMRegionDataType (0x0018, 0x6014);
const DICOMTag DICOMRegionFlags (0x0018, 0x6016);
const DICOMTag DICOMRegionLocationMinX0 (0x0018, 0x6018);
const DICOMTag DICOMRegionLocationMinY0 (0x0018, 0x601a);
const DICOMTag DICOMRegionLocationMaxX1 (0x0018, 0x601c);
const DICOMTag DICOMRegionLocationMaxY1 (0x0018, 0x601e);
const DICOMTag DICOMReferencePixelX0 (0x0018, 0x6020);
const DICOMTag DICOMReferencePixelY0 (0x0018, 0x6022);
const DICOMTag DICOMPhysicalUnitsXDirection (0x0018, 0x6024);
const DICOMTag DICOMPhysicalUnitsYDirection (0x0018, 0x6026);
const DICOMTag DICOMReferencePixelPhysicalValueX (0x0018, 0x6028);
const DICOMTag DICOMReferencePixelPhysicalValueY (0x0018, 0x602a);
const DICOMTag DICOMPhysicalDeltaX (0x0018, 0x602c);
const DICOMTag DICOMPhysicalDeltaY (0x0018, 0x602e);
const DICOMTag DICOMTransducerFrequency (0x0018, 0x6030);
const DICOMTag DICOMTransducerType (0x0018, 0x6031);
const DICOMTag DICOMPulseRepetitionFrequency (0x0018, 0x6032);
const DICOMTag DICOMDopplerCorrectionAngle (0x0018, 0x6034);
const DICOMTag DICOMSteeringAngle (0x0018, 0x6036);
const DICOMTag DICOMRETIREDDopplerSampleVolumeXPositionRetired (0x0018, 0x6038);
const DICOMTag DICOMDopplerSampleVolumeXPosition (0x0018, 0x6039);
const DICOMTag DICOMRETIREDDopplerSampleVolumeYPositionRetired (0x0018, 0x603a);
const DICOMTag DICOMDopplerSampleVolumeYPosition (0x0018, 0x603b);
const DICOMTag DICOMRETIREDTMLinePositionX0Retired (0x0018, 0x603c);
const DICOMTag DICOMTMLinePositionX0 (0x0018, 0x603d);
const DICOMTag DICOMRETIREDTMLinePositionY0Retired (0x0018, 0x603e);
const DICOMTag DICOMTMLinePositionY0 (0x0018, 0x603f);
const DICOMTag DICOMRETIREDTMLinePositionX1Retired (0x0018, 0x6040);
const DICOMTag DICOMTMLinePositionX1 (0x0018, 0x6041);
const DICOMTag DICOMRETIREDTMLinePositionY1Retired (0x0018, 0x6042);
const DICOMTag DICOMTMLinePositionY1 (0x0018, 0x6043);
const DICOMTag DICOMPixelComponentOrganization (0x0018, 0x6044);
const DICOMTag DICOMPixelComponentMask (0x0018, 0x6046);
const DICOMTag DICOMPixelComponentRangeStart (0x0018, 0x6048);
const DICOMTag DICOMPixelComponentRangeStop (0x0018, 0x604a);
const DICOMTag DICOMPixelComponentPhysicalUnits (0x0018, 0x604c);
const DICOMTag DICOMPixelComponentDataType (0x0018, 0x604e);
const DICOMTag DICOMNumberOfTableBreakPoints (0x0018, 0x6050);
const DICOMTag DICOMTableOfXBreakPoints (0x0018, 0x6052);
const DICOMTag DICOMTableOfYBreakPoints (0x0018, 0x6054);
const DICOMTag DICOMNumberOfTableEntries (0x0018, 0x6056);
const DICOMTag DICOMTableOfPixelValues (0x0018, 0x6058);
const DICOMTag DICOMTableOfParameterValues (0x0018, 0x605a);
const DICOMTag DICOMRWaveTimeVector (0x0018, 0x6060);
const DICOMTag DICOMDetectorConditionsNominalFlag (0x0018, 0x7000);
const DICOMTag DICOMDetectorTemperature (0x0018, 0x7001);
const DICOMTag DICOMDetectorType (0x0018, 0x7004);
const DICOMTag DICOMDetectorConfiguration (0x0018, 0x7005);
const DICOMTag DICOMDetectorDescription (0x0018, 0x7006);
const DICOMTag DICOMDetectorMode (0x0018, 0x7008);
const DICOMTag DICOMDetectorID (0x0018, 0x700a);
const DICOMTag DICOMDateOfLastDetectorCalibration (0x0018, 0x700c);
const DICOMTag DICOMTimeOfLastDetectorCalibration (0x0018, 0x700e);
const DICOMTag DICOMExposuresOnDetectorSinceLastCalibration (0x0018, 0x7010);
const DICOMTag DICOMExposuresOnDetectorSinceManufactured (0x0018, 0x7011);
const DICOMTag DICOMDetectorTimeSinceLastExposure (0x0018, 0x7012);
const DICOMTag DICOMDetectorActiveTime (0x0018, 0x7014);
const DICOMTag DICOMDetectorActivationOffsetFromExposure (0x0018, 0x7016);
const DICOMTag DICOMDetectorBinning (0x0018, 0x701a);
const DICOMTag DICOMDetectorElementPhysicalSize (0x0018, 0x7020);
const DICOMTag DICOMDetectorElementSpacing (0x0018, 0x7022);
const DICOMTag DICOMDetectorActiveShape (0x0018, 0x7024);
const DICOMTag DICOMDetectorActiveDimensions (0x0018, 0x7026);
const DICOMTag DICOMDetectorActiveOrigin (0x0018, 0x7028);
const DICOMTag DICOMDetectorManufacturerName (0x0018, 0x702a);
const DICOMTag DICOMDetectorManufacturerModelName (0x0018, 0x702b);
const DICOMTag DICOMFieldOfViewOrigin (0x0018, 0x7030);
const DICOMTag DICOMFieldOfViewRotation (0x0018, 0x7032);
const DICOMTag DICOMFieldOfViewHorizontalFlip (0x0018, 0x7034);
const DICOMTag DICOMPixelDataAreaOriginRelativeToFOV (0x0018, 0x7036);
const DICOMTag DICOMPixelDataAreaRotationAngleRelativeToFOV (0x0018, 0x7038);
const DICOMTag DICOMGridAbsorbingMaterial (0x0018, 0x7040);
const DICOMTag DICOMGridSpacingMaterial (0x0018, 0x7041);
const DICOMTag DICOMGridThickness (0x0018, 0x7042);
const DICOMTag DICOMGridPitch (0x0018, 0x7044);
const DICOMTag DICOMGridAspectRatio (0x0018, 0x7046);
const DICOMTag DICOMGridPeriod (0x0018, 0x7048);
const DICOMTag DICOMGridFocalDistance (0x0018, 0x704c);
const DICOMTag DICOMFilterMaterial (0x0018, 0x7050);
const DICOMTag DICOMFilterThicknessMinimum (0x0018, 0x7052);
const DICOMTag DICOMFilterThicknessMaximum (0x0018, 0x7054);
const DICOMTag DICOMFilterBeamPathLengthMinimum (0x0018, 0x7056);
const DICOMTag DICOMFilterBeamPathLengthMaximum (0x0018, 0x7058);
const DICOMTag DICOMExposureControlMode (0x0018, 0x7060);
const DICOMTag DICOMExposureControlModeDescription (0x0018, 0x7062);
const DICOMTag DICOMExposureStatus (0x0018, 0x7064);
const DICOMTag DICOMPhototimerSetting (0x0018, 0x7065);
const DICOMTag DICOMExposureTimeInuS (0x0018, 0x8150);
const DICOMTag DICOMXRayTubeCurrentInuA (0x0018, 0x8151);
const DICOMTag DICOMContentQualification (0x0018, 0x9004);
const DICOMTag DICOMPulseSequenceName (0x0018, 0x9005);
const DICOMTag DICOMMRImagingModifierSequence (0x0018, 0x9006);
const DICOMTag DICOMEchoPulseSequence (0x0018, 0x9008);
const DICOMTag DICOMInversionRecovery (0x0018, 0x9009);
const DICOMTag DICOMFlowCompensation (0x0018, 0x9010);
const DICOMTag DICOMMultipleSpinEcho (0x0018, 0x9011);
const DICOMTag DICOMMultiPlanarExcitation (0x0018, 0x9012);
const DICOMTag DICOMPhaseContrast (0x0018, 0x9014);
const DICOMTag DICOMTimeOfFlightContrast (0x0018, 0x9015);
const DICOMTag DICOMSpoiling (0x0018, 0x9016);
const DICOMTag DICOMSteadyStatePulseSequence (0x0018, 0x9017);
const DICOMTag DICOMEchoPlanarPulseSequence (0x0018, 0x9018);
const DICOMTag DICOMTagAngleFirstAxis (0x0018, 0x9019);
const DICOMTag DICOMMagnetizationTransfer (0x0018, 0x9020);
const DICOMTag DICOMT2Preparation (0x0018, 0x9021);
const DICOMTag DICOMBloodSignalNulling (0x0018, 0x9022);
const DICOMTag DICOMSaturationRecovery (0x0018, 0x9024);
const DICOMTag DICOMSpectrallySelectedSuppression (0x0018, 0x9025);
const DICOMTag DICOMSpectrallySelectedExcitation (0x0018, 0x9026);
const DICOMTag DICOMSpatialPresaturation (0x0018, 0x9027);
const DICOMTag DICOMTagging (0x0018, 0x9028);
const DICOMTag DICOMOversamplingPhase (0x0018, 0x9029);
const DICOMTag DICOMTagSpacingFirstDimension (0x0018, 0x9030);
const DICOMTag DICOMGeometryOfKSpaceTraversal (0x0018, 0x9032);
const DICOMTag DICOMSegmentedKSpaceTraversal (0x0018, 0x9033);
const DICOMTag DICOMRectilinearPhaseEncodeReordering (0x0018, 0x9034);
const DICOMTag DICOMTagThickness (0x0018, 0x9035);
const DICOMTag DICOMPartialFourierDirection (0x0018, 0x9036);
const DICOMTag DICOMCardiacSynchronizationTechnique (0x0018, 0x9037);
const DICOMTag DICOMReceiveCoilManufacturerName (0x0018, 0x9041);
const DICOMTag DICOMMRReceiveCoilSequence (0x0018, 0x9042);
const DICOMTag DICOMReceiveCoilType (0x0018, 0x9043);
const DICOMTag DICOMQuadratureReceiveCoil (0x0018, 0x9044);
const DICOMTag DICOMMultiCoilDefinitionSequence (0x0018, 0x9045);
const DICOMTag DICOMMultiCoilConfiguration (0x0018, 0x9046);
const DICOMTag DICOMMultiCoilElementName (0x0018, 0x9047);
const DICOMTag DICOMMultiCoilElementUsed (0x0018, 0x9048);
const DICOMTag DICOMMRTransmitCoilSequence (0x0018, 0x9049);
const DICOMTag DICOMTransmitCoilManufacturerName (0x0018, 0x9050);
const DICOMTag DICOMTransmitCoilType (0x0018, 0x9051);
const DICOMTag DICOMSpectralWidth (0x0018, 0x9052);
const DICOMTag DICOMChemicalShiftReference (0x0018, 0x9053);
const DICOMTag DICOMVolumeLocalizationTechnique (0x0018, 0x9054);
const DICOMTag DICOMMRAcquisitionFrequencyEncodingSteps (0x0018, 0x9058);
const DICOMTag DICOMDecoupling (0x0018, 0x9059);
const DICOMTag DICOMDecoupledNucleus (0x0018, 0x9060);
const DICOMTag DICOMDecouplingFrequency (0x0018, 0x9061);
const DICOMTag DICOMDecouplingMethod (0x0018, 0x9062);
const DICOMTag DICOMDecouplingChemicalShiftReference (0x0018, 0x9063);
const DICOMTag DICOMKSpaceFiltering (0x0018, 0x9064);
const DICOMTag DICOMTimeDomainFiltering (0x0018, 0x9065);
const DICOMTag DICOMNumberOfZeroFills (0x0018, 0x9066);
const DICOMTag DICOMBaselineCorrection (0x0018, 0x9067);
const DICOMTag DICOMParallelReductionFactorInPlane (0x0018, 0x9069);
const DICOMTag DICOMCardiacRRIntervalSpecified (0x0018, 0x9070);
const DICOMTag DICOMAcquisitionDuration (0x0018, 0x9073);
const DICOMTag DICOMFrameAcquisitionDateTime (0x0018, 0x9074);
const DICOMTag DICOMDiffusionDirectionality (0x0018, 0x9075);
const DICOMTag DICOMDiffusionGradientDirectionSequence (0x0018, 0x9076);
const DICOMTag DICOMParallelAcquisition (0x0018, 0x9077);
const DICOMTag DICOMParallelAcquisitionTechnique (0x0018, 0x9078);
const DICOMTag DICOMInversionTimes (0x0018, 0x9079);
const DICOMTag DICOMMetaboliteMapDescription (0x0018, 0x9080);
const DICOMTag DICOMPartialFourier (0x0018, 0x9081);
const DICOMTag DICOMEffectiveEchoTime (0x0018, 0x9082);
const DICOMTag DICOMMetaboliteMapCodeSequence (0x0018, 0x9083);
const DICOMTag DICOMChemicalShiftSequence (0x0018, 0x9084);
const DICOMTag DICOMCardiacSignalSource (0x0018, 0x9085);
const DICOMTag DICOMDiffusionBValue (0x0018, 0x9087);
const DICOMTag DICOMDiffusionGradientOrientation (0x0018, 0x9089);
const DICOMTag DICOMVelocityEncodingDirection (0x0018, 0x9090);
const DICOMTag DICOMVelocityEncodingMinimumValue (0x0018, 0x9091);
const DICOMTag DICOMVelocityEncodingAcquisitionSequence (0x0018, 0x9092);
const DICOMTag DICOMNumberOfKSpaceTrajectories (0x0018, 0x9093);
const DICOMTag DICOMCoverageOfKSpace (0x0018, 0x9094);
const DICOMTag DICOMSpectroscopyAcquisitionPhaseRows (0x0018, 0x9095);
const DICOMTag DICOMRETIREDParallelReductionFactorInPlaneRetired (0x0018, 0x9096);
const DICOMTag DICOMTransmitterFrequency (0x0018, 0x9098);
const DICOMTag DICOMResonantNucleus (0x0018, 0x9100);
const DICOMTag DICOMFrequencyCorrection (0x0018, 0x9101);
const DICOMTag DICOMMRSpectroscopyFOVGeometrySequence (0x0018, 0x9103);
const DICOMTag DICOMSlabThickness (0x0018, 0x9104);
const DICOMTag DICOMSlabOrientation (0x0018, 0x9105);
const DICOMTag DICOMMidSlabPosition (0x0018, 0x9106);
const DICOMTag DICOMMRSpatialSaturationSequence (0x0018, 0x9107);
const DICOMTag DICOMMRTimingAndRelatedParametersSequence (0x0018, 0x9112);
const DICOMTag DICOMMREchoSequence (0x0018, 0x9114);
const DICOMTag DICOMMRModifierSequence (0x0018, 0x9115);
const DICOMTag DICOMMRDiffusionSequence (0x0018, 0x9117);
const DICOMTag DICOMCardiacSynchronizationSequence (0x0018, 0x9118);
const DICOMTag DICOMMRAveragesSequence (0x0018, 0x9119);
const DICOMTag DICOMMRFOVGeometrySequence (0x0018, 0x9125);
const DICOMTag DICOMVolumeLocalizationSequence (0x0018, 0x9126);
const DICOMTag DICOMSpectroscopyAcquisitionDataColumns (0x0018, 0x9127);
const DICOMTag DICOMDiffusionAnisotropyType (0x0018, 0x9147);
const DICOMTag DICOMFrameReferenceDateTime (0x0018, 0x9151);
const DICOMTag DICOMMRMetaboliteMapSequence (0x0018, 0x9152);
const DICOMTag DICOMParallelReductionFactorOutOfPlane (0x0018, 0x9155);
const DICOMTag DICOMSpectroscopyAcquisitionOutOfPlanePhaseSteps (0x0018, 0x9159);
const DICOMTag DICOMRETIREDBulkMotionStatus (0x0018, 0x9166);
const DICOMTag DICOMParallelReductionFactorSecondInPlane (0x0018, 0x9168);
const DICOMTag DICOMCardiacBeatRejectionTechnique (0x0018, 0x9169);
const DICOMTag DICOMRespiratoryMotionCompensationTechnique (0x0018, 0x9170);
const DICOMTag DICOMRespiratorySignalSource (0x0018, 0x9171);
const DICOMTag DICOMBulkMotionCompensationTechnique (0x0018, 0x9172);
const DICOMTag DICOMBulkMotionSignalSource (0x0018, 0x9173);
const DICOMTag DICOMApplicableSafetyStandardAgency (0x0018, 0x9174);
const DICOMTag DICOMApplicableSafetyStandardDescription (0x0018, 0x9175);
const DICOMTag DICOMOperatingModeSequence (0x0018, 0x9176);
const DICOMTag DICOMOperatingModeType (0x0018, 0x9177);
const DICOMTag DICOMOperatingMode (0x0018, 0x9178);
const DICOMTag DICOMSpecificAbsorptionRateDefinition (0x0018, 0x9179);
const DICOMTag DICOMGradientOutputType (0x0018, 0x9180);
const DICOMTag DICOMSpecificAbsorptionRateValue (0x0018, 0x9181);
const DICOMTag DICOMGradientOutput (0x0018, 0x9182);
const DICOMTag DICOMFlowCompensationDirection (0x0018, 0x9183);
const DICOMTag DICOMTaggingDelay (0x0018, 0x9184);
const DICOMTag DICOMRespiratoryMotionCompensationTechniqueDescription (0x0018, 0x9185);
const DICOMTag DICOMRespiratorySignalSourceID (0x0018, 0x9186);
const DICOMTag DICOMRETIREDChemicalShiftMinimumIntegrationLimitInHz (0x0018, 0x9195);
const DICOMTag DICOMRETIREDChemicalShiftMaximumIntegrationLimitInHz (0x0018, 0x9196);
const DICOMTag DICOMMRVelocityEncodingSequence (0x0018, 0x9197);
const DICOMTag DICOMFirstOrderPhaseCorrection (0x0018, 0x9198);
const DICOMTag DICOMWaterReferencedPhaseCorrection (0x0018, 0x9199);
const DICOMTag DICOMMRSpectroscopyAcquisitionType (0x0018, 0x9200);
const DICOMTag DICOMRespiratoryCyclePosition (0x0018, 0x9214);
const DICOMTag DICOMVelocityEncodingMaximumValue (0x0018, 0x9217);
const DICOMTag DICOMTagSpacingSecondDimension (0x0018, 0x9218);
const DICOMTag DICOMTagAngleSecondAxis (0x0018, 0x9219);
const DICOMTag DICOMFrameAcquisitionDuration (0x0018, 0x9220);
const DICOMTag DICOMMRImageFrameTypeSequence (0x0018, 0x9226);
const DICOMTag DICOMMRSpectroscopyFrameTypeSequence (0x0018, 0x9227);
const DICOMTag DICOMMRAcquisitionPhaseEncodingStepsInPlane (0x0018, 0x9231);
const DICOMTag DICOMMRAcquisitionPhaseEncodingStepsOutOfPlane (0x0018, 0x9232);
const DICOMTag DICOMSpectroscopyAcquisitionPhaseColumns (0x0018, 0x9234);
const DICOMTag DICOMCardiacCyclePosition (0x0018, 0x9236);
const DICOMTag DICOMSpecificAbsorptionRateSequence (0x0018, 0x9239);
const DICOMTag DICOMRFEchoTrainLength (0x0018, 0x9240);
const DICOMTag DICOMGradientEchoTrainLength (0x0018, 0x9241);
const DICOMTag DICOMArterialSpinLabelingContrast (0x0018, 0x9250);
const DICOMTag DICOMMRArterialSpinLabelingSequence (0x0018, 0x9251);
const DICOMTag DICOMASLTechniqueDescription (0x0018, 0x9252);
const DICOMTag DICOMASLSlabNumber (0x0018, 0x9253);
const DICOMTag DICOMASLSlabThickness (0x0018, 0x9254);
const DICOMTag DICOMASLSlabOrientation (0x0018, 0x9255);
const DICOMTag DICOMASLMidSlabPosition (0x0018, 0x9256);
const DICOMTag DICOMASLContext (0x0018, 0x9257);
const DICOMTag DICOMASLPulseTrainDuration (0x0018, 0x9258);
const DICOMTag DICOMASLCrusherFlag (0x0018, 0x9259);
const DICOMTag DICOMASLCrusherFlow (0x0018, 0x925a);
const DICOMTag DICOMASLCrusherDescription (0x0018, 0x925b);
const DICOMTag DICOMASLBolusCutoffFlag (0x0018, 0x925c);
const DICOMTag DICOMASLBolusCutoffTimingSequence (0x0018, 0x925d);
const DICOMTag DICOMASLBolusCutoffTechnique (0x0018, 0x925e);
const DICOMTag DICOMASLBolusCutoffDelayTime (0x0018, 0x925f);
const DICOMTag DICOMASLSlabSequence (0x0018, 0x9260);
const DICOMTag DICOMChemicalShiftMinimumIntegrationLimitInppm (0x0018, 0x9295);
const DICOMTag DICOMChemicalShiftMaximumIntegrationLimitInppm (0x0018, 0x9296);
const DICOMTag DICOMCTAcquisitionTypeSequence (0x0018, 0x9301);
const DICOMTag DICOMAcquisitionType (0x0018, 0x9302);
const DICOMTag DICOMTubeAngle (0x0018, 0x9303);
const DICOMTag DICOMCTAcquisitionDetailsSequence (0x0018, 0x9304);
const DICOMTag DICOMRevolutionTime (0x0018, 0x9305);
const DICOMTag DICOMSingleCollimationWidth (0x0018, 0x9306);
const DICOMTag DICOMTotalCollimationWidth (0x0018, 0x9307);
const DICOMTag DICOMCTTableDynamicsSequence (0x0018, 0x9308);
const DICOMTag DICOMTableSpeed (0x0018, 0x9309);
const DICOMTag DICOMTableFeedPerRotation (0x0018, 0x9310);
const DICOMTag DICOMSpiralPitchFactor (0x0018, 0x9311);
const DICOMTag DICOMCTGeometrySequence (0x0018, 0x9312);
const DICOMTag DICOMDataCollectionCenterPatient (0x0018, 0x9313);
const DICOMTag DICOMCTReconstructionSequence (0x0018, 0x9314);
const DICOMTag DICOMReconstructionAlgorithm (0x0018, 0x9315);
const DICOMTag DICOMConvolutionKernelGroup (0x0018, 0x9316);
const DICOMTag DICOMReconstructionFieldOfView (0x0018, 0x9317);
const DICOMTag DICOMReconstructionTargetCenterPatient (0x0018, 0x9318);
const DICOMTag DICOMReconstructionAngle (0x0018, 0x9319);
const DICOMTag DICOMImageFilter (0x0018, 0x9320);
const DICOMTag DICOMCTExposureSequence (0x0018, 0x9321);
const DICOMTag DICOMReconstructionPixelSpacing (0x0018, 0x9322);
const DICOMTag DICOMExposureModulationType (0x0018, 0x9323);
const DICOMTag DICOMEstimatedDoseSaving (0x0018, 0x9324);
const DICOMTag DICOMCTXRayDetailsSequence (0x0018, 0x9325);
const DICOMTag DICOMCTPositionSequence (0x0018, 0x9326);
const DICOMTag DICOMTablePosition (0x0018, 0x9327);
const DICOMTag DICOMExposureTimeInms (0x0018, 0x9328);
const DICOMTag DICOMCTImageFrameTypeSequence (0x0018, 0x9329);
const DICOMTag DICOMXRayTubeCurrentInmA (0x0018, 0x9330);
const DICOMTag DICOMExposureInmAs (0x0018, 0x9332);
const DICOMTag DICOMConstantVolumeFlag (0x0018, 0x9333);
const DICOMTag DICOMFluoroscopyFlag (0x0018, 0x9334);
const DICOMTag DICOMDistanceSourceToDataCollectionCenter (0x0018, 0x9335);
const DICOMTag DICOMContrastBolusAgentNumber (0x0018, 0x9337);
const DICOMTag DICOMContrastBolusIngredientCodeSequence (0x0018, 0x9338);
const DICOMTag DICOMContrastAdministrationProfileSequence (0x0018, 0x9340);
const DICOMTag DICOMContrastBolusUsageSequence (0x0018, 0x9341);
const DICOMTag DICOMContrastBolusAgentAdministered (0x0018, 0x9342);
const DICOMTag DICOMContrastBolusAgentDetected (0x0018, 0x9343);
const DICOMTag DICOMContrastBolusAgentPhase (0x0018, 0x9344);
const DICOMTag DICOMCTDIvol (0x0018, 0x9345);
const DICOMTag DICOMCTDIPhantomTypeCodeSequence (0x0018, 0x9346);
const DICOMTag DICOMCalciumScoringMassFactorPatient (0x0018, 0x9351);
const DICOMTag DICOMCalciumScoringMassFactorDevice (0x0018, 0x9352);
const DICOMTag DICOMEnergyWeightingFactor (0x0018, 0x9353);
const DICOMTag DICOMCTAdditionalXRaySourceSequence (0x0018, 0x9360);
const DICOMTag DICOMProjectionPixelCalibrationSequence (0x0018, 0x9401);
const DICOMTag DICOMDistanceSourceToIsocenter (0x0018, 0x9402);
const DICOMTag DICOMDistanceObjectToTableTop (0x0018, 0x9403);
const DICOMTag DICOMObjectPixelSpacingInCenterOfBeam (0x0018, 0x9404);
const DICOMTag DICOMPositionerPositionSequence (0x0018, 0x9405);
const DICOMTag DICOMTablePositionSequence (0x0018, 0x9406);
const DICOMTag DICOMCollimatorShapeSequence (0x0018, 0x9407);
const DICOMTag DICOMPlanesInAcquisition (0x0018, 0x9410);
const DICOMTag DICOMXAXRFFrameCharacteristicsSequence (0x0018, 0x9412);
const DICOMTag DICOMFrameAcquisitionSequence (0x0018, 0x9417);
const DICOMTag DICOMXRayReceptorType (0x0018, 0x9420);
const DICOMTag DICOMAcquisitionProtocolName (0x0018, 0x9423);
const DICOMTag DICOMAcquisitionProtocolDescription (0x0018, 0x9424);
const DICOMTag DICOMContrastBolusIngredientOpaque (0x0018, 0x9425);
const DICOMTag DICOMDistanceReceptorPlaneToDetectorHousing (0x0018, 0x9426);
const DICOMTag DICOMIntensifierActiveShape (0x0018, 0x9427);
const DICOMTag DICOMIntensifierActiveDimensions (0x0018, 0x9428);
const DICOMTag DICOMPhysicalDetectorSize (0x0018, 0x9429);
const DICOMTag DICOMPositionOfIsocenterProjection (0x0018, 0x9430);
const DICOMTag DICOMFieldOfViewSequence (0x0018, 0x9432);
const DICOMTag DICOMFieldOfViewDescription (0x0018, 0x9433);
const DICOMTag DICOMExposureControlSensingRegionsSequence (0x0018, 0x9434);
const DICOMTag DICOMExposureControlSensingRegionShape (0x0018, 0x9435);
const DICOMTag DICOMExposureControlSensingRegionLeftVerticalEdge (0x0018, 0x9436);
const DICOMTag DICOMExposureControlSensingRegionRightVerticalEdge (0x0018, 0x9437);
const DICOMTag DICOMExposureControlSensingRegionUpperHorizontalEdge (0x0018, 0x9438);
const DICOMTag DICOMExposureControlSensingRegionLowerHorizontalEdge (0x0018, 0x9439);
const DICOMTag DICOMCenterOfCircularExposureControlSensingRegion (0x0018, 0x9440);
const DICOMTag DICOMRadiusOfCircularExposureControlSensingRegion (0x0018, 0x9441);
const DICOMTag DICOMVerticesOfThePolygonalExposureControlSensingRegion (0x0018, 0x9442);
const DICOMTag DICOMColumnAngulationPatient (0x0018, 0x9447);
const DICOMTag DICOMBeamAngle (0x0018, 0x9449);
const DICOMTag DICOMFrameDetectorParametersSequence (0x0018, 0x9451);
const DICOMTag DICOMCalculatedAnatomyThickness (0x0018, 0x9452);
const DICOMTag DICOMCalibrationSequence (0x0018, 0x9455);
const DICOMTag DICOMObjectThicknessSequence (0x0018, 0x9456);
const DICOMTag DICOMPlaneIdentification (0x0018, 0x9457);
const DICOMTag DICOMFieldOfViewDimensionsInFloat (0x0018, 0x9461);
const DICOMTag DICOMIsocenterReferenceSystemSequence (0x0018, 0x9462);
const DICOMTag DICOMPositionerIsocenterPrimaryAngle (0x0018, 0x9463);
const DICOMTag DICOMPositionerIsocenterSecondaryAngle (0x0018, 0x9464);
const DICOMTag DICOMPositionerIsocenterDetectorRotationAngle (0x0018, 0x9465);
const DICOMTag DICOMTableXPositionToIsocenter (0x0018, 0x9466);
const DICOMTag DICOMTableYPositionToIsocenter (0x0018, 0x9467);
const DICOMTag DICOMTableZPositionToIsocenter (0x0018, 0x9468);
const DICOMTag DICOMTableHorizontalRotationAngle (0x0018, 0x9469);
const DICOMTag DICOMTableHeadTiltAngle (0x0018, 0x9470);
const DICOMTag DICOMTableCradleTiltAngle (0x0018, 0x9471);
const DICOMTag DICOMFrameDisplayShutterSequence (0x0018, 0x9472);
const DICOMTag DICOMAcquiredImageAreaDoseProduct (0x0018, 0x9473);
const DICOMTag DICOMCArmPositionerTabletopRelationship (0x0018, 0x9474);
const DICOMTag DICOMXRayGeometrySequence (0x0018, 0x9476);
const DICOMTag DICOMIrradiationEventIdentificationSequence (0x0018, 0x9477);
const DICOMTag DICOMXRay3DFrameTypeSequence (0x0018, 0x9504);
const DICOMTag DICOMContributingSourcesSequence (0x0018, 0x9506);
const DICOMTag DICOMXRay3DAcquisitionSequence (0x0018, 0x9507);
const DICOMTag DICOMPrimaryPositionerScanArc (0x0018, 0x9508);
const DICOMTag DICOMSecondaryPositionerScanArc (0x0018, 0x9509);
const DICOMTag DICOMPrimaryPositionerScanStartAngle (0x0018, 0x9510);
const DICOMTag DICOMSecondaryPositionerScanStartAngle (0x0018, 0x9511);
const DICOMTag DICOMPrimaryPositionerIncrement (0x0018, 0x9514);
const DICOMTag DICOMSecondaryPositionerIncrement (0x0018, 0x9515);
const DICOMTag DICOMStartAcquisitionDateTime (0x0018, 0x9516);
const DICOMTag DICOMEndAcquisitionDateTime (0x0018, 0x9517);
const DICOMTag DICOMApplicationName (0x0018, 0x9524);
const DICOMTag DICOMApplicationVersion (0x0018, 0x9525);
const DICOMTag DICOMApplicationManufacturer (0x0018, 0x9526);
const DICOMTag DICOMAlgorithmType (0x0018, 0x9527);
const DICOMTag DICOMAlgorithmDescription (0x0018, 0x9528);
const DICOMTag DICOMXRay3DReconstructionSequence (0x0018, 0x9530);
const DICOMTag DICOMReconstructionDescription (0x0018, 0x9531);
const DICOMTag DICOMPerProjectionAcquisitionSequence (0x0018, 0x9538);
const DICOMTag DICOMDiffusionBMatrixSequence (0x0018, 0x9601);
const DICOMTag DICOMDiffusionBValueXX (0x0018, 0x9602);
const DICOMTag DICOMDiffusionBValueXY (0x0018, 0x9603);
const DICOMTag DICOMDiffusionBValueXZ (0x0018, 0x9604);
const DICOMTag DICOMDiffusionBValueYY (0x0018, 0x9605);
const DICOMTag DICOMDiffusionBValueYZ (0x0018, 0x9606);
const DICOMTag DICOMDiffusionBValueZZ (0x0018, 0x9607);
const DICOMTag DICOMDecayCorrectionDateTime (0x0018, 0x9701);
const DICOMTag DICOMStartDensityThreshold (0x0018, 0x9715);
const DICOMTag DICOMStartRelativeDensityDifferenceThreshold (0x0018, 0x9716);
const DICOMTag DICOMStartCardiacTriggerCountThreshold (0x0018, 0x9717);
const DICOMTag DICOMStartRespiratoryTriggerCountThreshold (0x0018, 0x9718);
const DICOMTag DICOMTerminationCountsThreshold (0x0018, 0x9719);
const DICOMTag DICOMTerminationDensityThreshold (0x0018, 0x9720);
const DICOMTag DICOMTerminationRelativeDensityThreshold (0x0018, 0x9721);
const DICOMTag DICOMTerminationTimeThreshold (0x0018, 0x9722);
const DICOMTag DICOMTerminationCardiacTriggerCountThreshold (0x0018, 0x9723);
const DICOMTag DICOMTerminationRespiratoryTriggerCountThreshold (0x0018, 0x9724);
const DICOMTag DICOMDetectorGeometry (0x0018, 0x9725);
const DICOMTag DICOMTransverseDetectorSeparation (0x0018, 0x9726);
const DICOMTag DICOMAxialDetectorDimension (0x0018, 0x9727);
const DICOMTag DICOMRadiopharmaceuticalAgentNumber (0x0018, 0x9729);
const DICOMTag DICOMPETFrameAcquisitionSequence (0x0018, 0x9732);
const DICOMTag DICOMPETDetectorMotionDetailsSequence (0x0018, 0x9733);
const DICOMTag DICOMPETTableDynamicsSequence (0x0018, 0x9734);
const DICOMTag DICOMPETPositionSequence (0x0018, 0x9735);
const DICOMTag DICOMPETFrameCorrectionFactorsSequence (0x0018, 0x9736);
const DICOMTag DICOMRadiopharmaceuticalUsageSequence (0x0018, 0x9737);
const DICOMTag DICOMAttenuationCorrectionSource (0x0018, 0x9738);
const DICOMTag DICOMNumberOfIterations (0x0018, 0x9739);
const DICOMTag DICOMNumberOfSubsets (0x0018, 0x9740);
const DICOMTag DICOMPETReconstructionSequence (0x0018, 0x9749);
const DICOMTag DICOMPETFrameTypeSequence (0x0018, 0x9751);
const DICOMTag DICOMTimeOfFlightInformationUsed (0x0018, 0x9755);
const DICOMTag DICOMReconstructionType (0x0018, 0x9756);
const DICOMTag DICOMDecayCorrected (0x0018, 0x9758);
const DICOMTag DICOMAttenuationCorrected (0x0018, 0x9759);
const DICOMTag DICOMScatterCorrected (0x0018, 0x9760);
const DICOMTag DICOMDeadTimeCorrected (0x0018, 0x9761);
const DICOMTag DICOMGantryMotionCorrected (0x0018, 0x9762);
const DICOMTag DICOMPatientMotionCorrected (0x0018, 0x9763);
const DICOMTag DICOMCountLossNormalizationCorrected (0x0018, 0x9764);
const DICOMTag DICOMRandomsCorrected (0x0018, 0x9765);
const DICOMTag DICOMNonUniformRadialSamplingCorrected (0x0018, 0x9766);
const DICOMTag DICOMSensitivityCalibrated (0x0018, 0x9767);
const DICOMTag DICOMDetectorNormalizationCorrection (0x0018, 0x9768);
const DICOMTag DICOMIterativeReconstructionMethod (0x0018, 0x9769);
const DICOMTag DICOMAttenuationCorrectionTemporalRelationship (0x0018, 0x9770);
const DICOMTag DICOMPatientPhysiologicalStateSequence (0x0018, 0x9771);
const DICOMTag DICOMPatientPhysiologicalStateCodeSequence (0x0018, 0x9772);
const DICOMTag DICOMDepthsOfFocus (0x0018, 0x9801);
const DICOMTag DICOMExcludedIntervalsSequence (0x0018, 0x9803);
const DICOMTag DICOMExclusionStartDatetime (0x0018, 0x9804);
const DICOMTag DICOMExclusionDuration (0x0018, 0x9805);
const DICOMTag DICOMUSImageDescriptionSequence (0x0018, 0x9806);
const DICOMTag DICOMImageDataTypeSequence (0x0018, 0x9807);
const DICOMTag DICOMDataType (0x0018, 0x9808);
const DICOMTag DICOMTransducerScanPatternCodeSequence (0x0018, 0x9809);
const DICOMTag DICOMAliasedDataType (0x0018, 0x980b);
const DICOMTag DICOMPositionMeasuringDeviceUsed (0x0018, 0x980c);
const DICOMTag DICOMTransducerGeometryCodeSequence (0x0018, 0x980d);
const DICOMTag DICOMTransducerBeamSteeringCodeSequence (0x0018, 0x980e);
const DICOMTag DICOMTransducerApplicationCodeSequence (0x0018, 0x980f);
const DICOMTag DICOMContributingEquipmentSequence (0x0018, 0xa001);
const DICOMTag DICOMContributionDateTime (0x0018, 0xa002);
const DICOMTag DICOMContributionDescription (0x0018, 0xa003);
const DICOMTag DICOMStudyInstanceUID (0x0020, 0x000d);
const DICOMTag DICOMSeriesInstanceUID (0x0020, 0x000e);
const DICOMTag DICOMStudyID (0x0020, 0x0010);
const DICOMTag DICOMSeriesNumber (0x0020, 0x0011);
const DICOMTag DICOMAcquisitionNumber (0x0020, 0x0012);
const DICOMTag DICOMInstanceNumber (0x0020, 0x0013);
const DICOMTag DICOMRETIREDIsotopeNumber (0x0020, 0x0014);
const DICOMTag DICOMRETIREDPhaseNumber (0x0020, 0x0015);
const DICOMTag DICOMRETIREDIntervalNumber (0x0020, 0x0016);
const DICOMTag DICOMRETIREDTimeSlotNumber (0x0020, 0x0017);
const DICOMTag DICOMRETIREDAngleNumber (0x0020, 0x0018);
const DICOMTag DICOMItemNumber (0x0020, 0x0019);
const DICOMTag DICOMPatientOrientation (0x0020, 0x0020);
const DICOMTag DICOMRETIREDOverlayNumber (0x0020, 0x0022);
const DICOMTag DICOMRETIREDCurveNumber (0x0020, 0x0024);
const DICOMTag DICOMRETIREDLUTNumber (0x0020, 0x0026);
const DICOMTag DICOMRETIREDImagePosition (0x0020, 0x0030);
const DICOMTag DICOMImagePositionPatient (0x0020, 0x0032);
const DICOMTag DICOMRETIREDImageOrientation (0x0020, 0x0035);
const DICOMTag DICOMImageOrientationPatient (0x0020, 0x0037);
const DICOMTag DICOMRETIREDLocation (0x0020, 0x0050);
const DICOMTag DICOMFrameOfReferenceUID (0x0020, 0x0052);
const DICOMTag DICOMLaterality (0x0020, 0x0060);
const DICOMTag DICOMImageLaterality (0x0020, 0x0062);
const DICOMTag DICOMRETIREDImageGeometryType (0x0020, 0x0070);
const DICOMTag DICOMRETIREDMaskingImage (0x0020, 0x0080);
const DICOMTag DICOMRETIREDReportNumber (0x0020, 0x00aa);
const DICOMTag DICOMTemporalPositionIdentifier (0x0020, 0x0100);
const DICOMTag DICOMNumberOfTemporalPositions (0x0020, 0x0105);
const DICOMTag DICOMTemporalResolution (0x0020, 0x0110);
const DICOMTag DICOMSynchronizationFrameOfReferenceUID (0x0020, 0x0200);
const DICOMTag DICOMSOPInstanceUIDOfConcatenationSource (0x0020, 0x0242);
const DICOMTag DICOMRETIREDSeriesInStudy (0x0020, 0x1000);
const DICOMTag DICOMRETIREDAcquisitionsInSeries (0x0020, 0x1001);
const DICOMTag DICOMImagesInAcquisition (0x0020, 0x1002);
const DICOMTag DICOMRETIREDImagesInSeries (0x0020, 0x1003);
const DICOMTag DICOMRETIREDAcquisitionsInStudy (0x0020, 0x1004);
const DICOMTag DICOMRETIREDImagesInStudy (0x0020, 0x1005);
const DICOMTag DICOMRETIREDReference (0x0020, 0x1020);
const DICOMTag DICOMPositionReferenceIndicator (0x0020, 0x1040);
const DICOMTag DICOMSliceLocation (0x0020, 0x1041);
const DICOMTag DICOMRETIREDOtherStudyNumbers (0x0020, 0x1070);
const DICOMTag DICOMNumberOfPatientRelatedStudies (0x0020, 0x1200);
const DICOMTag DICOMNumberOfPatientRelatedSeries (0x0020, 0x1202);
const DICOMTag DICOMNumberOfPatientRelatedInstances (0x0020, 0x1204);
const DICOMTag DICOMNumberOfStudyRelatedSeries (0x0020, 0x1206);
const DICOMTag DICOMNumberOfStudyRelatedInstances (0x0020, 0x1208);
const DICOMTag DICOMNumberOfSeriesRelatedInstances (0x0020, 0x1209);
const DICOMTag DICOMRETIREDModifyingDeviceID (0x0020, 0x3401);
const DICOMTag DICOMRETIREDModifiedImageID (0x0020, 0x3402);
const DICOMTag DICOMRETIREDModifiedImageDate (0x0020, 0x3403);
const DICOMTag DICOMRETIREDModifyingDeviceManufacturer (0x0020, 0x3404);
const DICOMTag DICOMRETIREDModifiedImageTime (0x0020, 0x3405);
const DICOMTag DICOMRETIREDModifiedImageDescription (0x0020, 0x3406);
const DICOMTag DICOMImageComments (0x0020, 0x4000);
const DICOMTag DICOMRETIREDOriginalImageIdentification (0x0020, 0x5000);
const DICOMTag DICOMRETIREDOriginalImageIdentificationNomenclature (0x0020, 0x5002);
const DICOMTag DICOMStackID (0x0020, 0x9056);
const DICOMTag DICOMInStackPositionNumber (0x0020, 0x9057);
const DICOMTag DICOMFrameAnatomySequence (0x0020, 0x9071);
const DICOMTag DICOMFrameLaterality (0x0020, 0x9072);
const DICOMTag DICOMFrameContentSequence (0x0020, 0x9111);
const DICOMTag DICOMPlanePositionSequence (0x0020, 0x9113);
const DICOMTag DICOMPlaneOrientationSequence (0x0020, 0x9116);
const DICOMTag DICOMTemporalPositionIndex (0x0020, 0x9128);
const DICOMTag DICOMNominalCardiacTriggerDelayTime (0x0020, 0x9153);
const DICOMTag DICOMNominalCardiacTriggerTimePriorToRPeak (0x0020, 0x9154);
const DICOMTag DICOMActualCardiacTriggerTimePriorToRPeak (0x0020, 0x9155);
const DICOMTag DICOMFrameAcquisitionNumber (0x0020, 0x9156);
const DICOMTag DICOMDimensionIndexValues (0x0020, 0x9157);
const DICOMTag DICOMFrameComments (0x0020, 0x9158);
const DICOMTag DICOMConcatenationUID (0x0020, 0x9161);
const DICOMTag DICOMInConcatenationNumber (0x0020, 0x9162);
const DICOMTag DICOMInConcatenationTotalNumber (0x0020, 0x9163);
const DICOMTag DICOMDimensionOrganizationUID (0x0020, 0x9164);
const DICOMTag DICOMDimensionIndexPointer (0x0020, 0x9165);
const DICOMTag DICOMFunctionalGroupPointer (0x0020, 0x9167);
const DICOMTag DICOMDimensionIndexPrivateCreator (0x0020, 0x9213);
const DICOMTag DICOMDimensionOrganizationSequence (0x0020, 0x9221);
const DICOMTag DICOMDimensionIndexSequence (0x0020, 0x9222);
const DICOMTag DICOMConcatenationFrameOffsetNumber (0x0020, 0x9228);
const DICOMTag DICOMFunctionalGroupPrivateCreator (0x0020, 0x9238);
const DICOMTag DICOMNominalPercentageOfCardiacPhase (0x0020, 0x9241);
const DICOMTag DICOMNominalPercentageOfRespiratoryPhase (0x0020, 0x9245);
const DICOMTag DICOMStartingRespiratoryAmplitude (0x0020, 0x9246);
const DICOMTag DICOMStartingRespiratoryPhase (0x0020, 0x9247);
const DICOMTag DICOMEndingRespiratoryAmplitude (0x0020, 0x9248);
const DICOMTag DICOMEndingRespiratoryPhase (0x0020, 0x9249);
const DICOMTag DICOMRespiratoryTriggerType (0x0020, 0x9250);
const DICOMTag DICOMRRIntervalTimeNominal (0x0020, 0x9251);
const DICOMTag DICOMActualCardiacTriggerDelayTime (0x0020, 0x9252);
const DICOMTag DICOMRespiratorySynchronizationSequence (0x0020, 0x9253);
const DICOMTag DICOMRespiratoryIntervalTime (0x0020, 0x9254);
const DICOMTag DICOMNominalRespiratoryTriggerDelayTime (0x0020, 0x9255);
const DICOMTag DICOMRespiratoryTriggerDelayThreshold (0x0020, 0x9256);
const DICOMTag DICOMActualRespiratoryTriggerDelayTime (0x0020, 0x9257);
const DICOMTag DICOMImagePositionVolume (0x0020, 0x9301);
const DICOMTag DICOMImageOrientationVolume (0x0020, 0x9302);
const DICOMTag DICOMUltrasoundAcquisitionGeometry (0x0020, 0x9307);
const DICOMTag DICOMApexPosition (0x0020, 0x9308);
const DICOMTag DICOMVolumeToTransducerMappingMatrix (0x0020, 0x9309);
const DICOMTag DICOMVolumeToTableMappingMatrix (0x0020, 0x930a);
const DICOMTag DICOMPatientFrameOfReferenceSource (0x0020, 0x930c);
const DICOMTag DICOMTemporalPositionTimeOffset (0x0020, 0x930d);
const DICOMTag DICOMPlanePositionVolumeSequence (0x0020, 0x930e);
const DICOMTag DICOMPlaneOrientationVolumeSequence (0x0020, 0x930f);
const DICOMTag DICOMTemporalPositionSequence (0x0020, 0x9310);
const DICOMTag DICOMDimensionOrganizationType (0x0020, 0x9311);
const DICOMTag DICOMVolumeFrameOfReferenceUID (0x0020, 0x9312);
const DICOMTag DICOMTableFrameOfReferenceUID (0x0020, 0x9313);
const DICOMTag DICOMDimensionDescriptionLabel (0x0020, 0x9421);
const DICOMTag DICOMPatientOrientationInFrameSequence (0x0020, 0x9450);
const DICOMTag DICOMFrameLabel (0x0020, 0x9453);
const DICOMTag DICOMAcquisitionIndex (0x0020, 0x9518);
const DICOMTag DICOMContributingSOPInstancesReferenceSequence (0x0020, 0x9529);
const DICOMTag DICOMReconstructionIndex (0x0020, 0x9536);
const DICOMTag DICOMLightPathFilterPassThroughWavelength (0x0022, 0x0001);
const DICOMTag DICOMLightPathFilterPassBand (0x0022, 0x0002);
const DICOMTag DICOMImagePathFilterPassThroughWavelength (0x0022, 0x0003);
const DICOMTag DICOMImagePathFilterPassBand (0x0022, 0x0004);
const DICOMTag DICOMPatientEyeMovementCommanded (0x0022, 0x0005);
const DICOMTag DICOMPatientEyeMovementCommandCodeSequence (0x0022, 0x0006);
const DICOMTag DICOMSphericalLensPower (0x0022, 0x0007);
const DICOMTag DICOMCylinderLensPower (0x0022, 0x0008);
const DICOMTag DICOMCylinderAxis (0x0022, 0x0009);
const DICOMTag DICOMEmmetropicMagnification (0x0022, 0x000a);
const DICOMTag DICOMIntraOcularPressure (0x0022, 0x000b);
const DICOMTag DICOMHorizontalFieldOfView (0x0022, 0x000c);
const DICOMTag DICOMPupilDilated (0x0022, 0x000d);
const DICOMTag DICOMDegreeOfDilation (0x0022, 0x000e);
const DICOMTag DICOMStereoBaselineAngle (0x0022, 0x0010);
const DICOMTag DICOMStereoBaselineDisplacement (0x0022, 0x0011);
const DICOMTag DICOMStereoHorizontalPixelOffset (0x0022, 0x0012);
const DICOMTag DICOMStereoVerticalPixelOffset (0x0022, 0x0013);
const DICOMTag DICOMStereoRotation (0x0022, 0x0014);
const DICOMTag DICOMAcquisitionDeviceTypeCodeSequence (0x0022, 0x0015);
const DICOMTag DICOMIlluminationTypeCodeSequence (0x0022, 0x0016);
const DICOMTag DICOMLightPathFilterTypeStackCodeSequence (0x0022, 0x0017);
const DICOMTag DICOMImagePathFilterTypeStackCodeSequence (0x0022, 0x0018);
const DICOMTag DICOMLensesCodeSequence (0x0022, 0x0019);
const DICOMTag DICOMChannelDescriptionCodeSequence (0x0022, 0x001a);
const DICOMTag DICOMRefractiveStateSequence (0x0022, 0x001b);
const DICOMTag DICOMMydriaticAgentCodeSequence (0x0022, 0x001c);
const DICOMTag DICOMRelativeImagePositionCodeSequence (0x0022, 0x001d);
const DICOMTag DICOMCameraAngleOfView (0x0022, 0x001e);
const DICOMTag DICOMStereoPairsSequence (0x0022, 0x0020);
const DICOMTag DICOMLeftImageSequence (0x0022, 0x0021);
const DICOMTag DICOMRightImageSequence (0x0022, 0x0022);
const DICOMTag DICOMAxialLengthOfTheEye (0x0022, 0x0030);
const DICOMTag DICOMOphthalmicFrameLocationSequence (0x0022, 0x0031);
const DICOMTag DICOMReferenceCoordinates (0x0022, 0x0032);
const DICOMTag DICOMDepthSpatialResolution (0x0022, 0x0035);
const DICOMTag DICOMMaximumDepthDistortion (0x0022, 0x0036);
const DICOMTag DICOMAlongScanSpatialResolution (0x0022, 0x0037);
const DICOMTag DICOMMaximumAlongScanDistortion (0x0022, 0x0038);
const DICOMTag DICOMOphthalmicImageOrientation (0x0022, 0x0039);
const DICOMTag DICOMDepthOfTransverseImage (0x0022, 0x0041);
const DICOMTag DICOMMydriaticAgentConcentrationUnitsSequence (0x0022, 0x0042);
const DICOMTag DICOMAcrossScanSpatialResolution (0x0022, 0x0048);
const DICOMTag DICOMMaximumAcrossScanDistortion (0x0022, 0x0049);
const DICOMTag DICOMMydriaticAgentConcentration (0x0022, 0x004e);
const DICOMTag DICOMIlluminationWaveLength (0x0022, 0x0055);
const DICOMTag DICOMIlluminationPower (0x0022, 0x0056);
const DICOMTag DICOMIlluminationBandwidth (0x0022, 0x0057);
const DICOMTag DICOMMydriaticAgentSequence (0x0022, 0x0058);
const DICOMTag DICOMOphthalmicAxialMeasurementsRightEyeSequence (0x0022, 0x1007);
const DICOMTag DICOMOphthalmicAxialMeasurementsLeftEyeSequence (0x0022, 0x1008);
const DICOMTag DICOMOphthalmicAxialMeasurementsDeviceType (0x0022, 0x1009);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsType (0x0022, 0x1010);
const DICOMTag DICOMOphthalmicAxialLengthSequence (0x0022, 0x1012);
const DICOMTag DICOMOphthalmicAxialLength (0x0022, 0x1019);
const DICOMTag DICOMLensStatusCodeSequence (0x0022, 0x1024);
const DICOMTag DICOMVitreousStatusCodeSequence (0x0022, 0x1025);
const DICOMTag DICOMIOLFormulaCodeSequence (0x0022, 0x1028);
const DICOMTag DICOMIOLFormulaDetail (0x0022, 0x1029);
const DICOMTag DICOMKeratometerIndex (0x0022, 0x1033);
const DICOMTag DICOMSourceofOphthalmicAxialLengthCodeSequence (0x0022, 0x1035);
const DICOMTag DICOMTargetRefraction (0x0022, 0x1037);
const DICOMTag DICOMRefractiveProcedureOccurred (0x0022, 0x1039);
const DICOMTag DICOMRefractiveSurgeryTypeCodeSequence (0x0022, 0x1040);
const DICOMTag DICOMOphthalmicUltrasoundMethodCodeSequence (0x0022, 0x1044);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsSequence (0x0022, 0x1050);
const DICOMTag DICOMIOLPower (0x0022, 0x1053);
const DICOMTag DICOMPredictedRefractiveError (0x0022, 0x1054);
const DICOMTag DICOMOphthalmicAxialLengthVelocity (0x0022, 0x1059);
const DICOMTag DICOMLensStatusDescription (0x0022, 0x1065);
const DICOMTag DICOMVitreousStatusDescription (0x0022, 0x1066);
const DICOMTag DICOMIOLPowerSequence (0x0022, 0x1090);
const DICOMTag DICOMLensConstantSequence (0x0022, 0x1092);
const DICOMTag DICOMIOLManufacturer (0x0022, 0x1093);
const DICOMTag DICOMImplantName (0x0022, 0x1095);
const DICOMTag DICOMKeratometryMeasurementTypeCodeSequence (0x0022, 0x1096);
const DICOMTag DICOMImplantPartNumber (0x0022, 0x1097);
const DICOMTag DICOMReferencedOphthalmicAxialMeasurementsSequence (0x0022, 0x1100);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsSegmentNameCodeSequence (0x0022, 0x1101);
const DICOMTag DICOMRefractiveErrorBeforeRefractiveSurgeryCodeSequence (0x0022, 0x1103);
const DICOMTag DICOMIOLPowerForExactEmmetropia (0x0022, 0x1121);
const DICOMTag DICOMIOLPowerForExactTargetRefraction (0x0022, 0x1122);
const DICOMTag DICOMAnteriorChamberDepthDefinitionCodeSequence (0x0022, 0x1125);
const DICOMTag DICOMLensThicknessSequence (0x0022, 0x1127);
const DICOMTag DICOMAnteriorChamberDepthSequence (0x0022, 0x1128);
const DICOMTag DICOMLensThickness (0x0022, 0x1130);
const DICOMTag DICOMAnteriorChamberDepth (0x0022, 0x1131);
const DICOMTag DICOMSourceofLensThicknessDataCodeSequence (0x0022, 0x1132);
const DICOMTag DICOMSourceofAnteriorChamberDepthDataCodeSequence (0x0022, 0x1133);
const DICOMTag DICOMSourceofRefractiveMeasurementsSequence (0x0022, 0x1134);
const DICOMTag DICOMSourceofRefractiveMeasurementsCodeSequence (0x0022, 0x1135);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementModified (0x0022, 0x1140);
const DICOMTag DICOMOphthalmicAxialLengthDataSourceCodeSequence (0x0022, 0x1150);
const DICOMTag DICOMSignaltoNoiseRatio (0x0022, 0x1155);
const DICOMTag DICOMOphthalmicAxialLengthDataSourceDescription (0x0022, 0x1159);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsTotalLengthSequence (0x0022, 0x1210);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsSegmentalLengthSequence (0x0022, 0x1211);
const DICOMTag DICOMOphthalmicAxialLengthMeasurementsLengthSummationSequence (0x0022, 0x1212);
const DICOMTag DICOMUltrasoundOphthalmicAxialLengthMeasurementsSequence (0x0022, 0x1220);
const DICOMTag DICOMOpticalOphthalmicAxialLengthMeasurementsSequence (0x0022, 0x1225);
const DICOMTag DICOMUltrasoundSelectedOphthalmicAxialLengthSequence (0x0022, 0x1230);
const DICOMTag DICOMOphthalmicAxialLengthSelectionMethodCodeSequence (0x0022, 0x1250);
const DICOMTag DICOMOpticalSelectedOphthalmicAxialLengthSequence (0x0022, 0x1255);
const DICOMTag DICOMSelectedSegmentalOphthalmicAxialLengthSequence (0x0022, 0x1257);
const DICOMTag DICOMSelectedTotalOphthalmicAxialLengthSequence (0x0022, 0x1260);
const DICOMTag DICOMOphthalmicAxialLengthQualityMetricSequence (0x0022, 0x1262);
const DICOMTag DICOMOphthalmicAxialLengthQualityMetricTypeCodeSequence (0x0022, 0x1265);
const DICOMTag DICOMIntraocularLensCalculationsRightEyeSequence (0x0022, 0x1300);
const DICOMTag DICOMIntraocularLensCalculationsLeftEyeSequence (0x0022, 0x1310);
const DICOMTag DICOMReferencedOphthalmicAxialLengthMeasurementQCImageSequence (0x0022, 0x1330);
const DICOMTag DICOMOphthalmicMappingDeviceType (0x0022, 0x1415);
const DICOMTag DICOMAcquisitionTypeMethodSequence (0x0022, 0x1420);
const DICOMTag DICOMAcquisitonMethodAlgorithmSequence (0x0022, 0x1423);
const DICOMTag DICOMOphthalmicThicknessMapTypeCodeSequence (0x0022, 0x1436);
const DICOMTag DICOMOphthalmicThicknessMappingNormalsSequence (0x0022, 0x1443);
const DICOMTag DICOMRetinalThicknessDefinitionCodeSequence (0x0022, 0x1445);
const DICOMTag DICOMPixelValueMappingtoCodedConceptSequence (0x0022, 0x1450);
const DICOMTag DICOMMappedPixelValue (0x0022, 0x1452);
const DICOMTag DICOMPixelValueMappingExplanation (0x0022, 0x1454);
const DICOMTag DICOMOphthalmicThicknessMapQualityThresholdSequence (0x0022, 0x1458);
const DICOMTag DICOMOphthalmicThicknessMapThresholdQualityRating (0x0022, 0x1460);
const DICOMTag DICOMAnatomicStructureReferencePoint (0x0022, 0x1463);
const DICOMTag DICOMRegistrationtoLocalizerSequence (0x0022, 0x1465);
const DICOMTag DICOMRegisteredLocalizerUnits (0x0022, 0x1466);
const DICOMTag DICOMRegisteredTopLeftHandCorner (0x0022, 0x1467);
const DICOMTag DICOMRegisteredBottomRightHandCorner (0x0022, 0x1468);
const DICOMTag DICOMOphthalmicThicknessMapQualityRatingSequence (0x0022, 0x1470);
const DICOMTag DICOMRelevantOPTAttributesSequence (0x0022, 0x1472);
const DICOMTag DICOMVisualFieldHorizontalExtent (0x0024, 0x0010);
const DICOMTag DICOMVisualFieldVerticalExtent (0x0024, 0x0011);
const DICOMTag DICOMVisualFieldShape (0x0024, 0x0012);
const DICOMTag DICOMScreeningTestModeCodeSequence (0x0024, 0x0016);
const DICOMTag DICOMMaximumStimulusLuminance (0x0024, 0x0018);
const DICOMTag DICOMBackgroundLuminance (0x0024, 0x0020);
const DICOMTag DICOMStimulusColorCodeSequence (0x0024, 0x0021);
const DICOMTag DICOMBackgroundIlluminationColorCodeSequence (0x0024, 0x0024);
const DICOMTag DICOMStimulusArea (0x0024, 0x0025);
const DICOMTag DICOMStimulusPresentationTime (0x0024, 0x0028);
const DICOMTag DICOMFixationSequence (0x0024, 0x0032);
const DICOMTag DICOMFixationMonitoringCodeSequence (0x0024, 0x0033);
const DICOMTag DICOMVisualFieldCatchTrialSequence (0x0024, 0x0034);
const DICOMTag DICOMFixationCheckedQuantity (0x0024, 0x0035);
const DICOMTag DICOMPatientNotProperlyFixatedQuantity (0x0024, 0x0036);
const DICOMTag DICOMPresentedVisualStimuliDataFlag (0x0024, 0x0037);
const DICOMTag DICOMNumberOfVisualStimuli (0x0024, 0x0038);
const DICOMTag DICOMExcessiveFixationLossesDataFlag (0x0024, 0x0039);
const DICOMTag DICOMExcessiveFixationLosses (0x0024, 0x0040);
const DICOMTag DICOMStimuliRetestingQuantity (0x0024, 0x0042);
const DICOMTag DICOMCommentsOnPatientPerformanceOfVisualField (0x0024, 0x0044);
const DICOMTag DICOMFalseNegativesEstimateFlag (0x0024, 0x0045);
const DICOMTag DICOMFalseNegativesEstimate (0x0024, 0x0046);
const DICOMTag DICOMNegativeCatchTrialsQuantity (0x0024, 0x0048);
const DICOMTag DICOMFalseNegativesQuantity (0x0024, 0x0050);
const DICOMTag DICOMExcessiveFalseNegativesDataFlag (0x0024, 0x0051);
const DICOMTag DICOMExcessiveFalseNegatives (0x0024, 0x0052);
const DICOMTag DICOMFalsePositivesEstimateFlag (0x0024, 0x0053);
const DICOMTag DICOMFalsePositivesEstimate (0x0024, 0x0054);
const DICOMTag DICOMCatchTrialsDataFlag (0x0024, 0x0055);
const DICOMTag DICOMPositiveCatchTrialsQuantity (0x0024, 0x0056);
const DICOMTag DICOMTestPointNormalsDataFlag (0x0024, 0x0057);
const DICOMTag DICOMTestPointNormalsSequence (0x0024, 0x0058);
const DICOMTag DICOMGlobalDeviationProbabilityNormalsFlag (0x0024, 0x0059);
const DICOMTag DICOMFalsePositivesQuantity (0x0024, 0x0060);
const DICOMTag DICOMExcessiveFalsePositivesDataFlag (0x0024, 0x0061);
const DICOMTag DICOMExcessiveFalsePositives (0x0024, 0x0062);
const DICOMTag DICOMVisualFieldTestNormalsFlag (0x0024, 0x0063);
const DICOMTag DICOMResultsNormalsSequence (0x0024, 0x0064);
const DICOMTag DICOMAgeCorrectedSensitivityDeviationAlgorithmSequence (0x0024, 0x0065);
const DICOMTag DICOMGlobalDeviationFromNormal (0x0024, 0x0066);
const DICOMTag DICOMGeneralizedDefectSensitivityDeviationAlgorithmSequence (0x0024, 0x0067);
const DICOMTag DICOMLocalizedDeviationfromNormal (0x0024, 0x0068);
const DICOMTag DICOMPatientReliabilityIndicator (0x0024, 0x0069);
const DICOMTag DICOMVisualFieldMeanSensitivity (0x0024, 0x0070);
const DICOMTag DICOMGlobalDeviationProbability (0x0024, 0x0071);
const DICOMTag DICOMLocalDeviationProbabilityNormalsFlag (0x0024, 0x0072);
const DICOMTag DICOMLocalizedDeviationProbability (0x0024, 0x0073);
const DICOMTag DICOMShortTermFluctuationCalculated (0x0024, 0x0074);
const DICOMTag DICOMShortTermFluctuation (0x0024, 0x0075);
const DICOMTag DICOMShortTermFluctuationProbabilityCalculated (0x0024, 0x0076);
const DICOMTag DICOMShortTermFluctuationProbability (0x0024, 0x0077);
const DICOMTag DICOMCorrectedLocalizedDeviationFromNormalCalculated (0x0024, 0x0078);
const DICOMTag DICOMCorrectedLocalizedDeviationFromNormal (0x0024, 0x0079);
const DICOMTag DICOMCorrectedLocalizedDeviationFromNormalProbabilityCalculated (0x0024, 0x0080);
const DICOMTag DICOMCorrectedLocalizedDeviationFromNormalProbability (0x0024, 0x0081);
const DICOMTag DICOMGlobalDeviationProbabilitySequence (0x0024, 0x0083);
const DICOMTag DICOMLocalizedDeviationProbabilitySequence (0x0024, 0x0085);
const DICOMTag DICOMFovealSensitivityMeasured (0x0024, 0x0086);
const DICOMTag DICOMFovealSensitivity (0x0024, 0x0087);
const DICOMTag DICOMVisualFieldTestDuration (0x0024, 0x0088);
const DICOMTag DICOMVisualFieldTestPointSequence (0x0024, 0x0089);
const DICOMTag DICOMVisualFieldTestPointXCoordinate (0x0024, 0x0090);
const DICOMTag DICOMVisualFieldTestPointYCoordinate (0x0024, 0x0091);
const DICOMTag DICOMAgeCorrectedSensitivityDeviationValue (0x0024, 0x0092);
const DICOMTag DICOMStimulusResults (0x0024, 0x0093);
const DICOMTag DICOMSensitivityValue (0x0024, 0x0094);
const DICOMTag DICOMRetestStimulusSeen (0x0024, 0x0095);
const DICOMTag DICOMRetestSensitivityValue (0x0024, 0x0096);
const DICOMTag DICOMVisualFieldTestPointNormalsSequence (0x0024, 0x0097);
const DICOMTag DICOMQuantifiedDefect (0x0024, 0x0098);
const DICOMTag DICOMGeneralizedDefectCorrectedSensitivityDeviationFlag (0x0024, 0x0102);
const DICOMTag DICOMGeneralizedDefectCorrectedSensitivityDeviationValue (0x0024, 0x0103);
const DICOMTag DICOMGeneralizedDefectCorrectedSensitivityDeviationProbabilityValue (0x0024, 0x0104);
const DICOMTag DICOMMinimumSensitivityValue (0x0024, 0x0105);
const DICOMTag DICOMBlindSpotLocalized (0x0024, 0x0106);
const DICOMTag DICOMBlindSpotXCoordinate (0x0024, 0x0107);
const DICOMTag DICOMBlindSpotYCoordinate (0x0024, 0x0108);
const DICOMTag DICOMVisualAcuityMeasurementSequence (0x0024, 0x0110);
const DICOMTag DICOMRefractiveParametersUsedOnPatientSequence (0x0024, 0x0112);
const DICOMTag DICOMMeasurementLaterality (0x0024, 0x0113);
const DICOMTag DICOMOphthalmicPatientClinicalInformationLeftEyeSequence (0x0024, 0x0114);
const DICOMTag DICOMOphthalmicPatientClinicalInformationRightEyeSequence (0x0024, 0x0115);
const DICOMTag DICOMFovealPointNormativeDataFlag (0x0024, 0x0117);
const DICOMTag DICOMFovealPointProbabilityValue (0x0024, 0x0118);
const DICOMTag DICOMScreeningBaselineMeasured (0x0024, 0x0120);
const DICOMTag DICOMScreeningBaselineMeasuredSequence (0x0024, 0x0122);
const DICOMTag DICOMScreeningBaselineType (0x0024, 0x0124);
const DICOMTag DICOMScreeningBaselineValue (0x0024, 0x0126);
const DICOMTag DICOMAlgorithmSource (0x0024, 0x0202);
const DICOMTag DICOMDataSetName (0x0024, 0x0306);
const DICOMTag DICOMDataSetVersion (0x0024, 0x0307);
const DICOMTag DICOMDataSetSource (0x0024, 0x0308);
const DICOMTag DICOMDataSetDescription (0x0024, 0x0309);
const DICOMTag DICOMVisualFieldTestReliabilityGlobalIndexSequence (0x0024, 0x0317);
const DICOMTag DICOMVisualFieldGlobalResultsIndexSequence (0x0024, 0x0320);
const DICOMTag DICOMDataObservationSequence (0x0024, 0x0325);
const DICOMTag DICOMIndexNormalsFlag (0x0024, 0x0338);
const DICOMTag DICOMIndexProbability (0x0024, 0x0341);
const DICOMTag DICOMIndexProbabilitySequence (0x0024, 0x0344);
const DICOMTag DICOMSamplesPerPixel (0x0028, 0x0002);
const DICOMTag DICOMSamplesPerPixelUsed (0x0028, 0x0003);
const DICOMTag DICOMPhotometricInterpretation (0x0028, 0x0004);
const DICOMTag DICOMRETIREDImageDimensions (0x0028, 0x0005);
const DICOMTag DICOMPlanarConfiguration (0x0028, 0x0006);
const DICOMTag DICOMNumberOfFrames (0x0028, 0x0008);
const DICOMTag DICOMFrameIncrementPointer (0x0028, 0x0009);
const DICOMTag DICOMFrameDimensionPointer (0x0028, 0x000a);
const DICOMTag DICOMRows (0x0028, 0x0010);
const DICOMTag DICOMColumns (0x0028, 0x0011);
const DICOMTag DICOMRETIREDPlanes (0x0028, 0x0012);
const DICOMTag DICOMUltrasoundColorDataPresent (0x0028, 0x0014);
const DICOMTag DICOMPixelSpacing (0x0028, 0x0030);
const DICOMTag DICOMZoomFactor (0x0028, 0x0031);
const DICOMTag DICOMZoomCenter (0x0028, 0x0032);
const DICOMTag DICOMPixelAspectRatio (0x0028, 0x0034);
const DICOMTag DICOMRETIREDImageFormat (0x0028, 0x0040);
const DICOMTag DICOMRETIREDManipulatedImage (0x0028, 0x0050);
const DICOMTag DICOMCorrectedImage (0x0028, 0x0051);
const DICOMTag DICOMRETIREDCompressionRecognitionCode (0x0028, 0x005f);
const DICOMTag DICOMRETIREDCompressionCode (0x0028, 0x0060);
const DICOMTag DICOMRETIREDCompressionOriginator (0x0028, 0x0061);
const DICOMTag DICOMRETIREDCompressionLabel (0x0028, 0x0062);
const DICOMTag DICOMRETIREDCompressionDescription (0x0028, 0x0063);
const DICOMTag DICOMRETIREDCompressionSequence (0x0028, 0x0065);
const DICOMTag DICOMRETIREDCompressionStepPointers (0x0028, 0x0066);
const DICOMTag DICOMRETIREDRepeatInterval (0x0028, 0x0068);
const DICOMTag DICOMRETIREDBitsGrouped (0x0028, 0x0069);
const DICOMTag DICOMRETIREDPerimeterTable (0x0028, 0x0070);
const DICOMTag DICOMRETIREDPerimeterValue (0x0028, 0x0071);
const DICOMTag DICOMRETIREDPredictorRows (0x0028, 0x0080);
const DICOMTag DICOMRETIREDPredictorColumns (0x0028, 0x0081);
const DICOMTag DICOMRETIREDPredictorConstants (0x0028, 0x0082);
const DICOMTag DICOMRETIREDBlockedPixels (0x0028, 0x0090);
const DICOMTag DICOMRETIREDBlockRows (0x0028, 0x0091);
const DICOMTag DICOMRETIREDBlockColumns (0x0028, 0x0092);
const DICOMTag DICOMRETIREDRowOverlap (0x0028, 0x0093);
const DICOMTag DICOMRETIREDColumnOverlap (0x0028, 0x0094);
const DICOMTag DICOMBitsAllocated (0x0028, 0x0100);
const DICOMTag DICOMBitsStored (0x0028, 0x0101);
const DICOMTag DICOMHighBit (0x0028, 0x0102);
const DICOMTag DICOMPixelRepresentation (0x0028, 0x0103);
const DICOMTag DICOMRETIREDSmallestValidPixelValue (0x0028, 0x0104);
const DICOMTag DICOMRETIREDLargestValidPixelValue (0x0028, 0x0105);
const DICOMTag DICOMSmallestImagePixelValue (0x0028, 0x0106);
const DICOMTag DICOMLargestImagePixelValue (0x0028, 0x0107);
const DICOMTag DICOMSmallestPixelValueInSeries (0x0028, 0x0108);
const DICOMTag DICOMLargestPixelValueInSeries (0x0028, 0x0109);
const DICOMTag DICOMRETIREDSmallestImagePixelValueInPlane (0x0028, 0x0110);
const DICOMTag DICOMRETIREDLargestImagePixelValueInPlane (0x0028, 0x0111);
const DICOMTag DICOMPixelPaddingValue (0x0028, 0x0120);
const DICOMTag DICOMPixelPaddingRangeLimit (0x0028, 0x0121);
const DICOMTag DICOMRETIREDImageLocation (0x0028, 0x0200);
const DICOMTag DICOMQualityControlImage (0x0028, 0x0300);
const DICOMTag DICOMBurnedInAnnotation (0x0028, 0x0301);
const DICOMTag DICOMRecognizableVisualFeatures (0x0028, 0x0302);
const DICOMTag DICOMLongitudinalTemporalInformationModified (0x0028, 0x0303);
const DICOMTag DICOMReferencedColorPaletteInstanceUID (0x0028, 0x0304);
const DICOMTag DICOMRETIREDTransformLabel (0x0028, 0x0400);
const DICOMTag DICOMRETIREDTransformVersionNumber (0x0028, 0x0401);
const DICOMTag DICOMRETIREDNumberOfTransformSteps (0x0028, 0x0402);
const DICOMTag DICOMRETIREDSequenceOfCompressedData (0x0028, 0x0403);
const DICOMTag DICOMRETIREDDetailsOfCoefficients (0x0028, 0x0404);
const DICOMTag DICOMACR_NEMA_2C_RowsForNthOrderCoefficients (0x0028, 0x0410);
const DICOMTag DICOMACR_NEMA_2C_ColumnsForNthOrderCoefficients (0x0028, 0x0411);
const DICOMTag DICOMACR_NEMA_2C_CoefficientCoding (0x0028, 0x0412);
const DICOMTag DICOMACR_NEMA_2C_CoefficientCodingPointers (0x0028, 0x0413);
const DICOMTag DICOMRETIREDDCTLabel (0x0028, 0x0700);
const DICOMTag DICOMRETIREDDataBlockDescription (0x0028, 0x0701);
const DICOMTag DICOMRETIREDDataBlock (0x0028, 0x0702);
const DICOMTag DICOMRETIREDNormalizationFactorFormat (0x0028, 0x0710);
const DICOMTag DICOMRETIREDZonalMapNumberFormat (0x0028, 0x0720);
const DICOMTag DICOMRETIREDZonalMapLocation (0x0028, 0x0721);
const DICOMTag DICOMRETIREDZonalMapFormat (0x0028, 0x0722);
const DICOMTag DICOMRETIREDAdaptiveMapFormat (0x0028, 0x0730);
const DICOMTag DICOMRETIREDCodeNumberFormat (0x0028, 0x0740);
const DICOMTag DICOMACR_NEMA_2C_CodeLabel (0x0028, 0x0800);
const DICOMTag DICOMACR_NEMA_2C_NumberOfTables (0x0028, 0x0802);
const DICOMTag DICOMACR_NEMA_2C_CodeTableLocation (0x0028, 0x0803);
const DICOMTag DICOMACR_NEMA_2C_BitsForCodeWord (0x0028, 0x0804);
const DICOMTag DICOMACR_NEMA_2C_ImageDataLocation (0x0028, 0x0808);
const DICOMTag DICOMPixelSpacingCalibrationType (0x0028, 0x0a02);
const DICOMTag DICOMPixelSpacingCalibrationDescription (0x0028, 0x0a04);
const DICOMTag DICOMPixelIntensityRelationship (0x0028, 0x1040);
const DICOMTag DICOMPixelIntensityRelationshipSign (0x0028, 0x1041);
const DICOMTag DICOMWindowCenter (0x0028, 0x1050);
const DICOMTag DICOMWindowWidth (0x0028, 0x1051);
const DICOMTag DICOMRescaleIntercept (0x0028, 0x1052);
const DICOMTag DICOMRescaleSlope (0x0028, 0x1053);
const DICOMTag DICOMRescaleType (0x0028, 0x1054);
const DICOMTag DICOMWindowCenterWidthExplanation (0x0028, 0x1055);
const DICOMTag DICOMVOILUTFunction (0x0028, 0x1056);
const DICOMTag DICOMRETIREDGrayScale (0x0028, 0x1080);
const DICOMTag DICOMRecommendedViewingMode (0x0028, 0x1090);
const DICOMTag DICOMRETIREDGrayLookupTableDescriptor (0x0028, 0x1100);
const DICOMTag DICOMRedPaletteColorLookupTableDescriptor (0x0028, 0x1101);
const DICOMTag DICOMGreenPaletteColorLookupTableDescriptor (0x0028, 0x1102);
const DICOMTag DICOMBluePaletteColorLookupTableDescriptor (0x0028, 0x1103);
const DICOMTag DICOMAlphaPaletteColorLookupTableDescriptor (0x0028, 0x1104);
const DICOMTag DICOMRETIREDLargeRedPaletteColorLookupTableDescriptor (0x0028, 0x1111);
const DICOMTag DICOMRETIREDLargeGreenPaletteColorLookupTableDescriptor (0x0028, 0x1112);
const DICOMTag DICOMRETIREDLargeBluePaletteColorLookupTableDescriptor (0x0028, 0x1113);
const DICOMTag DICOMPaletteColorLookupTableUID (0x0028, 0x1199);
const DICOMTag DICOMRETIREDGrayLookupTableData (0x0028, 0x1200);
const DICOMTag DICOMRedPaletteColorLookupTableData (0x0028, 0x1201);
const DICOMTag DICOMGreenPaletteColorLookupTableData (0x0028, 0x1202);
const DICOMTag DICOMBluePaletteColorLookupTableData (0x0028, 0x1203);
const DICOMTag DICOMAlphaPaletteColorLookupTableData (0x0028, 0x1204);
const DICOMTag DICOMRETIREDLargeRedPaletteColorLookupTableData (0x0028, 0x1211);
const DICOMTag DICOMRETIREDLargeGreenPaletteColorLookupTableData (0x0028, 0x1212);
const DICOMTag DICOMRETIREDLargeBluePaletteColorLookupTableData (0x0028, 0x1213);
const DICOMTag DICOMRETIREDLargePaletteColorLookupTableUID (0x0028, 0x1214);
const DICOMTag DICOMSegmentedRedPaletteColorLookupTableData (0x0028, 0x1221);
const DICOMTag DICOMSegmentedGreenPaletteColorLookupTableData (0x0028, 0x1222);
const DICOMTag DICOMSegmentedBluePaletteColorLookupTableData (0x0028, 0x1223);
const DICOMTag DICOMBreastImplantPresent (0x0028, 0x1300);
const DICOMTag DICOMPartialView (0x0028, 0x1350);
const DICOMTag DICOMPartialViewDescription (0x0028, 0x1351);
const DICOMTag DICOMPartialViewCodeSequence (0x0028, 0x1352);
const DICOMTag DICOMSpatialLocationsPreserved (0x0028, 0x135a);
const DICOMTag DICOMDataFrameAssignmentSequence (0x0028, 0x1401);
const DICOMTag DICOMDataPathAssignment (0x0028, 0x1402);
const DICOMTag DICOMBitsMappedToColorLookupTable (0x0028, 0x1403);
const DICOMTag DICOMBlendingLUT1Sequence (0x0028, 0x1404);
const DICOMTag DICOMBlendingLUT1TransferFunction (0x0028, 0x1405);
const DICOMTag DICOMBlendingWeightConstant (0x0028, 0x1406);
const DICOMTag DICOMBlendingLookupTableDescriptor (0x0028, 0x1407);
const DICOMTag DICOMBlendingLookupTableData (0x0028, 0x1408);
const DICOMTag DICOMEnhancedPaletteColorLookupTableSequence (0x0028, 0x140b);
const DICOMTag DICOMBlendingLUT2Sequence (0x0028, 0x140c);
const DICOMTag DICOMBlendingLUT2TransferFunction (0x0028, 0x140d);
const DICOMTag DICOMDataPathID (0x0028, 0x140e);
const DICOMTag DICOMRGBLUTTransferFunction (0x0028, 0x140f);
const DICOMTag DICOMAlphaLUTTransferFunction (0x0028, 0x1410);
const DICOMTag DICOMICCProfile (0x0028, 0x2000);
const DICOMTag DICOMLossyImageCompression (0x0028, 0x2110);
const DICOMTag DICOMLossyImageCompressionRatio (0x0028, 0x2112);
const DICOMTag DICOMLossyImageCompressionMethod (0x0028, 0x2114);
const DICOMTag DICOMModalityLUTSequence (0x0028, 0x3000);
const DICOMTag DICOMLUTDescriptor (0x0028, 0x3002);
const DICOMTag DICOMLUTExplanation (0x0028, 0x3003);
const DICOMTag DICOMModalityLUTType (0x0028, 0x3004);
const DICOMTag DICOMLUTData (0x0028, 0x3006);
const DICOMTag DICOMVOILUTSequence (0x0028, 0x3010);
const DICOMTag DICOMSoftcopyVOILUTSequence (0x0028, 0x3110);
const DICOMTag DICOMRETIREDImagePresentationComments (0x0028, 0x4000);
const DICOMTag DICOMRETIREDBiPlaneAcquisitionSequence (0x0028, 0x5000);
const DICOMTag DICOMRepresentativeFrameNumber (0x0028, 0x6010);
const DICOMTag DICOMFrameNumbersOfInterest (0x0028, 0x6020);
const DICOMTag DICOMFrameOfInterestDescription (0x0028, 0x6022);
const DICOMTag DICOMFrameOfInterestType (0x0028, 0x6023);
const DICOMTag DICOMRETIREDMaskPointers (0x0028, 0x6030);
const DICOMTag DICOMRWavePointer (0x0028, 0x6040);
const DICOMTag DICOMMaskSubtractionSequence (0x0028, 0x6100);
const DICOMTag DICOMMaskOperation (0x0028, 0x6101);
const DICOMTag DICOMApplicableFrameRange (0x0028, 0x6102);
const DICOMTag DICOMMaskFrameNumbers (0x0028, 0x6110);
const DICOMTag DICOMContrastFrameAveraging (0x0028, 0x6112);
const DICOMTag DICOMMaskSubPixelShift (0x0028, 0x6114);
const DICOMTag DICOMTIDOffset (0x0028, 0x6120);
const DICOMTag DICOMMaskOperationExplanation (0x0028, 0x6190);
const DICOMTag DICOMPixelDataProviderURL (0x0028, 0x7fe0);
const DICOMTag DICOMDataPointRows (0x0028, 0x9001);
const DICOMTag DICOMDataPointColumns (0x0028, 0x9002);
const DICOMTag DICOMSignalDomainColumns (0x0028, 0x9003);
const DICOMTag DICOMRETIREDLargestMonochromePixelValue (0x0028, 0x9099);
const DICOMTag DICOMDataRepresentation (0x0028, 0x9108);
const DICOMTag DICOMPixelMeasuresSequence (0x0028, 0x9110);
const DICOMTag DICOMFrameVOILUTSequence (0x0028, 0x9132);
const DICOMTag DICOMPixelValueTransformationSequence (0x0028, 0x9145);
const DICOMTag DICOMSignalDomainRows (0x0028, 0x9235);
const DICOMTag DICOMDisplayFilterPercentage (0x0028, 0x9411);
const DICOMTag DICOMFramePixelShiftSequence (0x0028, 0x9415);
const DICOMTag DICOMSubtractionItemID (0x0028, 0x9416);
const DICOMTag DICOMPixelIntensityRelationshipLUTSequence (0x0028, 0x9422);
const DICOMTag DICOMFramePixelDataPropertiesSequence (0x0028, 0x9443);
const DICOMTag DICOMGeometricalProperties (0x0028, 0x9444);
const DICOMTag DICOMGeometricMaximumDistortion (0x0028, 0x9445);
const DICOMTag DICOMImageProcessingApplied (0x0028, 0x9446);
const DICOMTag DICOMMaskSelectionMode (0x0028, 0x9454);
const DICOMTag DICOMLUTFunction (0x0028, 0x9474);
const DICOMTag DICOMMaskVisibilityPercentage (0x0028, 0x9478);
const DICOMTag DICOMPixelShiftSequence (0x0028, 0x9501);
const DICOMTag DICOMRegionPixelShiftSequence (0x0028, 0x9502);
const DICOMTag DICOMVerticesOfTheRegion (0x0028, 0x9503);
const DICOMTag DICOMMultiFramePresentationSequence (0x0028, 0x9505);
const DICOMTag DICOMPixelShiftFrameRange (0x0028, 0x9506);
const DICOMTag DICOMLUTFrameRange (0x0028, 0x9507);
const DICOMTag DICOMImageToEquipmentMappingMatrix (0x0028, 0x9520);
const DICOMTag DICOMEquipmentCoordinateSystemIdentification (0x0028, 0x9537);
const DICOMTag DICOMRETIREDStudyStatusID (0x0032, 0x000a);
const DICOMTag DICOMRETIREDStudyPriorityID (0x0032, 0x000c);
const DICOMTag DICOMRETIREDStudyIDIssuer (0x0032, 0x0012);
const DICOMTag DICOMRETIREDStudyVerifiedDate (0x0032, 0x0032);
const DICOMTag DICOMRETIREDStudyVerifiedTime (0x0032, 0x0033);
const DICOMTag DICOMRETIREDStudyReadDate (0x0032, 0x0034);
const DICOMTag DICOMRETIREDStudyReadTime (0x0032, 0x0035);
const DICOMTag DICOMRETIREDScheduledStudyStartDate (0x0032, 0x1000);
const DICOMTag DICOMRETIREDScheduledStudyStartTime (0x0032, 0x1001);
const DICOMTag DICOMRETIREDScheduledStudyStopDate (0x0032, 0x1010);
const DICOMTag DICOMRETIREDScheduledStudyStopTime (0x0032, 0x1011);
const DICOMTag DICOMRETIREDScheduledStudyLocation (0x0032, 0x1020);
const DICOMTag DICOMRETIREDScheduledStudyLocationAETitle (0x0032, 0x1021);
const DICOMTag DICOMRETIREDReasonForStudy (0x0032, 0x1030);
const DICOMTag DICOMRequestingPhysicianIdentificationSequence (0x0032, 0x1031);
const DICOMTag DICOMRequestingPhysician (0x0032, 0x1032);
const DICOMTag DICOMRequestingService (0x0032, 0x1033);
const DICOMTag DICOMRequestingServiceCodeSequence (0x0032, 0x1034);
const DICOMTag DICOMRETIREDStudyArrivalDate (0x0032, 0x1040);
const DICOMTag DICOMRETIREDStudyArrivalTime (0x0032, 0x1041);
const DICOMTag DICOMRETIREDStudyCompletionDate (0x0032, 0x1050);
const DICOMTag DICOMRETIREDStudyCompletionTime (0x0032, 0x1051);
const DICOMTag DICOMRETIREDStudyComponentStatusID (0x0032, 0x1055);
const DICOMTag DICOMRequestedProcedureDescription (0x0032, 0x1060);
const DICOMTag DICOMRequestedProcedureCodeSequence (0x0032, 0x1064);
const DICOMTag DICOMRequestedContrastAgent (0x0032, 0x1070);
const DICOMTag DICOMRETIREDStudyComments (0x0032, 0x4000);
const DICOMTag DICOMReferencedPatientAliasSequence (0x0038, 0x0004);
const DICOMTag DICOMVisitStatusID (0x0038, 0x0008);
const DICOMTag DICOMAdmissionID (0x0038, 0x0010);
const DICOMTag DICOMRETIREDIssuerOfAdmissionID (0x0038, 0x0011);
const DICOMTag DICOMIssuerOfAdmissionIDSequence (0x0038, 0x0014);
const DICOMTag DICOMRouteOfAdmissions (0x0038, 0x0016);
const DICOMTag DICOMRETIREDScheduledAdmissionDate (0x0038, 0x001a);
const DICOMTag DICOMRETIREDScheduledAdmissionTime (0x0038, 0x001b);
const DICOMTag DICOMRETIREDScheduledDischargeDate (0x0038, 0x001c);
const DICOMTag DICOMRETIREDScheduledDischargeTime (0x0038, 0x001d);
const DICOMTag DICOMRETIREDScheduledPatientInstitutionResidence (0x0038, 0x001e);
const DICOMTag DICOMAdmittingDate (0x0038, 0x0020);
const DICOMTag DICOMAdmittingTime (0x0038, 0x0021);
const DICOMTag DICOMRETIREDDischargeDate (0x0038, 0x0030);
const DICOMTag DICOMRETIREDDischargeTime (0x0038, 0x0032);
const DICOMTag DICOMRETIREDDischargeDiagnosisDescription (0x0038, 0x0040);
const DICOMTag DICOMRETIREDDischargeDiagnosisCodeSequence (0x0038, 0x0044);
const DICOMTag DICOMSpecialNeeds (0x0038, 0x0050);
const DICOMTag DICOMServiceEpisodeID (0x0038, 0x0060);
const DICOMTag DICOMRETIREDIssuerOfServiceEpisodeID (0x0038, 0x0061);
const DICOMTag DICOMServiceEpisodeDescription (0x0038, 0x0062);
const DICOMTag DICOMIssuerOfServiceEpisodeIDSequence (0x0038, 0x0064);
const DICOMTag DICOMPertinentDocumentsSequence (0x0038, 0x0100);
const DICOMTag DICOMCurrentPatientLocation (0x0038, 0x0300);
const DICOMTag DICOMPatientInstitutionResidence (0x0038, 0x0400);
const DICOMTag DICOMPatientState (0x0038, 0x0500);
const DICOMTag DICOMPatientClinicalTrialParticipationSequence (0x0038, 0x0502);
const DICOMTag DICOMVisitComments (0x0038, 0x4000);
const DICOMTag DICOMWaveformOriginality (0x003a, 0x0004);
const DICOMTag DICOMNumberOfWaveformChannels (0x003a, 0x0005);
const DICOMTag DICOMNumberOfWaveformSamples (0x003a, 0x0010);
const DICOMTag DICOMSamplingFrequency (0x003a, 0x001a);
const DICOMTag DICOMMultiplexGroupLabel (0x003a, 0x0020);
const DICOMTag DICOMChannelDefinitionSequence (0x003a, 0x0200);
const DICOMTag DICOMWaveformChannelNumber (0x003a, 0x0202);
const DICOMTag DICOMChannelLabel (0x003a, 0x0203);
const DICOMTag DICOMChannelStatus (0x003a, 0x0205);
const DICOMTag DICOMChannelSourceSequence (0x003a, 0x0208);
const DICOMTag DICOMChannelSourceModifiersSequence (0x003a, 0x0209);
const DICOMTag DICOMSourceWaveformSequence (0x003a, 0x020a);
const DICOMTag DICOMChannelDerivationDescription (0x003a, 0x020c);
const DICOMTag DICOMChannelSensitivity (0x003a, 0x0210);
const DICOMTag DICOMChannelSensitivityUnitsSequence (0x003a, 0x0211);
const DICOMTag DICOMChannelSensitivityCorrectionFactor (0x003a, 0x0212);
const DICOMTag DICOMChannelBaseline (0x003a, 0x0213);
const DICOMTag DICOMChannelTimeSkew (0x003a, 0x0214);
const DICOMTag DICOMChannelSampleSkew (0x003a, 0x0215);
const DICOMTag DICOMChannelOffset (0x003a, 0x0218);
const DICOMTag DICOMWaveformBitsStored (0x003a, 0x021a);
const DICOMTag DICOMFilterLowFrequency (0x003a, 0x0220);
const DICOMTag DICOMFilterHighFrequency (0x003a, 0x0221);
const DICOMTag DICOMNotchFilterFrequency (0x003a, 0x0222);
const DICOMTag DICOMNotchFilterBandwidth (0x003a, 0x0223);
const DICOMTag DICOMWaveformDataDisplayScale (0x003a, 0x0230);
const DICOMTag DICOMWaveformDisplayBackgroundCIELabValue (0x003a, 0x0231);
const DICOMTag DICOMWaveformPresentationGroupSequence (0x003a, 0x0240);
const DICOMTag DICOMPresentationGroupNumber (0x003a, 0x0241);
const DICOMTag DICOMChannelDisplaySequence (0x003a, 0x0242);
const DICOMTag DICOMChannelRecommendedDisplayCIELabValue (0x003a, 0x0244);
const DICOMTag DICOMChannelPosition (0x003a, 0x0245);
const DICOMTag DICOMDisplayShadingFlag (0x003a, 0x0246);
const DICOMTag DICOMFractionalChannelDisplayScale (0x003a, 0x0247);
const DICOMTag DICOMAbsoluteChannelDisplayScale (0x003a, 0x0248);
const DICOMTag DICOMMultiplexedAudioChannelsDescriptionCodeSequence (0x003a, 0x0300);
const DICOMTag DICOMChannelIdentificationCode (0x003a, 0x0301);
const DICOMTag DICOMChannelMode (0x003a, 0x0302);
const DICOMTag DICOMScheduledStationAETitle (0x0040, 0x0001);
const DICOMTag DICOMScheduledProcedureStepStartDate (0x0040, 0x0002);
const DICOMTag DICOMScheduledProcedureStepStartTime (0x0040, 0x0003);
const DICOMTag DICOMScheduledProcedureStepEndDate (0x0040, 0x0004);
const DICOMTag DICOMScheduledProcedureStepEndTime (0x0040, 0x0005);
const DICOMTag DICOMScheduledPerformingPhysicianName (0x0040, 0x0006);
const DICOMTag DICOMScheduledProcedureStepDescription (0x0040, 0x0007);
const DICOMTag DICOMScheduledProtocolCodeSequence (0x0040, 0x0008);
const DICOMTag DICOMScheduledProcedureStepID (0x0040, 0x0009);
const DICOMTag DICOMStageCodeSequence (0x0040, 0x000a);
const DICOMTag DICOMScheduledPerformingPhysicianIdentificationSequence (0x0040, 0x000b);
const DICOMTag DICOMScheduledStationName (0x0040, 0x0010);
const DICOMTag DICOMScheduledProcedureStepLocation (0x0040, 0x0011);
const DICOMTag DICOMPreMedication (0x0040, 0x0012);
const DICOMTag DICOMScheduledProcedureStepStatus (0x0040, 0x0020);
const DICOMTag DICOMOrderPlacerIdentifierSequence (0x0040, 0x0026);
const DICOMTag DICOMOrderFillerIdentifierSequence (0x0040, 0x0027);
const DICOMTag DICOMLocalNamespaceEntityID (0x0040, 0x0031);
const DICOMTag DICOMUniversalEntityID (0x0040, 0x0032);
const DICOMTag DICOMUniversalEntityIDType (0x0040, 0x0033);
const DICOMTag DICOMIdentifierTypeCode (0x0040, 0x0035);
const DICOMTag DICOMAssigningFacilitySequence (0x0040, 0x0036);
const DICOMTag DICOMAssigningJurisdictionCodeSequence (0x0040, 0x0039);
const DICOMTag DICOMAssigningAgencyOrDepartmentCodeSequence (0x0040, 0x003a);
const DICOMTag DICOMScheduledProcedureStepSequence (0x0040, 0x0100);
const DICOMTag DICOMReferencedNonImageCompositeSOPInstanceSequence (0x0040, 0x0220);
const DICOMTag DICOMPerformedStationAETitle (0x0040, 0x0241);
const DICOMTag DICOMPerformedStationName (0x0040, 0x0242);
const DICOMTag DICOMPerformedLocation (0x0040, 0x0243);
const DICOMTag DICOMPerformedProcedureStepStartDate (0x0040, 0x0244);
const DICOMTag DICOMPerformedProcedureStepStartTime (0x0040, 0x0245);
const DICOMTag DICOMPerformedProcedureStepEndDate (0x0040, 0x0250);
const DICOMTag DICOMPerformedProcedureStepEndTime (0x0040, 0x0251);
const DICOMTag DICOMPerformedProcedureStepStatus (0x0040, 0x0252);
const DICOMTag DICOMPerformedProcedureStepID (0x0040, 0x0253);
const DICOMTag DICOMPerformedProcedureStepDescription (0x0040, 0x0254);
const DICOMTag DICOMPerformedProcedureTypeDescription (0x0040, 0x0255);
const DICOMTag DICOMPerformedProtocolCodeSequence (0x0040, 0x0260);
const DICOMTag DICOMPerformedProtocolType (0x0040, 0x0261);
const DICOMTag DICOMScheduledStepAttributesSequence (0x0040, 0x0270);
const DICOMTag DICOMRequestAttributesSequence (0x0040, 0x0275);
const DICOMTag DICOMCommentsOnThePerformedProcedureStep (0x0040, 0x0280);
const DICOMTag DICOMPerformedProcedureStepDiscontinuationReasonCodeSequence (0x0040, 0x0281);
const DICOMTag DICOMQuantitySequence (0x0040, 0x0293);
const DICOMTag DICOMQuantity (0x0040, 0x0294);
const DICOMTag DICOMMeasuringUnitsSequence (0x0040, 0x0295);
const DICOMTag DICOMBillingItemSequence (0x0040, 0x0296);
const DICOMTag DICOMTotalTimeOfFluoroscopy (0x0040, 0x0300);
const DICOMTag DICOMTotalNumberOfExposures (0x0040, 0x0301);
const DICOMTag DICOMEntranceDose (0x0040, 0x0302);
const DICOMTag DICOMExposedArea (0x0040, 0x0303);
const DICOMTag DICOMDistanceSourceToEntrance (0x0040, 0x0306);
const DICOMTag DICOMRETIREDDistanceSourceToSupport (0x0040, 0x0307);
const DICOMTag DICOMExposureDoseSequence (0x0040, 0x030e);
const DICOMTag DICOMCommentsOnRadiationDose (0x0040, 0x0310);
const DICOMTag DICOMXRayOutput (0x0040, 0x0312);
const DICOMTag DICOMHalfValueLayer (0x0040, 0x0314);
const DICOMTag DICOMOrganDose (0x0040, 0x0316);
const DICOMTag DICOMOrganExposed (0x0040, 0x0318);
const DICOMTag DICOMBillingProcedureStepSequence (0x0040, 0x0320);
const DICOMTag DICOMFilmConsumptionSequence (0x0040, 0x0321);
const DICOMTag DICOMBillingSuppliesAndDevicesSequence (0x0040, 0x0324);
const DICOMTag DICOMRETIREDReferencedProcedureStepSequence (0x0040, 0x0330);
const DICOMTag DICOMPerformedSeriesSequence (0x0040, 0x0340);
const DICOMTag DICOMCommentsOnTheScheduledProcedureStep (0x0040, 0x0400);
const DICOMTag DICOMProtocolContextSequence (0x0040, 0x0440);
const DICOMTag DICOMContentItemModifierSequence (0x0040, 0x0441);
const DICOMTag DICOMScheduledSpecimenSequence (0x0040, 0x0500);
const DICOMTag DICOMRETIREDSpecimenAccessionNumber (0x0040, 0x050a);
const DICOMTag DICOMContainerIdentifier (0x0040, 0x0512);
const DICOMTag DICOMIssuerOfTheContainerIdentifierSequence (0x0040, 0x0513);
const DICOMTag DICOMAlternateContainerIdentifierSequence (0x0040, 0x0515);
const DICOMTag DICOMContainerTypeCodeSequence (0x0040, 0x0518);
const DICOMTag DICOMContainerDescription (0x0040, 0x051a);
const DICOMTag DICOMContainerComponentSequence (0x0040, 0x0520);
const DICOMTag DICOMRETIREDSpecimenSequence (0x0040, 0x0550);
const DICOMTag DICOMSpecimenIdentifier (0x0040, 0x0551);
const DICOMTag DICOMRETIREDSpecimenDescriptionSequenceTrial (0x0040, 0x0552);
const DICOMTag DICOMRETIREDSpecimenDescriptionTrial (0x0040, 0x0553);
const DICOMTag DICOMSpecimenUID (0x0040, 0x0554);
const DICOMTag DICOMAcquisitionContextSequence (0x0040, 0x0555);
const DICOMTag DICOMAcquisitionContextDescription (0x0040, 0x0556);
const DICOMTag DICOMSpecimenDescriptionSequence (0x0040, 0x0560);
const DICOMTag DICOMIssuerOfTheSpecimenIdentifierSequence (0x0040, 0x0562);
const DICOMTag DICOMSpecimenTypeCodeSequence (0x0040, 0x059a);
const DICOMTag DICOMSpecimenShortDescription (0x0040, 0x0600);
const DICOMTag DICOMSpecimenDetailedDescription (0x0040, 0x0602);
const DICOMTag DICOMSpecimenPreparationSequence (0x0040, 0x0610);
const DICOMTag DICOMSpecimenPreparationStepContentItemSequence (0x0040, 0x0612);
const DICOMTag DICOMSpecimenLocalizationContentItemSequence (0x0040, 0x0620);
const DICOMTag DICOMRETIREDSlideIdentifier (0x0040, 0x06fa);
const DICOMTag DICOMImageCenterPointCoordinatesSequence (0x0040, 0x071a);
const DICOMTag DICOMXOffsetInSlideCoordinateSystem (0x0040, 0x072a);
const DICOMTag DICOMYOffsetInSlideCoordinateSystem (0x0040, 0x073a);
const DICOMTag DICOMZOffsetInSlideCoordinateSystem (0x0040, 0x074a);
const DICOMTag DICOMRETIREDPixelSpacingSequence (0x0040, 0x08d8);
const DICOMTag DICOMRETIREDCoordinateSystemAxisCodeSequence (0x0040, 0x08da);
const DICOMTag DICOMMeasurementUnitsCodeSequence (0x0040, 0x08ea);
const DICOMTag DICOMRETIREDVitalStainCodeSequenceTrial (0x0040, 0x09f8);
const DICOMTag DICOMRequestedProcedureID (0x0040, 0x1001);
const DICOMTag DICOMReasonForTheRequestedProcedure (0x0040, 0x1002);
const DICOMTag DICOMRequestedProcedurePriority (0x0040, 0x1003);
const DICOMTag DICOMPatientTransportArrangements (0x0040, 0x1004);
const DICOMTag DICOMRequestedProcedureLocation (0x0040, 0x1005);
const DICOMTag DICOMRETIREDPlacerOrderNumberProcedure (0x0040, 0x1006);
const DICOMTag DICOMRETIREDFillerOrderNumberProcedure (0x0040, 0x1007);
const DICOMTag DICOMConfidentialityCode (0x0040, 0x1008);
const DICOMTag DICOMReportingPriority (0x0040, 0x1009);
const DICOMTag DICOMReasonForRequestedProcedureCodeSequence (0x0040, 0x100a);
const DICOMTag DICOMNamesOfIntendedRecipientsOfResults (0x0040, 0x1010);
const DICOMTag DICOMIntendedRecipientsOfResultsIdentificationSequence (0x0040, 0x1011);
const DICOMTag DICOMReasonForPerformedProcedureCodeSequence (0x0040, 0x1012);
const DICOMTag DICOMRETIREDRequestedProcedureDescriptionTrial (0x0040, 0x1060);
const DICOMTag DICOMPersonIdentificationCodeSequence (0x0040, 0x1101);
const DICOMTag DICOMPersonAddress (0x0040, 0x1102);
const DICOMTag DICOMPersonTelephoneNumbers (0x0040, 0x1103);
const DICOMTag DICOMRequestedProcedureComments (0x0040, 0x1400);
const DICOMTag DICOMRETIREDReasonForTheImagingServiceRequest (0x0040, 0x2001);
const DICOMTag DICOMIssueDateOfImagingServiceRequest (0x0040, 0x2004);
const DICOMTag DICOMIssueTimeOfImagingServiceRequest (0x0040, 0x2005);
const DICOMTag DICOMRETIREDPlacerOrderNumberImagingServiceRequestRetired (0x0040, 0x2006);
const DICOMTag DICOMRETIREDFillerOrderNumberImagingServiceRequestRetired (0x0040, 0x2007);
const DICOMTag DICOMOrderEnteredBy (0x0040, 0x2008);
const DICOMTag DICOMOrderEntererLocation (0x0040, 0x2009);
const DICOMTag DICOMOrderCallbackPhoneNumber (0x0040, 0x2010);
const DICOMTag DICOMPlacerOrderNumberImagingServiceRequest (0x0040, 0x2016);
const DICOMTag DICOMFillerOrderNumberImagingServiceRequest (0x0040, 0x2017);
const DICOMTag DICOMImagingServiceRequestComments (0x0040, 0x2400);
const DICOMTag DICOMConfidentialityConstraintOnPatientDataDescription (0x0040, 0x3001);
const DICOMTag DICOMGeneralPurposeScheduledProcedureStepStatus (0x0040, 0x4001);
const DICOMTag DICOMGeneralPurposePerformedProcedureStepStatus (0x0040, 0x4002);
const DICOMTag DICOMGeneralPurposeScheduledProcedureStepPriority (0x0040, 0x4003);
const DICOMTag DICOMScheduledProcessingApplicationsCodeSequence (0x0040, 0x4004);
const DICOMTag DICOMScheduledProcedureStepStartDateTime (0x0040, 0x4005);
const DICOMTag DICOMMultipleCopiesFlag (0x0040, 0x4006);
const DICOMTag DICOMPerformedProcessingApplicationsCodeSequence (0x0040, 0x4007);
const DICOMTag DICOMHumanPerformerCodeSequence (0x0040, 0x4009);
const DICOMTag DICOMScheduledProcedureStepModificationDateTime (0x0040, 0x4010);
const DICOMTag DICOMExpectedCompletionDateTime (0x0040, 0x4011);
const DICOMTag DICOMResultingGeneralPurposePerformedProcedureStepsSequence (0x0040, 0x4015);
const DICOMTag DICOMReferencedGeneralPurposeScheduledProcedureStepSequence (0x0040, 0x4016);
const DICOMTag DICOMScheduledWorkitemCodeSequence (0x0040, 0x4018);
const DICOMTag DICOMPerformedWorkitemCodeSequence (0x0040, 0x4019);
const DICOMTag DICOMInputAvailabilityFlag (0x0040, 0x4020);
const DICOMTag DICOMInputInformationSequence (0x0040, 0x4021);
const DICOMTag DICOMRelevantInformationSequence (0x0040, 0x4022);
const DICOMTag DICOMReferencedGeneralPurposeScheduledProcedureStepTransactionUID (0x0040, 0x4023);
const DICOMTag DICOMScheduledStationNameCodeSequence (0x0040, 0x4025);
const DICOMTag DICOMScheduledStationClassCodeSequence (0x0040, 0x4026);
const DICOMTag DICOMScheduledStationGeographicLocationCodeSequence (0x0040, 0x4027);
const DICOMTag DICOMPerformedStationNameCodeSequence (0x0040, 0x4028);
const DICOMTag DICOMPerformedStationClassCodeSequence (0x0040, 0x4029);
const DICOMTag DICOMPerformedStationGeographicLocationCodeSequence (0x0040, 0x4030);
const DICOMTag DICOMRequestedSubsequentWorkitemCodeSequence (0x0040, 0x4031);
const DICOMTag DICOMNonDICOMOutputCodeSequence (0x0040, 0x4032);
const DICOMTag DICOMOutputInformationSequence (0x0040, 0x4033);
const DICOMTag DICOMScheduledHumanPerformersSequence (0x0040, 0x4034);
const DICOMTag DICOMActualHumanPerformersSequence (0x0040, 0x4035);
const DICOMTag DICOMHumanPerformerOrganization (0x0040, 0x4036);
const DICOMTag DICOMHumanPerformerName (0x0040, 0x4037);
const DICOMTag DICOMRawDataHandling (0x0040, 0x4040);
const DICOMTag DICOMInputReadinessState (0x0040, 0x4041);
const DICOMTag DICOMPerformedProcedureStepStartDateTime (0x0040, 0x4050);
const DICOMTag DICOMPerformedProcedureStepEndDateTime (0x0040, 0x4051);
const DICOMTag DICOMProcedureStepCancellationDateTime (0x0040, 0x4052);
const DICOMTag DICOMEntranceDoseInmGy (0x0040, 0x8302);
const DICOMTag DICOMReferencedImageRealWorldValueMappingSequence (0x0040, 0x9094);
const DICOMTag DICOMRealWorldValueMappingSequence (0x0040, 0x9096);
const DICOMTag DICOMPixelValueMappingCodeSequence (0x0040, 0x9098);
const DICOMTag DICOMLUTLabel (0x0040, 0x9210);
const DICOMTag DICOMRealWorldValueLastValueMapped (0x0040, 0x9211);
const DICOMTag DICOMRealWorldValueLUTData (0x0040, 0x9212);
const DICOMTag DICOMRealWorldValueFirstValueMapped (0x0040, 0x9216);
const DICOMTag DICOMRealWorldValueIntercept (0x0040, 0x9224);
const DICOMTag DICOMRealWorldValueSlope (0x0040, 0x9225);
const DICOMTag DICOMRETIREDFindingsFlagTrial (0x0040, 0xa007);
const DICOMTag DICOMRelationshipType (0x0040, 0xa010);
const DICOMTag DICOMRETIREDFindingsSequenceTrial (0x0040, 0xa020);
const DICOMTag DICOMRETIREDFindingsGroupUIDTrial (0x0040, 0xa021);
const DICOMTag DICOMRETIREDReferencedFindingsGroupUIDTrial (0x0040, 0xa022);
const DICOMTag DICOMRETIREDFindingsGroupRecordingDateTrial (0x0040, 0xa023);
const DICOMTag DICOMRETIREDFindingsGroupRecordingTimeTrial (0x0040, 0xa024);
const DICOMTag DICOMRETIREDFindingsSourceCategoryCodeSequenceTrial (0x0040, 0xa026);
const DICOMTag DICOMVerifyingOrganization (0x0040, 0xa027);
const DICOMTag DICOMRETIREDDocumentingOrganizationIdentifierCodeSequenceTrial (0x0040, 0xa028);
const DICOMTag DICOMVerificationDateTime (0x0040, 0xa030);
const DICOMTag DICOMObservationDateTime (0x0040, 0xa032);
const DICOMTag DICOMValueType (0x0040, 0xa040);
const DICOMTag DICOMConceptNameCodeSequence (0x0040, 0xa043);
const DICOMTag DICOMRETIREDMeasurementPrecisionDescriptionTrial (0x0040, 0xa047);
const DICOMTag DICOMContinuityOfContent (0x0040, 0xa050);
const DICOMTag DICOMRETIREDUrgencyOrPriorityAlertsTrial (0x0040, 0xa057);
const DICOMTag DICOMRETIREDSequencingIndicatorTrial (0x0040, 0xa060);
const DICOMTag DICOMRETIREDDocumentIdentifierCodeSequenceTrial (0x0040, 0xa066);
const DICOMTag DICOMRETIREDDocumentAuthorTrial (0x0040, 0xa067);
const DICOMTag DICOMRETIREDDocumentAuthorIdentifierCodeSequenceTrial (0x0040, 0xa068);
const DICOMTag DICOMRETIREDIdentifierCodeSequenceTrial (0x0040, 0xa070);
const DICOMTag DICOMVerifyingObserverSequence (0x0040, 0xa073);
const DICOMTag DICOMRETIREDObjectBinaryIdentifierTrial (0x0040, 0xa074);
const DICOMTag DICOMVerifyingObserverName (0x0040, 0xa075);
const DICOMTag DICOMRETIREDDocumentingObserverIdentifierCodeSequenceTrial (0x0040, 0xa076);
const DICOMTag DICOMAuthorObserverSequence (0x0040, 0xa078);
const DICOMTag DICOMParticipantSequence (0x0040, 0xa07a);
const DICOMTag DICOMCustodialOrganizationSequence (0x0040, 0xa07c);
const DICOMTag DICOMParticipationType (0x0040, 0xa080);
const DICOMTag DICOMParticipationDateTime (0x0040, 0xa082);
const DICOMTag DICOMObserverType (0x0040, 0xa084);
const DICOMTag DICOMRETIREDProcedureIdentifierCodeSequenceTrial (0x0040, 0xa085);
const DICOMTag DICOMVerifyingObserverIdentificationCodeSequence (0x0040, 0xa088);
const DICOMTag DICOMRETIREDObjectDirectoryBinaryIdentifierTrial (0x0040, 0xa089);
const DICOMTag DICOMRETIREDEquivalentCDADocumentSequence (0x0040, 0xa090);
const DICOMTag DICOMReferencedWaveformChannels (0x0040, 0xa0b0);
const DICOMTag DICOMRETIREDDateOfDocumentOrVerbalTransactionTrial (0x0040, 0xa110);
const DICOMTag DICOMRETIREDTimeOfDocumentCreationOrVerbalTransactionTrial (0x0040, 0xa112);
const DICOMTag DICOMDateTime (0x0040, 0xa120);
const DICOMTag DICOMDate (0x0040, 0xa121);
const DICOMTag DICOMTime (0x0040, 0xa122);
const DICOMTag DICOMPersonName (0x0040, 0xa123);
const DICOMTag DICOMUID (0x0040, 0xa124);
const DICOMTag DICOMRETIREDReportStatusIDTrial (0x0040, 0xa125);
const DICOMTag DICOMTemporalRangeType (0x0040, 0xa130);
const DICOMTag DICOMReferencedSamplePositions (0x0040, 0xa132);
const DICOMTag DICOMReferencedFrameNumbers (0x0040, 0xa136);
const DICOMTag DICOMReferencedTimeOffsets (0x0040, 0xa138);
const DICOMTag DICOMReferencedDateTime (0x0040, 0xa13a);
const DICOMTag DICOMTextValue (0x0040, 0xa160);
const DICOMTag DICOMFloatingPointValue (0x0040, 0xa161);
const DICOMTag DICOMRationalNumeratorValue (0x0040, 0xa162);
const DICOMTag DICOMRationalDenominatorValue (0x0040, 0xa163);
const DICOMTag DICOMRETIREDObservationCategoryCodeSequenceTrial (0x0040, 0xa167);
const DICOMTag DICOMConceptCodeSequence (0x0040, 0xa168);
const DICOMTag DICOMRETIREDBibliographicCitationTrial (0x0040, 0xa16a);
const DICOMTag DICOMPurposeOfReferenceCodeSequence (0x0040, 0xa170);
const DICOMTag DICOMObservationUID (0x0040, 0xa171);
const DICOMTag DICOMRETIREDReferencedObservationUIDTrial (0x0040, 0xa172);
const DICOMTag DICOMRETIREDReferencedObservationClassTrial (0x0040, 0xa173);
const DICOMTag DICOMRETIREDReferencedObjectObservationClassTrial (0x0040, 0xa174);
const DICOMTag DICOMAnnotationGroupNumber (0x0040, 0xa180);
const DICOMTag DICOMRETIREDObservationDateTrial (0x0040, 0xa192);
const DICOMTag DICOMRETIREDObservationTimeTrial (0x0040, 0xa193);
const DICOMTag DICOMRETIREDMeasurementAutomationTrial (0x0040, 0xa194);
const DICOMTag DICOMModifierCodeSequence (0x0040, 0xa195);
const DICOMTag DICOMRETIREDIdentificationDescriptionTrial (0x0040, 0xa224);
const DICOMTag DICOMRETIREDCoordinatesSetGeometricTypeTrial (0x0040, 0xa290);
const DICOMTag DICOMRETIREDAlgorithmCodeSequenceTrial (0x0040, 0xa296);
const DICOMTag DICOMRETIREDAlgorithmDescriptionTrial (0x0040, 0xa297);
const DICOMTag DICOMRETIREDPixelCoordinatesSetTrial (0x0040, 0xa29a);
const DICOMTag DICOMMeasuredValueSequence (0x0040, 0xa300);
const DICOMTag DICOMNumericValueQualifierCodeSequence (0x0040, 0xa301);
const DICOMTag DICOMRETIREDCurrentObserverTrial (0x0040, 0xa307);
const DICOMTag DICOMNumericValue (0x0040, 0xa30a);
const DICOMTag DICOMRETIREDReferencedAccessionSequenceTrial (0x0040, 0xa313);
const DICOMTag DICOMRETIREDReportStatusCommentTrial (0x0040, 0xa33a);
const DICOMTag DICOMRETIREDProcedureContextSequenceTrial (0x0040, 0xa340);
const DICOMTag DICOMRETIREDVerbalSourceTrial (0x0040, 0xa352);
const DICOMTag DICOMRETIREDAddressTrial (0x0040, 0xa353);
const DICOMTag DICOMRETIREDTelephoneNumberTrial (0x0040, 0xa354);
const DICOMTag DICOMRETIREDVerbalSourceIdentifierCodeSequenceTrial (0x0040, 0xa358);
const DICOMTag DICOMPredecessorDocumentsSequence (0x0040, 0xa360);
const DICOMTag DICOMReferencedRequestSequence (0x0040, 0xa370);
const DICOMTag DICOMPerformedProcedureCodeSequence (0x0040, 0xa372);
const DICOMTag DICOMCurrentRequestedProcedureEvidenceSequence (0x0040, 0xa375);
const DICOMTag DICOMRETIREDReportDetailSequenceTrial (0x0040, 0xa380);
const DICOMTag DICOMPertinentOtherEvidenceSequence (0x0040, 0xa385);
const DICOMTag DICOMHL7StructuredDocumentReferenceSequence (0x0040, 0xa390);
const DICOMTag DICOMRETIREDObservationSubjectUIDTrial (0x0040, 0xa402);
const DICOMTag DICOMRETIREDObservationSubjectClassTrial (0x0040, 0xa403);
const DICOMTag DICOMRETIREDObservationSubjectTypeCodeSequenceTrial (0x0040, 0xa404);
const DICOMTag DICOMCompletionFlag (0x0040, 0xa491);
const DICOMTag DICOMCompletionFlagDescription (0x0040, 0xa492);
const DICOMTag DICOMVerificationFlag (0x0040, 0xa493);
const DICOMTag DICOMArchiveRequested (0x0040, 0xa494);
const DICOMTag DICOMPreliminaryFlag (0x0040, 0xa496);
const DICOMTag DICOMContentTemplateSequence (0x0040, 0xa504);
const DICOMTag DICOMIdenticalDocumentsSequence (0x0040, 0xa525);
const DICOMTag DICOMRETIREDObservationSubjectContextFlagTrial (0x0040, 0xa600);
const DICOMTag DICOMRETIREDObserverContextFlagTrial (0x0040, 0xa601);
const DICOMTag DICOMRETIREDProcedureContextFlagTrial (0x0040, 0xa603);
const DICOMTag DICOMContentSequence (0x0040, 0xa730);
const DICOMTag DICOMRETIREDRelationshipSequenceTrial (0x0040, 0xa731);
const DICOMTag DICOMRETIREDRelationshipTypeCodeSequenceTrial (0x0040, 0xa732);
const DICOMTag DICOMRETIREDLanguageCodeSequenceTrial (0x0040, 0xa744);
const DICOMTag DICOMRETIREDUniformResourceLocatorTrial (0x0040, 0xa992);
const DICOMTag DICOMWaveformAnnotationSequence (0x0040, 0xb020);
const DICOMTag DICOMTemplateIdentifier (0x0040, 0xdb00);
const DICOMTag DICOMRETIREDTemplateVersion (0x0040, 0xdb06);
const DICOMTag DICOMRETIREDTemplateLocalVersion (0x0040, 0xdb07);
const DICOMTag DICOMRETIREDTemplateExtensionFlag (0x0040, 0xdb0b);
const DICOMTag DICOMRETIREDTemplateExtensionOrganizationUID (0x0040, 0xdb0c);
const DICOMTag DICOMRETIREDTemplateExtensionCreatorUID (0x0040, 0xdb0d);
const DICOMTag DICOMReferencedContentItemIdentifier (0x0040, 0xdb73);
const DICOMTag DICOMHL7InstanceIdentifier (0x0040, 0xe001);
const DICOMTag DICOMHL7DocumentEffectiveTime (0x0040, 0xe004);
const DICOMTag DICOMHL7DocumentTypeCodeSequence (0x0040, 0xe006);
const DICOMTag DICOMDocumentClassCodeSequence (0x0040, 0xe008);
const DICOMTag DICOMRetrieveURI (0x0040, 0xe010);
const DICOMTag DICOMRetrieveLocationUID (0x0040, 0xe011);
const DICOMTag DICOMTypeOfInstances (0x0040, 0xe020);
const DICOMTag DICOMDICOMRetrievalSequence (0x0040, 0xe021);
const DICOMTag DICOMDICOMMediaRetrievalSequence (0x0040, 0xe022);
const DICOMTag DICOMWADORetrievalSequence (0x0040, 0xe023);
const DICOMTag DICOMXDSRetrievalSequence (0x0040, 0xe024);
const DICOMTag DICOMRepositoryUniqueID (0x0040, 0xe030);
const DICOMTag DICOMHomeCommunityID (0x0040, 0xe031);
const DICOMTag DICOMDocumentTitle (0x0042, 0x0010);
const DICOMTag DICOMEncapsulatedDocument (0x0042, 0x0011);
const DICOMTag DICOMMIMETypeOfEncapsulatedDocument (0x0042, 0x0012);
const DICOMTag DICOMSourceInstanceSequence (0x0042, 0x0013);
const DICOMTag DICOMListOfMIMETypes (0x0042, 0x0014);
const DICOMTag DICOMProductPackageIdentifier (0x0044, 0x0001);
const DICOMTag DICOMSubstanceAdministrationApproval (0x0044, 0x0002);
const DICOMTag DICOMApprovalStatusFurtherDescription (0x0044, 0x0003);
const DICOMTag DICOMApprovalStatusDateTime (0x0044, 0x0004);
const DICOMTag DICOMProductTypeCodeSequence (0x0044, 0x0007);
const DICOMTag DICOMProductName (0x0044, 0x0008);
const DICOMTag DICOMProductDescription (0x0044, 0x0009);
const DICOMTag DICOMProductLotIdentifier (0x0044, 0x000a);
const DICOMTag DICOMProductExpirationDateTime (0x0044, 0x000b);
const DICOMTag DICOMSubstanceAdministrationDateTime (0x0044, 0x0010);
const DICOMTag DICOMSubstanceAdministrationNotes (0x0044, 0x0011);
const DICOMTag DICOMSubstanceAdministrationDeviceID (0x0044, 0x0012);
const DICOMTag DICOMProductParameterSequence (0x0044, 0x0013);
const DICOMTag DICOMSubstanceAdministrationParameterSequence (0x0044, 0x0019);
const DICOMTag DICOMLensDescription (0x0046, 0x0012);
const DICOMTag DICOMRightLensSequence (0x0046, 0x0014);
const DICOMTag DICOMLeftLensSequence (0x0046, 0x0015);
const DICOMTag DICOMUnspecifiedLateralityLensSequence (0x0046, 0x0016);
const DICOMTag DICOMCylinderSequence (0x0046, 0x0018);
const DICOMTag DICOMPrismSequence (0x0046, 0x0028);
const DICOMTag DICOMHorizontalPrismPower (0x0046, 0x0030);
const DICOMTag DICOMHorizontalPrismBase (0x0046, 0x0032);
const DICOMTag DICOMVerticalPrismPower (0x0046, 0x0034);
const DICOMTag DICOMVerticalPrismBase (0x0046, 0x0036);
const DICOMTag DICOMLensSegmentType (0x0046, 0x0038);
const DICOMTag DICOMOpticalTransmittance (0x0046, 0x0040);
const DICOMTag DICOMChannelWidth (0x0046, 0x0042);
const DICOMTag DICOMPupilSize (0x0046, 0x0044);
const DICOMTag DICOMCornealSize (0x0046, 0x0046);
const DICOMTag DICOMAutorefractionRightEyeSequence (0x0046, 0x0050);
const DICOMTag DICOMAutorefractionLeftEyeSequence (0x0046, 0x0052);
const DICOMTag DICOMDistancePupillaryDistance (0x0046, 0x0060);
const DICOMTag DICOMNearPupillaryDistance (0x0046, 0x0062);
const DICOMTag DICOMIntermediatePupillaryDistance (0x0046, 0x0063);
const DICOMTag DICOMOtherPupillaryDistance (0x0046, 0x0064);
const DICOMTag DICOMKeratometryRightEyeSequence (0x0046, 0x0070);
const DICOMTag DICOMKeratometryLeftEyeSequence (0x0046, 0x0071);
const DICOMTag DICOMSteepKeratometricAxisSequence (0x0046, 0x0074);
const DICOMTag DICOMRadiusOfCurvature (0x0046, 0x0075);
const DICOMTag DICOMKeratometricPower (0x0046, 0x0076);
const DICOMTag DICOMKeratometricAxis (0x0046, 0x0077);
const DICOMTag DICOMFlatKeratometricAxisSequence (0x0046, 0x0080);
const DICOMTag DICOMBackgroundColor (0x0046, 0x0092);
const DICOMTag DICOMOptotype (0x0046, 0x0094);
const DICOMTag DICOMOptotypePresentation (0x0046, 0x0095);
const DICOMTag DICOMSubjectiveRefractionRightEyeSequence (0x0046, 0x0097);
const DICOMTag DICOMSubjectiveRefractionLeftEyeSequence (0x0046, 0x0098);
const DICOMTag DICOMAddNearSequence (0x0046, 0x0100);
const DICOMTag DICOMAddIntermediateSequence (0x0046, 0x0101);
const DICOMTag DICOMAddOtherSequence (0x0046, 0x0102);
const DICOMTag DICOMAddPower (0x0046, 0x0104);
const DICOMTag DICOMViewingDistance (0x0046, 0x0106);
const DICOMTag DICOMVisualAcuityTypeCodeSequence (0x0046, 0x0121);
const DICOMTag DICOMVisualAcuityRightEyeSequence (0x0046, 0x0122);
const DICOMTag DICOMVisualAcuityLeftEyeSequence (0x0046, 0x0123);
const DICOMTag DICOMVisualAcuityBothEyesOpenSequence (0x0046, 0x0124);
const DICOMTag DICOMViewingDistanceType (0x0046, 0x0125);
const DICOMTag DICOMVisualAcuityModifiers (0x0046, 0x0135);
const DICOMTag DICOMDecimalVisualAcuity (0x0046, 0x0137);
const DICOMTag DICOMOptotypeDetailedDefinition (0x0046, 0x0139);
const DICOMTag DICOMReferencedRefractiveMeasurementsSequence (0x0046, 0x0145);
const DICOMTag DICOMSpherePower (0x0046, 0x0146);
const DICOMTag DICOMCylinderPower (0x0046, 0x0147);
const DICOMTag DICOMImagedVolumeWidth (0x0048, 0x0001);
const DICOMTag DICOMImagedVolumeHeight (0x0048, 0x0002);
const DICOMTag DICOMImagedVolumeDepth (0x0048, 0x0003);
const DICOMTag DICOMTotalPixelMatrixColumns (0x0048, 0x0006);
const DICOMTag DICOMTotalPixelMatrixRows (0x0048, 0x0007);
const DICOMTag DICOMTotalPixelMatrixOriginSequence (0x0048, 0x0008);
const DICOMTag DICOMSpecimenLabelInImage (0x0048, 0x0010);
const DICOMTag DICOMFocusMethod (0x0048, 0x0011);
const DICOMTag DICOMExtendedDepthOfField (0x0048, 0x0012);
const DICOMTag DICOMNumberOfFocalPlanes (0x0048, 0x0013);
const DICOMTag DICOMDistanceBetweenFocalPlanes (0x0048, 0x0014);
const DICOMTag DICOMRecommendedAbsentPixelCIELabValue (0x0048, 0x0015);
const DICOMTag DICOMIlluminatorTypeCodeSequence (0x0048, 0x0100);
const DICOMTag DICOMImageOrientationSlide (0x0048, 0x0102);
const DICOMTag DICOMOpticalPathSequence (0x0048, 0x0105);
const DICOMTag DICOMOpticalPathIdentifier (0x0048, 0x0106);
const DICOMTag DICOMOpticalPathDescription (0x0048, 0x0107);
const DICOMTag DICOMIlluminationColorCodeSequence (0x0048, 0x0108);
const DICOMTag DICOMSpecimenReferenceSequence (0x0048, 0x0110);
const DICOMTag DICOMCondenserLensPower (0x0048, 0x0111);
const DICOMTag DICOMObjectiveLensPower (0x0048, 0x0112);
const DICOMTag DICOMObjectiveLensNumericalAperture (0x0048, 0x0113);
const DICOMTag DICOMPaletteColorLookupTableSequence (0x0048, 0x0120);
const DICOMTag DICOMReferencedImageNavigationSequence (0x0048, 0x0200);
const DICOMTag DICOMTopLeftHandCornerOfLocalizerArea (0x0048, 0x0201);
const DICOMTag DICOMBottomRightHandCornerOfLocalizerArea (0x0048, 0x0202);
const DICOMTag DICOMOpticalPathIdentificationSequence (0x0048, 0x0207);
const DICOMTag DICOMPlanePositionSlideSequence (0x0048, 0x021a);
const DICOMTag DICOMColumnPositionInTotalImagePixelMatrix (0x0048, 0x021e);
const DICOMTag DICOMRowPositionInTotalImagePixelMatrix (0x0048, 0x021f);
const DICOMTag DICOMPixelOriginInterpretation (0x0048, 0x0301);
const DICOMTag DICOMCalibrationImage (0x0050, 0x0004);
const DICOMTag DICOMDeviceSequence (0x0050, 0x0010);
const DICOMTag DICOMContainerComponentTypeCodeSequence (0x0050, 0x0012);
const DICOMTag DICOMContainerComponentThickness (0x0050, 0x0013);
const DICOMTag DICOMDeviceLength (0x0050, 0x0014);
const DICOMTag DICOMContainerComponentWidth (0x0050, 0x0015);
const DICOMTag DICOMDeviceDiameter (0x0050, 0x0016);
const DICOMTag DICOMDeviceDiameterUnits (0x0050, 0x0017);
const DICOMTag DICOMDeviceVolume (0x0050, 0x0018);
const DICOMTag DICOMInterMarkerDistance (0x0050, 0x0019);
const DICOMTag DICOMContainerComponentMaterial (0x0050, 0x001a);
const DICOMTag DICOMContainerComponentID (0x0050, 0x001b);
const DICOMTag DICOMContainerComponentLength (0x0050, 0x001c);
const DICOMTag DICOMContainerComponentDiameter (0x0050, 0x001d);
const DICOMTag DICOMContainerComponentDescription (0x0050, 0x001e);
const DICOMTag DICOMDeviceDescription (0x0050, 0x0020);
const DICOMTag DICOMContrastBolusIngredientPercentByVolume (0x0052, 0x0001);
const DICOMTag DICOMOCTFocalDistance (0x0052, 0x0002);
const DICOMTag DICOMBeamSpotSize (0x0052, 0x0003);
const DICOMTag DICOMEffectiveRefractiveIndex (0x0052, 0x0004);
const DICOMTag DICOMOCTAcquisitionDomain (0x0052, 0x0006);
const DICOMTag DICOMOCTOpticalCenterWavelength (0x0052, 0x0007);
const DICOMTag DICOMAxialResolution (0x0052, 0x0008);
const DICOMTag DICOMRangingDepth (0x0052, 0x0009);
const DICOMTag DICOMALineRate (0x0052, 0x0011);
const DICOMTag DICOMALinesPerFrame (0x0052, 0x0012);
const DICOMTag DICOMCatheterRotationalRate (0x0052, 0x0013);
const DICOMTag DICOMALinePixelSpacing (0x0052, 0x0014);
const DICOMTag DICOMModeOfPercutaneousAccessSequence (0x0052, 0x0016);
const DICOMTag DICOMIntravascularOCTFrameTypeSequence (0x0052, 0x0025);
const DICOMTag DICOMOCTZOffsetApplied (0x0052, 0x0026);
const DICOMTag DICOMIntravascularFrameContentSequence (0x0052, 0x0027);
const DICOMTag DICOMIntravascularLongitudinalDistance (0x0052, 0x0028);
const DICOMTag DICOMIntravascularOCTFrameContentSequence (0x0052, 0x0029);
const DICOMTag DICOMOCTZOffsetCorrection (0x0052, 0x0030);
const DICOMTag DICOMCatheterDirectionOfRotation (0x0052, 0x0031);
const DICOMTag DICOMSeamLineLocation (0x0052, 0x0033);
const DICOMTag DICOMFirstALineLocation (0x0052, 0x0034);
const DICOMTag DICOMSeamLineIndex (0x0052, 0x0036);
const DICOMTag DICOMNumberOfPaddedAlines (0x0052, 0x0038);
const DICOMTag DICOMInterpolationType (0x0052, 0x0039);
const DICOMTag DICOMRefractiveIndexApplied (0x0052, 0x003a);
const DICOMTag DICOMEnergyWindowVector (0x0054, 0x0010);
const DICOMTag DICOMNumberOfEnergyWindows (0x0054, 0x0011);
const DICOMTag DICOMEnergyWindowInformationSequence (0x0054, 0x0012);
const DICOMTag DICOMEnergyWindowRangeSequence (0x0054, 0x0013);
const DICOMTag DICOMEnergyWindowLowerLimit (0x0054, 0x0014);
const DICOMTag DICOMEnergyWindowUpperLimit (0x0054, 0x0015);
const DICOMTag DICOMRadiopharmaceuticalInformationSequence (0x0054, 0x0016);
const DICOMTag DICOMResidualSyringeCounts (0x0054, 0x0017);
const DICOMTag DICOMEnergyWindowName (0x0054, 0x0018);
const DICOMTag DICOMDetectorVector (0x0054, 0x0020);
const DICOMTag DICOMNumberOfDetectors (0x0054, 0x0021);
const DICOMTag DICOMDetectorInformationSequence (0x0054, 0x0022);
const DICOMTag DICOMPhaseVector (0x0054, 0x0030);
const DICOMTag DICOMNumberOfPhases (0x0054, 0x0031);
const DICOMTag DICOMPhaseInformationSequence (0x0054, 0x0032);
const DICOMTag DICOMNumberOfFramesInPhase (0x0054, 0x0033);
const DICOMTag DICOMPhaseDelay (0x0054, 0x0036);
const DICOMTag DICOMPauseBetweenFrames (0x0054, 0x0038);
const DICOMTag DICOMPhaseDescription (0x0054, 0x0039);
const DICOMTag DICOMRotationVector (0x0054, 0x0050);
const DICOMTag DICOMNumberOfRotations (0x0054, 0x0051);
const DICOMTag DICOMRotationInformationSequence (0x0054, 0x0052);
const DICOMTag DICOMNumberOfFramesInRotation (0x0054, 0x0053);
const DICOMTag DICOMRRIntervalVector (0x0054, 0x0060);
const DICOMTag DICOMNumberOfRRIntervals (0x0054, 0x0061);
const DICOMTag DICOMGatedInformationSequence (0x0054, 0x0062);
const DICOMTag DICOMDataInformationSequence (0x0054, 0x0063);
const DICOMTag DICOMTimeSlotVector (0x0054, 0x0070);
const DICOMTag DICOMNumberOfTimeSlots (0x0054, 0x0071);
const DICOMTag DICOMTimeSlotInformationSequence (0x0054, 0x0072);
const DICOMTag DICOMTimeSlotTime (0x0054, 0x0073);
const DICOMTag DICOMSliceVector (0x0054, 0x0080);
const DICOMTag DICOMNumberOfSlices (0x0054, 0x0081);
const DICOMTag DICOMAngularViewVector (0x0054, 0x0090);
const DICOMTag DICOMTimeSliceVector (0x0054, 0x0100);
const DICOMTag DICOMNumberOfTimeSlices (0x0054, 0x0101);
const DICOMTag DICOMStartAngle (0x0054, 0x0200);
const DICOMTag DICOMTypeOfDetectorMotion (0x0054, 0x0202);
const DICOMTag DICOMTriggerVector (0x0054, 0x0210);
const DICOMTag DICOMNumberOfTriggersInPhase (0x0054, 0x0211);
const DICOMTag DICOMViewCodeSequence (0x0054, 0x0220);
const DICOMTag DICOMViewModifierCodeSequence (0x0054, 0x0222);
const DICOMTag DICOMRadionuclideCodeSequence (0x0054, 0x0300);
const DICOMTag DICOMAdministrationRouteCodeSequence (0x0054, 0x0302);
const DICOMTag DICOMRadiopharmaceuticalCodeSequence (0x0054, 0x0304);
const DICOMTag DICOMCalibrationDataSequence (0x0054, 0x0306);
const DICOMTag DICOMEnergyWindowNumber (0x0054, 0x0308);
const DICOMTag DICOMImageID (0x0054, 0x0400);
const DICOMTag DICOMPatientOrientationCodeSequence (0x0054, 0x0410);
const DICOMTag DICOMPatientOrientationModifierCodeSequence (0x0054, 0x0412);
const DICOMTag DICOMPatientGantryRelationshipCodeSequence (0x0054, 0x0414);
const DICOMTag DICOMSliceProgressionDirection (0x0054, 0x0500);
const DICOMTag DICOMSeriesType (0x0054, 0x1000);
const DICOMTag DICOMUnits (0x0054, 0x1001);
const DICOMTag DICOMCountsSource (0x0054, 0x1002);
const DICOMTag DICOMReprojectionMethod (0x0054, 0x1004);
const DICOMTag DICOMSUVType (0x0054, 0x1006);
const DICOMTag DICOMRandomsCorrectionMethod (0x0054, 0x1100);
const DICOMTag DICOMAttenuationCorrectionMethod (0x0054, 0x1101);
const DICOMTag DICOMDecayCorrection (0x0054, 0x1102);
const DICOMTag DICOMReconstructionMethod (0x0054, 0x1103);
const DICOMTag DICOMDetectorLinesOfResponseUsed (0x0054, 0x1104);
const DICOMTag DICOMScatterCorrectionMethod (0x0054, 0x1105);
const DICOMTag DICOMAxialAcceptance (0x0054, 0x1200);
const DICOMTag DICOMAxialMash (0x0054, 0x1201);
const DICOMTag DICOMTransverseMash (0x0054, 0x1202);
const DICOMTag DICOMDetectorElementSize (0x0054, 0x1203);
const DICOMTag DICOMCoincidenceWindowWidth (0x0054, 0x1210);
const DICOMTag DICOMSecondaryCountsType (0x0054, 0x1220);
const DICOMTag DICOMFrameReferenceTime (0x0054, 0x1300);
const DICOMTag DICOMPrimaryPromptsCountsAccumulated (0x0054, 0x1310);
const DICOMTag DICOMSecondaryCountsAccumulated (0x0054, 0x1311);
const DICOMTag DICOMSliceSensitivityFactor (0x0054, 0x1320);
const DICOMTag DICOMDecayFactor (0x0054, 0x1321);
const DICOMTag DICOMDoseCalibrationFactor (0x0054, 0x1322);
const DICOMTag DICOMScatterFractionFactor (0x0054, 0x1323);
const DICOMTag DICOMDeadTimeFactor (0x0054, 0x1324);
const DICOMTag DICOMImageIndex (0x0054, 0x1330);
const DICOMTag DICOMRETIREDCountsIncluded (0x0054, 0x1400);
const DICOMTag DICOMRETIREDDeadTimeCorrectionFlag (0x0054, 0x1401);
const DICOMTag DICOMHistogramSequence (0x0060, 0x3000);
const DICOMTag DICOMHistogramNumberOfBins (0x0060, 0x3002);
const DICOMTag DICOMHistogramFirstBinValue (0x0060, 0x3004);
const DICOMTag DICOMHistogramLastBinValue (0x0060, 0x3006);
const DICOMTag DICOMHistogramBinWidth (0x0060, 0x3008);
const DICOMTag DICOMHistogramExplanation (0x0060, 0x3010);
const DICOMTag DICOMHistogramData (0x0060, 0x3020);
const DICOMTag DICOMSegmentationType (0x0062, 0x0001);
const DICOMTag DICOMSegmentSequence (0x0062, 0x0002);
const DICOMTag DICOMSegmentedPropertyCategoryCodeSequence (0x0062, 0x0003);
const DICOMTag DICOMSegmentNumber (0x0062, 0x0004);
const DICOMTag DICOMSegmentLabel (0x0062, 0x0005);
const DICOMTag DICOMSegmentDescription (0x0062, 0x0006);
const DICOMTag DICOMSegmentAlgorithmType (0x0062, 0x0008);
const DICOMTag DICOMSegmentAlgorithmName (0x0062, 0x0009);
const DICOMTag DICOMSegmentIdentificationSequence (0x0062, 0x000a);
const DICOMTag DICOMReferencedSegmentNumber (0x0062, 0x000b);
const DICOMTag DICOMRecommendedDisplayGrayscaleValue (0x0062, 0x000c);
const DICOMTag DICOMRecommendedDisplayCIELabValue (0x0062, 0x000d);
const DICOMTag DICOMMaximumFractionalValue (0x0062, 0x000e);
const DICOMTag DICOMSegmentedPropertyTypeCodeSequence (0x0062, 0x000f);
const DICOMTag DICOMSegmentationFractionalType (0x0062, 0x0010);
const DICOMTag DICOMDeformableRegistrationSequence (0x0064, 0x0002);
const DICOMTag DICOMSourceFrameOfReferenceUID (0x0064, 0x0003);
const DICOMTag DICOMDeformableRegistrationGridSequence (0x0064, 0x0005);
const DICOMTag DICOMGridDimensions (0x0064, 0x0007);
const DICOMTag DICOMGridResolution (0x0064, 0x0008);
const DICOMTag DICOMVectorGridData (0x0064, 0x0009);
const DICOMTag DICOMPreDeformationMatrixRegistrationSequence (0x0064, 0x000f);
const DICOMTag DICOMPostDeformationMatrixRegistrationSequence (0x0064, 0x0010);
const DICOMTag DICOMNumberOfSurfaces (0x0066, 0x0001);
const DICOMTag DICOMSurfaceSequence (0x0066, 0x0002);
const DICOMTag DICOMSurfaceNumber (0x0066, 0x0003);
const DICOMTag DICOMSurfaceComments (0x0066, 0x0004);
const DICOMTag DICOMSurfaceProcessing (0x0066, 0x0009);
const DICOMTag DICOMSurfaceProcessingRatio (0x0066, 0x000a);
const DICOMTag DICOMSurfaceProcessingDescription (0x0066, 0x000b);
const DICOMTag DICOMRecommendedPresentationOpacity (0x0066, 0x000c);
const DICOMTag DICOMRecommendedPresentationType (0x0066, 0x000d);
const DICOMTag DICOMFiniteVolume (0x0066, 0x000e);
const DICOMTag DICOMManifold (0x0066, 0x0010);
const DICOMTag DICOMSurfacePointsSequence (0x0066, 0x0011);
const DICOMTag DICOMSurfacePointsNormalsSequence (0x0066, 0x0012);
const DICOMTag DICOMSurfaceMeshPrimitivesSequence (0x0066, 0x0013);
const DICOMTag DICOMNumberOfSurfacePoints (0x0066, 0x0015);
const DICOMTag DICOMPointCoordinatesData (0x0066, 0x0016);
const DICOMTag DICOMPointPositionAccuracy (0x0066, 0x0017);
const DICOMTag DICOMMeanPointDistance (0x0066, 0x0018);
const DICOMTag DICOMMaximumPointDistance (0x0066, 0x0019);
const DICOMTag DICOMPointsBoundingBoxCoordinates (0x0066, 0x001a);
const DICOMTag DICOMAxisOfRotation (0x0066, 0x001b);
const DICOMTag DICOMCenterOfRotation (0x0066, 0x001c);
const DICOMTag DICOMNumberOfVectors (0x0066, 0x001e);
const DICOMTag DICOMVectorDimensionality (0x0066, 0x001f);
const DICOMTag DICOMVectorAccuracy (0x0066, 0x0020);
const DICOMTag DICOMVectorCoordinateData (0x0066, 0x0021);
const DICOMTag DICOMTrianglePointIndexList (0x0066, 0x0023);
const DICOMTag DICOMEdgePointIndexList (0x0066, 0x0024);
const DICOMTag DICOMVertexPointIndexList (0x0066, 0x0025);
const DICOMTag DICOMTriangleStripSequence (0x0066, 0x0026);
const DICOMTag DICOMTriangleFanSequence (0x0066, 0x0027);
const DICOMTag DICOMLineSequence (0x0066, 0x0028);
const DICOMTag DICOMPrimitivePointIndexList (0x0066, 0x0029);
const DICOMTag DICOMSurfaceCount (0x0066, 0x002a);
const DICOMTag DICOMReferencedSurfaceSequence (0x0066, 0x002b);
const DICOMTag DICOMReferencedSurfaceNumber (0x0066, 0x002c);
const DICOMTag DICOMSegmentSurfaceGenerationAlgorithmIdentificationSequence (0x0066, 0x002d);
const DICOMTag DICOMSegmentSurfaceSourceInstanceSequence (0x0066, 0x002e);
const DICOMTag DICOMAlgorithmFamilyCodeSequence (0x0066, 0x002f);
const DICOMTag DICOMAlgorithmNameCodeSequence (0x0066, 0x0030);
const DICOMTag DICOMAlgorithmVersion (0x0066, 0x0031);
const DICOMTag DICOMAlgorithmParameters (0x0066, 0x0032);
const DICOMTag DICOMFacetSequence (0x0066, 0x0034);
const DICOMTag DICOMSurfaceProcessingAlgorithmIdentificationSequence (0x0066, 0x0035);
const DICOMTag DICOMAlgorithmName (0x0066, 0x0036);
const DICOMTag DICOMImplantSize (0x0068, 0x6210);
const DICOMTag DICOMImplantTemplateVersion (0x0068, 0x6221);
const DICOMTag DICOMReplacedImplantTemplateSequence (0x0068, 0x6222);
const DICOMTag DICOMImplantType (0x0068, 0x6223);
const DICOMTag DICOMDerivationImplantTemplateSequence (0x0068, 0x6224);
const DICOMTag DICOMOriginalImplantTemplateSequence (0x0068, 0x6225);
const DICOMTag DICOMEffectiveDateTime (0x0068, 0x6226);
const DICOMTag DICOMImplantTargetAnatomySequence (0x0068, 0x6230);
const DICOMTag DICOMInformationFromManufacturerSequence (0x0068, 0x6260);
const DICOMTag DICOMNotificationFromManufacturerSequence (0x0068, 0x6265);
const DICOMTag DICOMInformationIssueDateTime (0x0068, 0x6270);
const DICOMTag DICOMInformationSummary (0x0068, 0x6280);
const DICOMTag DICOMImplantRegulatoryDisapprovalCodeSequence (0x0068, 0x62a0);
const DICOMTag DICOMOverallTemplateSpatialTolerance (0x0068, 0x62a5);
const DICOMTag DICOMHPGLDocumentSequence (0x0068, 0x62c0);
const DICOMTag DICOMHPGLDocumentID (0x0068, 0x62d0);
const DICOMTag DICOMHPGLDocumentLabel (0x0068, 0x62d5);
const DICOMTag DICOMViewOrientationCodeSequence (0x0068, 0x62e0);
const DICOMTag DICOMViewOrientationModifier (0x0068, 0x62f0);
const DICOMTag DICOMHPGLDocumentScaling (0x0068, 0x62f2);
const DICOMTag DICOMHPGLDocument (0x0068, 0x6300);
const DICOMTag DICOMHPGLContourPenNumber (0x0068, 0x6310);
const DICOMTag DICOMHPGLPenSequence (0x0068, 0x6320);
const DICOMTag DICOMHPGLPenNumber (0x0068, 0x6330);
const DICOMTag DICOMHPGLPenLabel (0x0068, 0x6340);
const DICOMTag DICOMHPGLPenDescription (0x0068, 0x6345);
const DICOMTag DICOMRecommendedRotationPoint (0x0068, 0x6346);
const DICOMTag DICOMBoundingRectangle (0x0068, 0x6347);
const DICOMTag DICOMImplantTemplate3DModelSurfaceNumber (0x0068, 0x6350);
const DICOMTag DICOMSurfaceModelDescriptionSequence (0x0068, 0x6360);
const DICOMTag DICOMSurfaceModelLabel (0x0068, 0x6380);
const DICOMTag DICOMSurfaceModelScalingFactor (0x0068, 0x6390);
const DICOMTag DICOMMaterialsCodeSequence (0x0068, 0x63a0);
const DICOMTag DICOMCoatingMaterialsCodeSequence (0x0068, 0x63a4);
const DICOMTag DICOMImplantTypeCodeSequence (0x0068, 0x63a8);
const DICOMTag DICOMFixationMethodCodeSequence (0x0068, 0x63ac);
const DICOMTag DICOMMatingFeatureSetsSequence (0x0068, 0x63b0);
const DICOMTag DICOMMatingFeatureSetID (0x0068, 0x63c0);
const DICOMTag DICOMMatingFeatureSetLabel (0x0068, 0x63d0);
const DICOMTag DICOMMatingFeatureSequence (0x0068, 0x63e0);
const DICOMTag DICOMMatingFeatureID (0x0068, 0x63f0);
const DICOMTag DICOMMatingFeatureDegreeOfFreedomSequence (0x0068, 0x6400);
const DICOMTag DICOMDegreeOfFreedomID (0x0068, 0x6410);
const DICOMTag DICOMDegreeOfFreedomType (0x0068, 0x6420);
const DICOMTag DICOMTwoDMatingFeatureCoordinatesSequence (0x0068, 0x6430);
const DICOMTag DICOMReferencedHPGLDocumentID (0x0068, 0x6440);
const DICOMTag DICOMTwoDMatingPoint (0x0068, 0x6450);
const DICOMTag DICOMTwoDMatingAxes (0x0068, 0x6460);
const DICOMTag DICOMTwoDDegreeOfFreedomSequence (0x0068, 0x6470);
const DICOMTag DICOMThreeDDegreeOfFreedomAxis (0x0068, 0x6490);
const DICOMTag DICOMRangeOfFreedom (0x0068, 0x64a0);
const DICOMTag DICOMThreeDMatingPoint (0x0068, 0x64c0);
const DICOMTag DICOMThreeDMatingAxes (0x0068, 0x64d0);
const DICOMTag DICOMTwoDDegreeOfFreedomAxis (0x0068, 0x64f0);
const DICOMTag DICOMPlanningLandmarkPointSequence (0x0068, 0x6500);
const DICOMTag DICOMPlanningLandmarkLineSequence (0x0068, 0x6510);
const DICOMTag DICOMPlanningLandmarkPlaneSequence (0x0068, 0x6520);
const DICOMTag DICOMPlanningLandmarkID (0x0068, 0x6530);
const DICOMTag DICOMPlanningLandmarkDescription (0x0068, 0x6540);
const DICOMTag DICOMPlanningLandmarkIdentificationCodeSequence (0x0068, 0x6545);
const DICOMTag DICOMTwoDPointCoordinatesSequence (0x0068, 0x6550);
const DICOMTag DICOMTwoDPointCoordinates (0x0068, 0x6560);
const DICOMTag DICOMThreeDPointCoordinates (0x0068, 0x6590);
const DICOMTag DICOMTwoDLineCoordinatesSequence (0x0068, 0x65a0);
const DICOMTag DICOMTwoDLineCoordinates (0x0068, 0x65b0);
const DICOMTag DICOMThreeDLineCoordinates (0x0068, 0x65d0);
const DICOMTag DICOMTwoDPlaneCoordinatesSequence (0x0068, 0x65e0);
const DICOMTag DICOMTwoDPlaneIntersection (0x0068, 0x65f0);
const DICOMTag DICOMThreeDPlaneOrigin (0x0068, 0x6610);
const DICOMTag DICOMThreeDPlaneNormal (0x0068, 0x6620);
const DICOMTag DICOMGraphicAnnotationSequence (0x0070, 0x0001);
const DICOMTag DICOMGraphicLayer (0x0070, 0x0002);
const DICOMTag DICOMBoundingBoxAnnotationUnits (0x0070, 0x0003);
const DICOMTag DICOMAnchorPointAnnotationUnits (0x0070, 0x0004);
const DICOMTag DICOMGraphicAnnotationUnits (0x0070, 0x0005);
const DICOMTag DICOMUnformattedTextValue (0x0070, 0x0006);
const DICOMTag DICOMTextObjectSequence (0x0070, 0x0008);
const DICOMTag DICOMGraphicObjectSequence (0x0070, 0x0009);
const DICOMTag DICOMBoundingBoxTopLeftHandCorner (0x0070, 0x0010);
const DICOMTag DICOMBoundingBoxBottomRightHandCorner (0x0070, 0x0011);
const DICOMTag DICOMBoundingBoxTextHorizontalJustification (0x0070, 0x0012);
const DICOMTag DICOMAnchorPoint (0x0070, 0x0014);
const DICOMTag DICOMAnchorPointVisibility (0x0070, 0x0015);
const DICOMTag DICOMGraphicDimensions (0x0070, 0x0020);
const DICOMTag DICOMNumberOfGraphicPoints (0x0070, 0x0021);
const DICOMTag DICOMGraphicData (0x0070, 0x0022);
const DICOMTag DICOMGraphicType (0x0070, 0x0023);
const DICOMTag DICOMGraphicFilled (0x0070, 0x0024);
const DICOMTag DICOMRETIREDImageRotationRetired (0x0070, 0x0040);
const DICOMTag DICOMImageHorizontalFlip (0x0070, 0x0041);
const DICOMTag DICOMImageRotation (0x0070, 0x0042);
const DICOMTag DICOMRETIREDDisplayedAreaTopLeftHandCornerTrial (0x0070, 0x0050);
const DICOMTag DICOMRETIREDDisplayedAreaBottomRightHandCornerTrial (0x0070, 0x0051);
const DICOMTag DICOMDisplayedAreaTopLeftHandCorner (0x0070, 0x0052);
const DICOMTag DICOMDisplayedAreaBottomRightHandCorner (0x0070, 0x0053);
const DICOMTag DICOMDisplayedAreaSelectionSequence (0x0070, 0x005a);
const DICOMTag DICOMGraphicLayerSequence (0x0070, 0x0060);
const DICOMTag DICOMGraphicLayerOrder (0x0070, 0x0062);
const DICOMTag DICOMGraphicLayerRecommendedDisplayGrayscaleValue (0x0070, 0x0066);
const DICOMTag DICOMRETIREDGraphicLayerRecommendedDisplayRGBValue (0x0070, 0x0067);
const DICOMTag DICOMGraphicLayerDescription (0x0070, 0x0068);
const DICOMTag DICOMContentLabel (0x0070, 0x0080);
const DICOMTag DICOMContentDescription (0x0070, 0x0081);
const DICOMTag DICOMPresentationCreationDate (0x0070, 0x0082);
const DICOMTag DICOMPresentationCreationTime (0x0070, 0x0083);
const DICOMTag DICOMContentCreatorName (0x0070, 0x0084);
const DICOMTag DICOMContentCreatorIdentificationCodeSequence (0x0070, 0x0086);
const DICOMTag DICOMAlternateContentDescriptionSequence (0x0070, 0x0087);
const DICOMTag DICOMPresentationSizeMode (0x0070, 0x0100);
const DICOMTag DICOMPresentationPixelSpacing (0x0070, 0x0101);
const DICOMTag DICOMPresentationPixelAspectRatio (0x0070, 0x0102);
const DICOMTag DICOMPresentationPixelMagnificationRatio (0x0070, 0x0103);
const DICOMTag DICOMGraphicGroupLabel (0x0070, 0x0207);
const DICOMTag DICOMGraphicGroupDescription (0x0070, 0x0208);
const DICOMTag DICOMCompoundGraphicSequence (0x0070, 0x0209);
const DICOMTag DICOMCompoundGraphicInstanceID (0x0070, 0x0226);
const DICOMTag DICOMFontName (0x0070, 0x0227);
const DICOMTag DICOMFontNameType (0x0070, 0x0228);
const DICOMTag DICOMCSSFontName (0x0070, 0x0229);
const DICOMTag DICOMRotationAngle (0x0070, 0x0230);
const DICOMTag DICOMTextStyleSequence (0x0070, 0x0231);
const DICOMTag DICOMLineStyleSequence (0x0070, 0x0232);
const DICOMTag DICOMFillStyleSequence (0x0070, 0x0233);
const DICOMTag DICOMGraphicGroupSequence (0x0070, 0x0234);
const DICOMTag DICOMTextColorCIELabValue (0x0070, 0x0241);
const DICOMTag DICOMHorizontalAlignment (0x0070, 0x0242);
const DICOMTag DICOMVerticalAlignment (0x0070, 0x0243);
const DICOMTag DICOMShadowStyle (0x0070, 0x0244);
const DICOMTag DICOMShadowOffsetX (0x0070, 0x0245);
const DICOMTag DICOMShadowOffsetY (0x0070, 0x0246);
const DICOMTag DICOMShadowColorCIELabValue (0x0070, 0x0247);
const DICOMTag DICOMUnderlined (0x0070, 0x0248);
const DICOMTag DICOMBold (0x0070, 0x0249);
const DICOMTag DICOMItalic (0x0070, 0x0250);
const DICOMTag DICOMPatternOnColorCIELabValue (0x0070, 0x0251);
const DICOMTag DICOMPatternOffColorCIELabValue (0x0070, 0x0252);
const DICOMTag DICOMLineThickness (0x0070, 0x0253);
const DICOMTag DICOMLineDashingStyle (0x0070, 0x0254);
const DICOMTag DICOMLinePattern (0x0070, 0x0255);
const DICOMTag DICOMFillPattern (0x0070, 0x0256);
const DICOMTag DICOMFillMode (0x0070, 0x0257);
const DICOMTag DICOMShadowOpacity (0x0070, 0x0258);
const DICOMTag DICOMGapLength (0x0070, 0x0261);
const DICOMTag DICOMDiameterOfVisibility (0x0070, 0x0262);
const DICOMTag DICOMRotationPoint (0x0070, 0x0273);
const DICOMTag DICOMTickAlignment (0x0070, 0x0274);
const DICOMTag DICOMShowTickLabel (0x0070, 0x0278);
const DICOMTag DICOMTickLabelAlignment (0x0070, 0x0279);
const DICOMTag DICOMCompoundGraphicUnits (0x0070, 0x0282);
const DICOMTag DICOMPatternOnOpacity (0x0070, 0x0284);
const DICOMTag DICOMPatternOffOpacity (0x0070, 0x0285);
const DICOMTag DICOMMajorTicksSequence (0x0070, 0x0287);
const DICOMTag DICOMTickPosition (0x0070, 0x0288);
const DICOMTag DICOMTickLabel (0x0070, 0x0289);
const DICOMTag DICOMCompoundGraphicType (0x0070, 0x0294);
const DICOMTag DICOMGraphicGroupID (0x0070, 0x0295);
const DICOMTag DICOMShapeType (0x0070, 0x0306);
const DICOMTag DICOMRegistrationSequence (0x0070, 0x0308);
const DICOMTag DICOMMatrixRegistrationSequence (0x0070, 0x0309);
const DICOMTag DICOMMatrixSequence (0x0070, 0x030a);
const DICOMTag DICOMFrameOfReferenceTransformationMatrixType (0x0070, 0x030c);
const DICOMTag DICOMRegistrationTypeCodeSequence (0x0070, 0x030d);
const DICOMTag DICOMFiducialDescription (0x0070, 0x030f);
const DICOMTag DICOMFiducialIdentifier (0x0070, 0x0310);
const DICOMTag DICOMFiducialIdentifierCodeSequence (0x0070, 0x0311);
const DICOMTag DICOMContourUncertaintyRadius (0x0070, 0x0312);
const DICOMTag DICOMUsedFiducialsSequence (0x0070, 0x0314);
const DICOMTag DICOMGraphicCoordinatesDataSequence (0x0070, 0x0318);
const DICOMTag DICOMFiducialUID (0x0070, 0x031a);
const DICOMTag DICOMFiducialSetSequence (0x0070, 0x031c);
const DICOMTag DICOMFiducialSequence (0x0070, 0x031e);
const DICOMTag DICOMGraphicLayerRecommendedDisplayCIELabValue (0x0070, 0x0401);
const DICOMTag DICOMBlendingSequence (0x0070, 0x0402);
const DICOMTag DICOMRelativeOpacity (0x0070, 0x0403);
const DICOMTag DICOMReferencedSpatialRegistrationSequence (0x0070, 0x0404);
const DICOMTag DICOMBlendingPosition (0x0070, 0x0405);
const DICOMTag DICOMHangingProtocolName (0x0072, 0x0002);
const DICOMTag DICOMHangingProtocolDescription (0x0072, 0x0004);
const DICOMTag DICOMHangingProtocolLevel (0x0072, 0x0006);
const DICOMTag DICOMHangingProtocolCreator (0x0072, 0x0008);
const DICOMTag DICOMHangingProtocolCreationDateTime (0x0072, 0x000a);
const DICOMTag DICOMHangingProtocolDefinitionSequence (0x0072, 0x000c);
const DICOMTag DICOMHangingProtocolUserIdentificationCodeSequence (0x0072, 0x000e);
const DICOMTag DICOMHangingProtocolUserGroupName (0x0072, 0x0010);
const DICOMTag DICOMSourceHangingProtocolSequence (0x0072, 0x0012);
const DICOMTag DICOMNumberOfPriorsReferenced (0x0072, 0x0014);
const DICOMTag DICOMImageSetsSequence (0x0072, 0x0020);
const DICOMTag DICOMImageSetSelectorSequence (0x0072, 0x0022);
const DICOMTag DICOMImageSetSelectorUsageFlag (0x0072, 0x0024);
const DICOMTag DICOMSelectorAttribute (0x0072, 0x0026);
const DICOMTag DICOMSelectorValueNumber (0x0072, 0x0028);
const DICOMTag DICOMTimeBasedImageSetsSequence (0x0072, 0x0030);
const DICOMTag DICOMImageSetNumber (0x0072, 0x0032);
const DICOMTag DICOMImageSetSelectorCategory (0x0072, 0x0034);
const DICOMTag DICOMRelativeTime (0x0072, 0x0038);
const DICOMTag DICOMRelativeTimeUnits (0x0072, 0x003a);
const DICOMTag DICOMAbstractPriorValue (0x0072, 0x003c);
const DICOMTag DICOMAbstractPriorCodeSequence (0x0072, 0x003e);
const DICOMTag DICOMImageSetLabel (0x0072, 0x0040);
const DICOMTag DICOMSelectorAttributeVR (0x0072, 0x0050);
const DICOMTag DICOMSelectorSequencePointer (0x0072, 0x0052);
const DICOMTag DICOMSelectorSequencePointerPrivateCreator (0x0072, 0x0054);
const DICOMTag DICOMSelectorAttributePrivateCreator (0x0072, 0x0056);
const DICOMTag DICOMSelectorATValue (0x0072, 0x0060);
const DICOMTag DICOMSelectorCSValue (0x0072, 0x0062);
const DICOMTag DICOMSelectorISValue (0x0072, 0x0064);
const DICOMTag DICOMSelectorLOValue (0x0072, 0x0066);
const DICOMTag DICOMSelectorLTValue (0x0072, 0x0068);
const DICOMTag DICOMSelectorPNValue (0x0072, 0x006a);
const DICOMTag DICOMSelectorSHValue (0x0072, 0x006c);
const DICOMTag DICOMSelectorSTValue (0x0072, 0x006e);
const DICOMTag DICOMSelectorUTValue (0x0072, 0x0070);
const DICOMTag DICOMSelectorDSValue (0x0072, 0x0072);
const DICOMTag DICOMSelectorFDValue (0x0072, 0x0074);
const DICOMTag DICOMSelectorFLValue (0x0072, 0x0076);
const DICOMTag DICOMSelectorULValue (0x0072, 0x0078);
const DICOMTag DICOMSelectorUSValue (0x0072, 0x007a);
const DICOMTag DICOMSelectorSLValue (0x0072, 0x007c);
const DICOMTag DICOMSelectorSSValue (0x0072, 0x007e);
const DICOMTag DICOMSelectorCodeSequenceValue (0x0072, 0x0080);
const DICOMTag DICOMNumberOfScreens (0x0072, 0x0100);
const DICOMTag DICOMNominalScreenDefinitionSequence (0x0072, 0x0102);
const DICOMTag DICOMNumberOfVerticalPixels (0x0072, 0x0104);
const DICOMTag DICOMNumberOfHorizontalPixels (0x0072, 0x0106);
const DICOMTag DICOMDisplayEnvironmentSpatialPosition (0x0072, 0x0108);
const DICOMTag DICOMScreenMinimumGrayscaleBitDepth (0x0072, 0x010a);
const DICOMTag DICOMScreenMinimumColorBitDepth (0x0072, 0x010c);
const DICOMTag DICOMApplicationMaximumRepaintTime (0x0072, 0x010e);
const DICOMTag DICOMDisplaySetsSequence (0x0072, 0x0200);
const DICOMTag DICOMDisplaySetNumber (0x0072, 0x0202);
const DICOMTag DICOMDisplaySetLabel (0x0072, 0x0203);
const DICOMTag DICOMDisplaySetPresentationGroup (0x0072, 0x0204);
const DICOMTag DICOMDisplaySetPresentationGroupDescription (0x0072, 0x0206);
const DICOMTag DICOMPartialDataDisplayHandling (0x0072, 0x0208);
const DICOMTag DICOMSynchronizedScrollingSequence (0x0072, 0x0210);
const DICOMTag DICOMDisplaySetScrollingGroup (0x0072, 0x0212);
const DICOMTag DICOMNavigationIndicatorSequence (0x0072, 0x0214);
const DICOMTag DICOMNavigationDisplaySet (0x0072, 0x0216);
const DICOMTag DICOMReferenceDisplaySets (0x0072, 0x0218);
const DICOMTag DICOMImageBoxesSequence (0x0072, 0x0300);
const DICOMTag DICOMImageBoxNumber (0x0072, 0x0302);
const DICOMTag DICOMImageBoxLayoutType (0x0072, 0x0304);
const DICOMTag DICOMImageBoxTileHorizontalDimension (0x0072, 0x0306);
const DICOMTag DICOMImageBoxTileVerticalDimension (0x0072, 0x0308);
const DICOMTag DICOMImageBoxScrollDirection (0x0072, 0x0310);
const DICOMTag DICOMImageBoxSmallScrollType (0x0072, 0x0312);
const DICOMTag DICOMImageBoxSmallScrollAmount (0x0072, 0x0314);
const DICOMTag DICOMImageBoxLargeScrollType (0x0072, 0x0316);
const DICOMTag DICOMImageBoxLargeScrollAmount (0x0072, 0x0318);
const DICOMTag DICOMImageBoxOverlapPriority (0x0072, 0x0320);
const DICOMTag DICOMCineRelativeToRealTime (0x0072, 0x0330);
const DICOMTag DICOMFilterOperationsSequence (0x0072, 0x0400);
const DICOMTag DICOMFilterByCategory (0x0072, 0x0402);
const DICOMTag DICOMFilterByAttributePresence (0x0072, 0x0404);
const DICOMTag DICOMFilterByOperator (0x0072, 0x0406);
const DICOMTag DICOMStructuredDisplayBackgroundCIELabValue (0x0072, 0x0420);
const DICOMTag DICOMEmptyImageBoxCIELabValue (0x0072, 0x0421);
const DICOMTag DICOMStructuredDisplayImageBoxSequence (0x0072, 0x0422);
const DICOMTag DICOMStructuredDisplayTextBoxSequence (0x0072, 0x0424);
const DICOMTag DICOMReferencedFirstFrameSequence (0x0072, 0x0427);
const DICOMTag DICOMImageBoxSynchronizationSequence (0x0072, 0x0430);
const DICOMTag DICOMSynchronizedImageBoxList (0x0072, 0x0432);
const DICOMTag DICOMTypeOfSynchronization (0x0072, 0x0434);
const DICOMTag DICOMBlendingOperationType (0x0072, 0x0500);
const DICOMTag DICOMReformattingOperationType (0x0072, 0x0510);
const DICOMTag DICOMReformattingThickness (0x0072, 0x0512);
const DICOMTag DICOMReformattingInterval (0x0072, 0x0514);
const DICOMTag DICOMReformattingOperationInitialViewDirection (0x0072, 0x0516);
const DICOMTag DICOMThreeDRenderingType (0x0072, 0x0520);
const DICOMTag DICOMSortingOperationsSequence (0x0072, 0x0600);
const DICOMTag DICOMSortByCategory (0x0072, 0x0602);
const DICOMTag DICOMSortingDirection (0x0072, 0x0604);
const DICOMTag DICOMDisplaySetPatientOrientation (0x0072, 0x0700);
const DICOMTag DICOMVOIType (0x0072, 0x0702);
const DICOMTag DICOMPseudoColorType (0x0072, 0x0704);
const DICOMTag DICOMPseudoColorPaletteInstanceReferenceSequence (0x0072, 0x0705);
const DICOMTag DICOMShowGrayscaleInverted (0x0072, 0x0706);
const DICOMTag DICOMShowImageTrueSizeFlag (0x0072, 0x0710);
const DICOMTag DICOMShowGraphicAnnotationFlag (0x0072, 0x0712);
const DICOMTag DICOMShowPatientDemographicsFlag (0x0072, 0x0714);
const DICOMTag DICOMShowAcquisitionTechniquesFlag (0x0072, 0x0716);
const DICOMTag DICOMDisplaySetHorizontalJustification (0x0072, 0x0717);
const DICOMTag DICOMDisplaySetVerticalJustification (0x0072, 0x0718);
const DICOMTag DICOMContinuationStartMeterset (0x0074, 0x0120);
const DICOMTag DICOMContinuationEndMeterset (0x0074, 0x0121);
const DICOMTag DICOMProcedureStepState (0x0074, 0x1000);
const DICOMTag DICOMProcedureStepProgressInformationSequence (0x0074, 0x1002);
const DICOMTag DICOMProcedureStepProgress (0x0074, 0x1004);
const DICOMTag DICOMProcedureStepProgressDescription (0x0074, 0x1006);
const DICOMTag DICOMProcedureStepCommunicationsURISequence (0x0074, 0x1008);
const DICOMTag DICOMContactURI (0x0074, 0x100a);
const DICOMTag DICOMContactDisplayName (0x0074, 0x100c);
const DICOMTag DICOMProcedureStepDiscontinuationReasonCodeSequence (0x0074, 0x100e);
const DICOMTag DICOMBeamTaskSequence (0x0074, 0x1020);
const DICOMTag DICOMBeamTaskType (0x0074, 0x1022);
const DICOMTag DICOMRETIREDBeamOrderIndexTrial (0x0074, 0x1024);
const DICOMTag DICOMTableTopVerticalAdjustedPosition (0x0074, 0x1026);
const DICOMTag DICOMTableTopLongitudinalAdjustedPosition (0x0074, 0x1027);
const DICOMTag DICOMTableTopLateralAdjustedPosition (0x0074, 0x1028);
const DICOMTag DICOMPatientSupportAdjustedAngle (0x0074, 0x102a);
const DICOMTag DICOMTableTopEccentricAdjustedAngle (0x0074, 0x102b);
const DICOMTag DICOMTableTopPitchAdjustedAngle (0x0074, 0x102c);
const DICOMTag DICOMTableTopRollAdjustedAngle (0x0074, 0x102d);
const DICOMTag DICOMDeliveryVerificationImageSequence (0x0074, 0x1030);
const DICOMTag DICOMVerificationImageTiming (0x0074, 0x1032);
const DICOMTag DICOMDoubleExposureFlag (0x0074, 0x1034);
const DICOMTag DICOMDoubleExposureOrdering (0x0074, 0x1036);
const DICOMTag DICOMRETIREDDoubleExposureMetersetTrial (0x0074, 0x1038);
const DICOMTag DICOMRETIREDDoubleExposureFieldDeltaTrial (0x0074, 0x103a);
const DICOMTag DICOMRelatedReferenceRTImageSequence (0x0074, 0x1040);
const DICOMTag DICOMGeneralMachineVerificationSequence (0x0074, 0x1042);
const DICOMTag DICOMConventionalMachineVerificationSequence (0x0074, 0x1044);
const DICOMTag DICOMIonMachineVerificationSequence (0x0074, 0x1046);
const DICOMTag DICOMFailedAttributesSequence (0x0074, 0x1048);
const DICOMTag DICOMOverriddenAttributesSequence (0x0074, 0x104a);
const DICOMTag DICOMConventionalControlPointVerificationSequence (0x0074, 0x104c);
const DICOMTag DICOMIonControlPointVerificationSequence (0x0074, 0x104e);
const DICOMTag DICOMAttributeOccurrenceSequence (0x0074, 0x1050);
const DICOMTag DICOMAttributeOccurrencePointer (0x0074, 0x1052);
const DICOMTag DICOMAttributeItemSelector (0x0074, 0x1054);
const DICOMTag DICOMAttributeOccurrencePrivateCreator (0x0074, 0x1056);
const DICOMTag DICOMSelectorSequencePointerItems (0x0074, 0x1057);
const DICOMTag DICOMScheduledProcedureStepPriority (0x0074, 0x1200);
const DICOMTag DICOMWorklistLabel (0x0074, 0x1202);
const DICOMTag DICOMProcedureStepLabel (0x0074, 0x1204);
const DICOMTag DICOMScheduledProcessingParametersSequence (0x0074, 0x1210);
const DICOMTag DICOMPerformedProcessingParametersSequence (0x0074, 0x1212);
const DICOMTag DICOMUnifiedProcedureStepPerformedProcedureSequence (0x0074, 0x1216);
const DICOMTag DICOMRETIREDRelatedProcedureStepSequence (0x0074, 0x1220);
const DICOMTag DICOMRETIREDProcedureStepRelationshipType (0x0074, 0x1222);
const DICOMTag DICOMReplacedProcedureStepSequence (0x0074, 0x1224);
const DICOMTag DICOMDeletionLock (0x0074, 0x1230);
const DICOMTag DICOMReceivingAE (0x0074, 0x1234);
const DICOMTag DICOMRequestingAE (0x0074, 0x1236);
const DICOMTag DICOMReasonForCancellation (0x0074, 0x1238);
const DICOMTag DICOMSCPStatus (0x0074, 0x1242);
const DICOMTag DICOMSubscriptionListStatus (0x0074, 0x1244);
const DICOMTag DICOMUnifiedProcedureStepListStatus (0x0074, 0x1246);
const DICOMTag DICOMBeamOrderIndex (0x0074, 0x1324);
const DICOMTag DICOMDoubleExposureMeterset (0x0074, 0x1338);
const DICOMTag DICOMDoubleExposureFieldDelta (0x0074, 0x133a);
const DICOMTag DICOMImplantAssemblyTemplateName (0x0076, 0x0001);
const DICOMTag DICOMImplantAssemblyTemplateIssuer (0x0076, 0x0003);
const DICOMTag DICOMImplantAssemblyTemplateVersion (0x0076, 0x0006);
const DICOMTag DICOMReplacedImplantAssemblyTemplateSequence (0x0076, 0x0008);
const DICOMTag DICOMImplantAssemblyTemplateType (0x0076, 0x000a);
const DICOMTag DICOMOriginalImplantAssemblyTemplateSequence (0x0076, 0x000c);
const DICOMTag DICOMDerivationImplantAssemblyTemplateSequence (0x0076, 0x000e);
const DICOMTag DICOMImplantAssemblyTemplateTargetAnatomySequence (0x0076, 0x0010);
const DICOMTag DICOMProcedureTypeCodeSequence (0x0076, 0x0020);
const DICOMTag DICOMSurgicalTechnique (0x0076, 0x0030);
const DICOMTag DICOMComponentTypesSequence (0x0076, 0x0032);
const DICOMTag DICOMComponentTypeCodeSequence (0x0076, 0x0034);
const DICOMTag DICOMExclusiveComponentType (0x0076, 0x0036);
const DICOMTag DICOMMandatoryComponentType (0x0076, 0x0038);
const DICOMTag DICOMComponentSequence (0x0076, 0x0040);
const DICOMTag DICOMComponentID (0x0076, 0x0055);
const DICOMTag DICOMComponentAssemblySequence (0x0076, 0x0060);
const DICOMTag DICOMComponent1ReferencedID (0x0076, 0x0070);
const DICOMTag DICOMComponent1ReferencedMatingFeatureSetID (0x0076, 0x0080);
const DICOMTag DICOMComponent1ReferencedMatingFeatureID (0x0076, 0x0090);
const DICOMTag DICOMComponent2ReferencedID (0x0076, 0x00a0);
const DICOMTag DICOMComponent2ReferencedMatingFeatureSetID (0x0076, 0x00b0);
const DICOMTag DICOMComponent2ReferencedMatingFeatureID (0x0076, 0x00c0);
const DICOMTag DICOMImplantTemplateGroupName (0x0078, 0x0001);
const DICOMTag DICOMImplantTemplateGroupDescription (0x0078, 0x0010);
const DICOMTag DICOMImplantTemplateGroupIssuer (0x0078, 0x0020);
const DICOMTag DICOMImplantTemplateGroupVersion (0x0078, 0x0024);
const DICOMTag DICOMReplacedImplantTemplateGroupSequence (0x0078, 0x0026);
const DICOMTag DICOMImplantTemplateGroupTargetAnatomySequence (0x0078, 0x0028);
const DICOMTag DICOMImplantTemplateGroupMembersSequence (0x0078, 0x002a);
const DICOMTag DICOMImplantTemplateGroupMemberID (0x0078, 0x002e);
const DICOMTag DICOMThreeDImplantTemplateGroupMemberMatchingPoint (0x0078, 0x0050);
const DICOMTag DICOMThreeDImplantTemplateGroupMemberMatchingAxes (0x0078, 0x0060);
const DICOMTag DICOMImplantTemplateGroupMemberMatching2DCoordinatesSequence (0x0078, 0x0070);
const DICOMTag DICOMTwoDImplantTemplateGroupMemberMatchingPoint (0x0078, 0x0090);
const DICOMTag DICOMTwoDImplantTemplateGroupMemberMatchingAxes (0x0078, 0x00a0);
const DICOMTag DICOMImplantTemplateGroupVariationDimensionSequence (0x0078, 0x00b0);
const DICOMTag DICOMImplantTemplateGroupVariationDimensionName (0x0078, 0x00b2);
const DICOMTag DICOMImplantTemplateGroupVariationDimensionRankSequence (0x0078, 0x00b4);
const DICOMTag DICOMReferencedImplantTemplateGroupMemberID (0x0078, 0x00b6);
const DICOMTag DICOMImplantTemplateGroupVariationDimensionRank (0x0078, 0x00b8);
const DICOMTag DICOMStorageMediaFileSetID (0x0088, 0x0130);
const DICOMTag DICOMStorageMediaFileSetUID (0x0088, 0x0140);
const DICOMTag DICOMIconImageSequence (0x0088, 0x0200);
const DICOMTag DICOMRETIREDTopicTitle (0x0088, 0x0904);
const DICOMTag DICOMRETIREDTopicSubject (0x0088, 0x0906);
const DICOMTag DICOMRETIREDTopicAuthor (0x0088, 0x0910);
const DICOMTag DICOMRETIREDTopicKeywords (0x0088, 0x0912);
const DICOMTag DICOMSOPInstanceStatus (0x0100, 0x0410);
const DICOMTag DICOMSOPAuthorizationDateTime (0x0100, 0x0420);
const DICOMTag DICOMSOPAuthorizationComment (0x0100, 0x0424);
const DICOMTag DICOMAuthorizationEquipmentCertificationNumber (0x0100, 0x0426);
const DICOMTag DICOMMACIDNumber (0x0400, 0x0005);
const DICOMTag DICOMMACCalculationTransferSyntaxUID (0x0400, 0x0010);
const DICOMTag DICOMMACAlgorithm (0x0400, 0x0015);
const DICOMTag DICOMDataElementsSigned (0x0400, 0x0020);
const DICOMTag DICOMDigitalSignatureUID (0x0400, 0x0100);
const DICOMTag DICOMDigitalSignatureDateTime (0x0400, 0x0105);
const DICOMTag DICOMCertificateType (0x0400, 0x0110);
const DICOMTag DICOMCertificateOfSigner (0x0400, 0x0115);
const DICOMTag DICOMSignature (0x0400, 0x0120);
const DICOMTag DICOMCertifiedTimestampType (0x0400, 0x0305);
const DICOMTag DICOMCertifiedTimestamp (0x0400, 0x0310);
const DICOMTag DICOMDigitalSignaturePurposeCodeSequence (0x0400, 0x0401);
const DICOMTag DICOMReferencedDigitalSignatureSequence (0x0400, 0x0402);
const DICOMTag DICOMReferencedSOPInstanceMACSequence (0x0400, 0x0403);
const DICOMTag DICOMMAC (0x0400, 0x0404);
const DICOMTag DICOMEncryptedAttributesSequence (0x0400, 0x0500);
const DICOMTag DICOMEncryptedContentTransferSyntaxUID (0x0400, 0x0510);
const DICOMTag DICOMEncryptedContent (0x0400, 0x0520);
const DICOMTag DICOMModifiedAttributesSequence (0x0400, 0x0550);
const DICOMTag DICOMOriginalAttributesSequence (0x0400, 0x0561);
const DICOMTag DICOMAttributeModificationDateTime (0x0400, 0x0562);
const DICOMTag DICOMModifyingSystem (0x0400, 0x0563);
const DICOMTag DICOMSourceOfPreviousValues (0x0400, 0x0564);
const DICOMTag DICOMReasonForTheAttributeModification (0x0400, 0x0565);
const DICOMTag DICOMACR_NEMA_2C_CodeTableGroupLength (0x1000, 0x0000);
const DICOMTag DICOMACR_NEMA_2C_EscapeTriplet (0x1000, 0x0010);
const DICOMTag DICOMACR_NEMA_2C_RunLengthTriplet (0x1000, 0x0011);
const DICOMTag DICOMACR_NEMA_2C_HuffmanTableSize (0x1000, 0x0012);
const DICOMTag DICOMACR_NEMA_2C_HuffmanTableTriplet (0x1000, 0x0013);
const DICOMTag DICOMACR_NEMA_2C_ShiftTableSize (0x1000, 0x0014);
const DICOMTag DICOMACR_NEMA_2C_ShiftTableTriplet (0x1000, 0x0015);
const DICOMTag DICOMACR_NEMA_2C_ZonalMapGroupLength (0x1010, 0x0000);
const DICOMTag DICOMACR_NEMA_2C_ZonalMap (0x1010, 0x0004);
const DICOMTag DICOMNumberOfCopies (0x2000, 0x0010);
const DICOMTag DICOMPrinterConfigurationSequence (0x2000, 0x001e);
const DICOMTag DICOMPrintPriority (0x2000, 0x0020);
const DICOMTag DICOMMediumType (0x2000, 0x0030);
const DICOMTag DICOMFilmDestination (0x2000, 0x0040);
const DICOMTag DICOMFilmSessionLabel (0x2000, 0x0050);
const DICOMTag DICOMMemoryAllocation (0x2000, 0x0060);
const DICOMTag DICOMMaximumMemoryAllocation (0x2000, 0x0061);
const DICOMTag DICOMRETIREDColorImagePrintingFlag (0x2000, 0x0062);
const DICOMTag DICOMRETIREDCollationFlag (0x2000, 0x0063);
const DICOMTag DICOMRETIREDAnnotationFlag (0x2000, 0x0065);
const DICOMTag DICOMRETIREDImageOverlayFlag (0x2000, 0x0067);
const DICOMTag DICOMRETIREDPresentationLUTFlag (0x2000, 0x0069);
const DICOMTag DICOMRETIREDImageBoxPresentationLUTFlag (0x2000, 0x006a);
const DICOMTag DICOMMemoryBitDepth (0x2000, 0x00a0);
const DICOMTag DICOMPrintingBitDepth (0x2000, 0x00a1);
const DICOMTag DICOMMediaInstalledSequence (0x2000, 0x00a2);
const DICOMTag DICOMOtherMediaAvailableSequence (0x2000, 0x00a4);
const DICOMTag DICOMSupportedImageDisplayFormatsSequence (0x2000, 0x00a8);
const DICOMTag DICOMReferencedFilmBoxSequence (0x2000, 0x0500);
const DICOMTag DICOMRETIREDReferencedStoredPrintSequence (0x2000, 0x0510);
const DICOMTag DICOMImageDisplayFormat (0x2010, 0x0010);
const DICOMTag DICOMAnnotationDisplayFormatID (0x2010, 0x0030);
const DICOMTag DICOMFilmOrientation (0x2010, 0x0040);
const DICOMTag DICOMFilmSizeID (0x2010, 0x0050);
const DICOMTag DICOMPrinterResolutionID (0x2010, 0x0052);
const DICOMTag DICOMDefaultPrinterResolutionID (0x2010, 0x0054);
const DICOMTag DICOMMagnificationType (0x2010, 0x0060);
const DICOMTag DICOMSmoothingType (0x2010, 0x0080);
const DICOMTag DICOMDefaultMagnificationType (0x2010, 0x00a6);
const DICOMTag DICOMOtherMagnificationTypesAvailable (0x2010, 0x00a7);
const DICOMTag DICOMDefaultSmoothingType (0x2010, 0x00a8);
const DICOMTag DICOMOtherSmoothingTypesAvailable (0x2010, 0x00a9);
const DICOMTag DICOMBorderDensity (0x2010, 0x0100);
const DICOMTag DICOMEmptyImageDensity (0x2010, 0x0110);
const DICOMTag DICOMMinDensity (0x2010, 0x0120);
const DICOMTag DICOMMaxDensity (0x2010, 0x0130);
const DICOMTag DICOMTrim (0x2010, 0x0140);
const DICOMTag DICOMConfigurationInformation (0x2010, 0x0150);
const DICOMTag DICOMConfigurationInformationDescription (0x2010, 0x0152);
const DICOMTag DICOMMaximumCollatedFilms (0x2010, 0x0154);
const DICOMTag DICOMIllumination (0x2010, 0x015e);
const DICOMTag DICOMReflectedAmbientLight (0x2010, 0x0160);
const DICOMTag DICOMPrinterPixelSpacing (0x2010, 0x0376);
const DICOMTag DICOMReferencedFilmSessionSequence (0x2010, 0x0500);
const DICOMTag DICOMReferencedImageBoxSequence (0x2010, 0x0510);
const DICOMTag DICOMReferencedBasicAnnotationBoxSequence (0x2010, 0x0520);
const DICOMTag DICOMImageBoxPosition (0x2020, 0x0010);
const DICOMTag DICOMPolarity (0x2020, 0x0020);
const DICOMTag DICOMRequestedImageSize (0x2020, 0x0030);
const DICOMTag DICOMRequestedDecimateCropBehavior (0x2020, 0x0040);
const DICOMTag DICOMRequestedResolutionID (0x2020, 0x0050);
const DICOMTag DICOMRequestedImageSizeFlag (0x2020, 0x00a0);
const DICOMTag DICOMDecimateCropResult (0x2020, 0x00a2);
const DICOMTag DICOMBasicGrayscaleImageSequence (0x2020, 0x0110);
const DICOMTag DICOMBasicColorImageSequence (0x2020, 0x0111);
const DICOMTag DICOMRETIREDReferencedImageOverlayBoxSequence (0x2020, 0x0130);
const DICOMTag DICOMRETIREDReferencedVOILUTBoxSequence (0x2020, 0x0140);
const DICOMTag DICOMAnnotationPosition (0x2030, 0x0010);
const DICOMTag DICOMTextString (0x2030, 0x0020);
const DICOMTag DICOMRETIREDReferencedOverlayPlaneSequence (0x2040, 0x0010);
const DICOMTag DICOMRETIREDReferencedOverlayPlaneGroups (0x2040, 0x0011);
const DICOMTag DICOMRETIREDOverlayPixelDataSequence (0x2040, 0x0020);
const DICOMTag DICOMRETIREDOverlayMagnificationType (0x2040, 0x0060);
const DICOMTag DICOMRETIREDOverlaySmoothingType (0x2040, 0x0070);
const DICOMTag DICOMRETIREDOverlayOrImageMagnification (0x2040, 0x0072);
const DICOMTag DICOMRETIREDMagnifyToNumberOfColumns (0x2040, 0x0074);
const DICOMTag DICOMRETIREDOverlayForegroundDensity (0x2040, 0x0080);
const DICOMTag DICOMRETIREDOverlayBackgroundDensity (0x2040, 0x0082);
const DICOMTag DICOMRETIREDOverlayMode (0x2040, 0x0090);
const DICOMTag DICOMRETIREDThresholdDensity (0x2040, 0x0100);
const DICOMTag DICOMRETIREDReferencedImageBoxSequenceRetired (0x2040, 0x0500);
const DICOMTag DICOMPresentationLUTSequence (0x2050, 0x0010);
const DICOMTag DICOMPresentationLUTShape (0x2050, 0x0020);
const DICOMTag DICOMReferencedPresentationLUTSequence (0x2050, 0x0500);
const DICOMTag DICOMRETIREDPrintJobID (0x2100, 0x0010);
const DICOMTag DICOMExecutionStatus (0x2100, 0x0020);
const DICOMTag DICOMExecutionStatusInfo (0x2100, 0x0030);
const DICOMTag DICOMCreationDate (0x2100, 0x0040);
const DICOMTag DICOMCreationTime (0x2100, 0x0050);
const DICOMTag DICOMOriginator (0x2100, 0x0070);
const DICOMTag DICOMRETIREDDestinationAE (0x2100, 0x0140);
const DICOMTag DICOMOwnerID (0x2100, 0x0160);
const DICOMTag DICOMNumberOfFilms (0x2100, 0x0170);
const DICOMTag DICOMRETIREDReferencedPrintJobSequencePullStoredPrint (0x2100, 0x0500);
const DICOMTag DICOMPrinterStatus (0x2110, 0x0010);
const DICOMTag DICOMPrinterStatusInfo (0x2110, 0x0020);
const DICOMTag DICOMPrinterName (0x2110, 0x0030);
const DICOMTag DICOMRETIREDPrintQueueID (0x2110, 0x0099);
const DICOMTag DICOMRETIREDQueueStatus (0x2120, 0x0010);
const DICOMTag DICOMRETIREDPrintJobDescriptionSequence (0x2120, 0x0050);
const DICOMTag DICOMRETIREDReferencedPrintJobSequence (0x2120, 0x0070);
const DICOMTag DICOMRETIREDPrintManagementCapabilitiesSequence (0x2130, 0x0010);
const DICOMTag DICOMRETIREDPrinterCharacteristicsSequence (0x2130, 0x0015);
const DICOMTag DICOMRETIREDFilmBoxContentSequence (0x2130, 0x0030);
const DICOMTag DICOMRETIREDImageBoxContentSequence (0x2130, 0x0040);
const DICOMTag DICOMRETIREDAnnotationContentSequence (0x2130, 0x0050);
const DICOMTag DICOMRETIREDImageOverlayBoxContentSequence (0x2130, 0x0060);
const DICOMTag DICOMRETIREDPresentationLUTContentSequence (0x2130, 0x0080);
const DICOMTag DICOMRETIREDProposedStudySequence (0x2130, 0x00a0);
const DICOMTag DICOMRETIREDOriginalImageSequence (0x2130, 0x00c0);
const DICOMTag DICOMLabelUsingInformationExtractedFromInstances (0x2200, 0x0001);
const DICOMTag DICOMLabelText (0x2200, 0x0002);
const DICOMTag DICOMLabelStyleSelection (0x2200, 0x0003);
const DICOMTag DICOMMediaDisposition (0x2200, 0x0004);
const DICOMTag DICOMBarcodeValue (0x2200, 0x0005);
const DICOMTag DICOMBarcodeSymbology (0x2200, 0x0006);
const DICOMTag DICOMAllowMediaSplitting (0x2200, 0x0007);
const DICOMTag DICOMIncludeNonDICOMObjects (0x2200, 0x0008);
const DICOMTag DICOMIncludeDisplayApplication (0x2200, 0x0009);
const DICOMTag DICOMPreserveCompositeInstancesAfterMediaCreation (0x2200, 0x000a);
const DICOMTag DICOMTotalNumberOfPiecesOfMediaCreated (0x2200, 0x000b);
const DICOMTag DICOMRequestedMediaApplicationProfile (0x2200, 0x000c);
const DICOMTag DICOMReferencedStorageMediaSequence (0x2200, 0x000d);
const DICOMTag DICOMFailureAttributes (0x2200, 0x000e);
const DICOMTag DICOMAllowLossyCompression (0x2200, 0x000f);
const DICOMTag DICOMRequestPriority (0x2200, 0x0020);
const DICOMTag DICOMRTImageLabel (0x3002, 0x0002);
const DICOMTag DICOMRTImageName (0x3002, 0x0003);
const DICOMTag DICOMRTImageDescription (0x3002, 0x0004);
const DICOMTag DICOMReportedValuesOrigin (0x3002, 0x000a);
const DICOMTag DICOMRTImagePlane (0x3002, 0x000c);
const DICOMTag DICOMXRayImageReceptorTranslation (0x3002, 0x000d);
const DICOMTag DICOMXRayImageReceptorAngle (0x3002, 0x000e);
const DICOMTag DICOMRTImageOrientation (0x3002, 0x0010);
const DICOMTag DICOMImagePlanePixelSpacing (0x3002, 0x0011);
const DICOMTag DICOMRTImagePosition (0x3002, 0x0012);
const DICOMTag DICOMRadiationMachineName (0x3002, 0x0020);
const DICOMTag DICOMRadiationMachineSAD (0x3002, 0x0022);
const DICOMTag DICOMRadiationMachineSSD (0x3002, 0x0024);
const DICOMTag DICOMRTImageSID (0x3002, 0x0026);
const DICOMTag DICOMSourceToReferenceObjectDistance (0x3002, 0x0028);
const DICOMTag DICOMFractionNumber (0x3002, 0x0029);
const DICOMTag DICOMExposureSequence (0x3002, 0x0030);
const DICOMTag DICOMMetersetExposure (0x3002, 0x0032);
const DICOMTag DICOMDiaphragmPosition (0x3002, 0x0034);
const DICOMTag DICOMFluenceMapSequence (0x3002, 0x0040);
const DICOMTag DICOMFluenceDataSource (0x3002, 0x0041);
const DICOMTag DICOMFluenceDataScale (0x3002, 0x0042);
const DICOMTag DICOMPrimaryFluenceModeSequence (0x3002, 0x0050);
const DICOMTag DICOMFluenceMode (0x3002, 0x0051);
const DICOMTag DICOMFluenceModeID (0x3002, 0x0052);
const DICOMTag DICOMDVHType (0x3004, 0x0001);
const DICOMTag DICOMDoseUnits (0x3004, 0x0002);
const DICOMTag DICOMDoseType (0x3004, 0x0004);
const DICOMTag DICOMDoseComment (0x3004, 0x0006);
const DICOMTag DICOMNormalizationPoint (0x3004, 0x0008);
const DICOMTag DICOMDoseSummationType (0x3004, 0x000a);
const DICOMTag DICOMGridFrameOffsetVector (0x3004, 0x000c);
const DICOMTag DICOMDoseGridScaling (0x3004, 0x000e);
const DICOMTag DICOMRTDoseROISequence (0x3004, 0x0010);
const DICOMTag DICOMDoseValue (0x3004, 0x0012);
const DICOMTag DICOMTissueHeterogeneityCorrection (0x3004, 0x0014);
const DICOMTag DICOMDVHNormalizationPoint (0x3004, 0x0040);
const DICOMTag DICOMDVHNormalizationDoseValue (0x3004, 0x0042);
const DICOMTag DICOMDVHSequence (0x3004, 0x0050);
const DICOMTag DICOMDVHDoseScaling (0x3004, 0x0052);
const DICOMTag DICOMDVHVolumeUnits (0x3004, 0x0054);
const DICOMTag DICOMDVHNumberOfBins (0x3004, 0x0056);
const DICOMTag DICOMDVHData (0x3004, 0x0058);
const DICOMTag DICOMDVHReferencedROISequence (0x3004, 0x0060);
const DICOMTag DICOMDVHROIContributionType (0x3004, 0x0062);
const DICOMTag DICOMDVHMinimumDose (0x3004, 0x0070);
const DICOMTag DICOMDVHMaximumDose (0x3004, 0x0072);
const DICOMTag DICOMDVHMeanDose (0x3004, 0x0074);
const DICOMTag DICOMStructureSetLabel (0x3006, 0x0002);
const DICOMTag DICOMStructureSetName (0x3006, 0x0004);
const DICOMTag DICOMStructureSetDescription (0x3006, 0x0006);
const DICOMTag DICOMStructureSetDate (0x3006, 0x0008);
const DICOMTag DICOMStructureSetTime (0x3006, 0x0009);
const DICOMTag DICOMReferencedFrameOfReferenceSequence (0x3006, 0x0010);
const DICOMTag DICOMRTReferencedStudySequence (0x3006, 0x0012);
const DICOMTag DICOMRTReferencedSeriesSequence (0x3006, 0x0014);
const DICOMTag DICOMContourImageSequence (0x3006, 0x0016);
const DICOMTag DICOMStructureSetROISequence (0x3006, 0x0020);
const DICOMTag DICOMROINumber (0x3006, 0x0022);
const DICOMTag DICOMReferencedFrameOfReferenceUID (0x3006, 0x0024);
const DICOMTag DICOMROIName (0x3006, 0x0026);
const DICOMTag DICOMROIDescription (0x3006, 0x0028);
const DICOMTag DICOMROIDisplayColor (0x3006, 0x002a);
const DICOMTag DICOMROIVolume (0x3006, 0x002c);
const DICOMTag DICOMRTRelatedROISequence (0x3006, 0x0030);
const DICOMTag DICOMRTROIRelationship (0x3006, 0x0033);
const DICOMTag DICOMROIGenerationAlgorithm (0x3006, 0x0036);
const DICOMTag DICOMROIGenerationDescription (0x3006, 0x0038);
const DICOMTag DICOMROIContourSequence (0x3006, 0x0039);
const DICOMTag DICOMContourSequence (0x3006, 0x0040);
const DICOMTag DICOMContourGeometricType (0x3006, 0x0042);
const DICOMTag DICOMContourSlabThickness (0x3006, 0x0044);
const DICOMTag DICOMContourOffsetVector (0x3006, 0x0045);
const DICOMTag DICOMNumberOfContourPoints (0x3006, 0x0046);
const DICOMTag DICOMContourNumber (0x3006, 0x0048);
const DICOMTag DICOMAttachedContours (0x3006, 0x0049);
const DICOMTag DICOMContourData (0x3006, 0x0050);
const DICOMTag DICOMRTROIObservationsSequence (0x3006, 0x0080);
const DICOMTag DICOMObservationNumber (0x3006, 0x0082);
const DICOMTag DICOMReferencedROINumber (0x3006, 0x0084);
const DICOMTag DICOMROIObservationLabel (0x3006, 0x0085);
const DICOMTag DICOMRTROIIdentificationCodeSequence (0x3006, 0x0086);
const DICOMTag DICOMROIObservationDescription (0x3006, 0x0088);
const DICOMTag DICOMRelatedRTROIObservationsSequence (0x3006, 0x00a0);
const DICOMTag DICOMRTROIInterpretedType (0x3006, 0x00a4);
const DICOMTag DICOMROIInterpreter (0x3006, 0x00a6);
const DICOMTag DICOMROIPhysicalPropertiesSequence (0x3006, 0x00b0);
const DICOMTag DICOMROIPhysicalProperty (0x3006, 0x00b2);
const DICOMTag DICOMROIPhysicalPropertyValue (0x3006, 0x00b4);
const DICOMTag DICOMROIElementalCompositionSequence (0x3006, 0x00b6);
const DICOMTag DICOMROIElementalCompositionAtomicNumber (0x3006, 0x00b7);
const DICOMTag DICOMROIElementalCompositionAtomicMassFraction (0x3006, 0x00b8);
const DICOMTag DICOMFrameOfReferenceRelationshipSequence (0x3006, 0x00c0);
const DICOMTag DICOMRelatedFrameOfReferenceUID (0x3006, 0x00c2);
const DICOMTag DICOMFrameOfReferenceTransformationType (0x3006, 0x00c4);
const DICOMTag DICOMFrameOfReferenceTransformationMatrix (0x3006, 0x00c6);
const DICOMTag DICOMFrameOfReferenceTransformationComment (0x3006, 0x00c8);
const DICOMTag DICOMMeasuredDoseReferenceSequence (0x3008, 0x0010);
const DICOMTag DICOMMeasuredDoseDescription (0x3008, 0x0012);
const DICOMTag DICOMMeasuredDoseType (0x3008, 0x0014);
const DICOMTag DICOMMeasuredDoseValue (0x3008, 0x0016);
const DICOMTag DICOMTreatmentSessionBeamSequence (0x3008, 0x0020);
const DICOMTag DICOMTreatmentSessionIonBeamSequence (0x3008, 0x0021);
const DICOMTag DICOMCurrentFractionNumber (0x3008, 0x0022);
const DICOMTag DICOMTreatmentControlPointDate (0x3008, 0x0024);
const DICOMTag DICOMTreatmentControlPointTime (0x3008, 0x0025);
const DICOMTag DICOMTreatmentTerminationStatus (0x3008, 0x002a);
const DICOMTag DICOMTreatmentTerminationCode (0x3008, 0x002b);
const DICOMTag DICOMTreatmentVerificationStatus (0x3008, 0x002c);
const DICOMTag DICOMReferencedTreatmentRecordSequence (0x3008, 0x0030);
const DICOMTag DICOMSpecifiedPrimaryMeterset (0x3008, 0x0032);
const DICOMTag DICOMSpecifiedSecondaryMeterset (0x3008, 0x0033);
const DICOMTag DICOMDeliveredPrimaryMeterset (0x3008, 0x0036);
const DICOMTag DICOMDeliveredSecondaryMeterset (0x3008, 0x0037);
const DICOMTag DICOMSpecifiedTreatmentTime (0x3008, 0x003a);
const DICOMTag DICOMDeliveredTreatmentTime (0x3008, 0x003b);
const DICOMTag DICOMControlPointDeliverySequence (0x3008, 0x0040);
const DICOMTag DICOMIonControlPointDeliverySequence (0x3008, 0x0041);
const DICOMTag DICOMSpecifiedMeterset (0x3008, 0x0042);
const DICOMTag DICOMDeliveredMeterset (0x3008, 0x0044);
const DICOMTag DICOMMetersetRateSet (0x3008, 0x0045);
const DICOMTag DICOMMetersetRateDelivered (0x3008, 0x0046);
const DICOMTag DICOMScanSpotMetersetsDelivered (0x3008, 0x0047);
const DICOMTag DICOMDoseRateDelivered (0x3008, 0x0048);
const DICOMTag DICOMTreatmentSummaryCalculatedDoseReferenceSequence (0x3008, 0x0050);
const DICOMTag DICOMCumulativeDoseToDoseReference (0x3008, 0x0052);
const DICOMTag DICOMFirstTreatmentDate (0x3008, 0x0054);
const DICOMTag DICOMMostRecentTreatmentDate (0x3008, 0x0056);
const DICOMTag DICOMNumberOfFractionsDelivered (0x3008, 0x005a);
const DICOMTag DICOMOverrideSequence (0x3008, 0x0060);
const DICOMTag DICOMParameterSequencePointer (0x3008, 0x0061);
const DICOMTag DICOMOverrideParameterPointer (0x3008, 0x0062);
const DICOMTag DICOMParameterItemIndex (0x3008, 0x0063);
const DICOMTag DICOMMeasuredDoseReferenceNumber (0x3008, 0x0064);
const DICOMTag DICOMParameterPointer (0x3008, 0x0065);
const DICOMTag DICOMOverrideReason (0x3008, 0x0066);
const DICOMTag DICOMCorrectedParameterSequence (0x3008, 0x0068);
const DICOMTag DICOMCorrectionValue (0x3008, 0x006a);
const DICOMTag DICOMCalculatedDoseReferenceSequence (0x3008, 0x0070);
const DICOMTag DICOMCalculatedDoseReferenceNumber (0x3008, 0x0072);
const DICOMTag DICOMCalculatedDoseReferenceDescription (0x3008, 0x0074);
const DICOMTag DICOMCalculatedDoseReferenceDoseValue (0x3008, 0x0076);
const DICOMTag DICOMStartMeterset (0x3008, 0x0078);
const DICOMTag DICOMEndMeterset (0x3008, 0x007a);
const DICOMTag DICOMReferencedMeasuredDoseReferenceSequence (0x3008, 0x0080);
const DICOMTag DICOMReferencedMeasuredDoseReferenceNumber (0x3008, 0x0082);
const DICOMTag DICOMReferencedCalculatedDoseReferenceSequence (0x3008, 0x0090);
const DICOMTag DICOMReferencedCalculatedDoseReferenceNumber (0x3008, 0x0092);
const DICOMTag DICOMBeamLimitingDeviceLeafPairsSequence (0x3008, 0x00a0);
const DICOMTag DICOMRecordedWedgeSequence (0x3008, 0x00b0);
const DICOMTag DICOMRecordedCompensatorSequence (0x3008, 0x00c0);
const DICOMTag DICOMRecordedBlockSequence (0x3008, 0x00d0);
const DICOMTag DICOMTreatmentSummaryMeasuredDoseReferenceSequence (0x3008, 0x00e0);
const DICOMTag DICOMRecordedSnoutSequence (0x3008, 0x00f0);
const DICOMTag DICOMRecordedRangeShifterSequence (0x3008, 0x00f2);
const DICOMTag DICOMRecordedLateralSpreadingDeviceSequence (0x3008, 0x00f4);
const DICOMTag DICOMRecordedRangeModulatorSequence (0x3008, 0x00f6);
const DICOMTag DICOMRecordedSourceSequence (0x3008, 0x0100);
const DICOMTag DICOMSourceSerialNumber (0x3008, 0x0105);
const DICOMTag DICOMTreatmentSessionApplicationSetupSequence (0x3008, 0x0110);
const DICOMTag DICOMApplicationSetupCheck (0x3008, 0x0116);
const DICOMTag DICOMRecordedBrachyAccessoryDeviceSequence (0x3008, 0x0120);
const DICOMTag DICOMReferencedBrachyAccessoryDeviceNumber (0x3008, 0x0122);
const DICOMTag DICOMRecordedChannelSequence (0x3008, 0x0130);
const DICOMTag DICOMSpecifiedChannelTotalTime (0x3008, 0x0132);
const DICOMTag DICOMDeliveredChannelTotalTime (0x3008, 0x0134);
const DICOMTag DICOMSpecifiedNumberOfPulses (0x3008, 0x0136);
const DICOMTag DICOMDeliveredNumberOfPulses (0x3008, 0x0138);
const DICOMTag DICOMSpecifiedPulseRepetitionInterval (0x3008, 0x013a);
const DICOMTag DICOMDeliveredPulseRepetitionInterval (0x3008, 0x013c);
const DICOMTag DICOMRecordedSourceApplicatorSequence (0x3008, 0x0140);
const DICOMTag DICOMReferencedSourceApplicatorNumber (0x3008, 0x0142);
const DICOMTag DICOMRecordedChannelShieldSequence (0x3008, 0x0150);
const DICOMTag DICOMReferencedChannelShieldNumber (0x3008, 0x0152);
const DICOMTag DICOMBrachyControlPointDeliveredSequence (0x3008, 0x0160);
const DICOMTag DICOMSafePositionExitDate (0x3008, 0x0162);
const DICOMTag DICOMSafePositionExitTime (0x3008, 0x0164);
const DICOMTag DICOMSafePositionReturnDate (0x3008, 0x0166);
const DICOMTag DICOMSafePositionReturnTime (0x3008, 0x0168);
const DICOMTag DICOMCurrentTreatmentStatus (0x3008, 0x0200);
const DICOMTag DICOMTreatmentStatusComment (0x3008, 0x0202);
const DICOMTag DICOMFractionGroupSummarySequence (0x3008, 0x0220);
const DICOMTag DICOMReferencedFractionNumber (0x3008, 0x0223);
const DICOMTag DICOMFractionGroupType (0x3008, 0x0224);
const DICOMTag DICOMBeamStopperPosition (0x3008, 0x0230);
const DICOMTag DICOMFractionStatusSummarySequence (0x3008, 0x0240);
const DICOMTag DICOMTreatmentDate (0x3008, 0x0250);
const DICOMTag DICOMTreatmentTime (0x3008, 0x0251);
const DICOMTag DICOMRTPlanLabel (0x300a, 0x0002);
const DICOMTag DICOMRTPlanName (0x300a, 0x0003);
const DICOMTag DICOMRTPlanDescription (0x300a, 0x0004);
const DICOMTag DICOMRTPlanDate (0x300a, 0x0006);
const DICOMTag DICOMRTPlanTime (0x300a, 0x0007);
const DICOMTag DICOMTreatmentProtocols (0x300a, 0x0009);
const DICOMTag DICOMPlanIntent (0x300a, 0x000a);
const DICOMTag DICOMTreatmentSites (0x300a, 0x000b);
const DICOMTag DICOMRTPlanGeometry (0x300a, 0x000c);
const DICOMTag DICOMPrescriptionDescription (0x300a, 0x000e);
const DICOMTag DICOMDoseReferenceSequence (0x300a, 0x0010);
const DICOMTag DICOMDoseReferenceNumber (0x300a, 0x0012);
const DICOMTag DICOMDoseReferenceUID (0x300a, 0x0013);
const DICOMTag DICOMDoseReferenceStructureType (0x300a, 0x0014);
const DICOMTag DICOMNominalBeamEnergyUnit (0x300a, 0x0015);
const DICOMTag DICOMDoseReferenceDescription (0x300a, 0x0016);
const DICOMTag DICOMDoseReferencePointCoordinates (0x300a, 0x0018);
const DICOMTag DICOMNominalPriorDose (0x300a, 0x001a);
const DICOMTag DICOMDoseReferenceType (0x300a, 0x0020);
const DICOMTag DICOMConstraintWeight (0x300a, 0x0021);
const DICOMTag DICOMDeliveryWarningDose (0x300a, 0x0022);
const DICOMTag DICOMDeliveryMaximumDose (0x300a, 0x0023);
const DICOMTag DICOMTargetMinimumDose (0x300a, 0x0025);
const DICOMTag DICOMTargetPrescriptionDose (0x300a, 0x0026);
const DICOMTag DICOMTargetMaximumDose (0x300a, 0x0027);
const DICOMTag DICOMTargetUnderdoseVolumeFraction (0x300a, 0x0028);
const DICOMTag DICOMOrganAtRiskFullVolumeDose (0x300a, 0x002a);
const DICOMTag DICOMOrganAtRiskLimitDose (0x300a, 0x002b);
const DICOMTag DICOMOrganAtRiskMaximumDose (0x300a, 0x002c);
const DICOMTag DICOMOrganAtRiskOverdoseVolumeFraction (0x300a, 0x002d);
const DICOMTag DICOMToleranceTableSequence (0x300a, 0x0040);
const DICOMTag DICOMToleranceTableNumber (0x300a, 0x0042);
const DICOMTag DICOMToleranceTableLabel (0x300a, 0x0043);
const DICOMTag DICOMGantryAngleTolerance (0x300a, 0x0044);
const DICOMTag DICOMBeamLimitingDeviceAngleTolerance (0x300a, 0x0046);
const DICOMTag DICOMBeamLimitingDeviceToleranceSequence (0x300a, 0x0048);
const DICOMTag DICOMBeamLimitingDevicePositionTolerance (0x300a, 0x004a);
const DICOMTag DICOMSnoutPositionTolerance (0x300a, 0x004b);
const DICOMTag DICOMPatientSupportAngleTolerance (0x300a, 0x004c);
const DICOMTag DICOMTableTopEccentricAngleTolerance (0x300a, 0x004e);
const DICOMTag DICOMTableTopPitchAngleTolerance (0x300a, 0x004f);
const DICOMTag DICOMTableTopRollAngleTolerance (0x300a, 0x0050);
const DICOMTag DICOMTableTopVerticalPositionTolerance (0x300a, 0x0051);
const DICOMTag DICOMTableTopLongitudinalPositionTolerance (0x300a, 0x0052);
const DICOMTag DICOMTableTopLateralPositionTolerance (0x300a, 0x0053);
const DICOMTag DICOMRTPlanRelationship (0x300a, 0x0055);
const DICOMTag DICOMFractionGroupSequence (0x300a, 0x0070);
const DICOMTag DICOMFractionGroupNumber (0x300a, 0x0071);
const DICOMTag DICOMFractionGroupDescription (0x300a, 0x0072);
const DICOMTag DICOMNumberOfFractionsPlanned (0x300a, 0x0078);
const DICOMTag DICOMNumberOfFractionPatternDigitsPerDay (0x300a, 0x0079);
const DICOMTag DICOMRepeatFractionCycleLength (0x300a, 0x007a);
const DICOMTag DICOMFractionPattern (0x300a, 0x007b);
const DICOMTag DICOMNumberOfBeams (0x300a, 0x0080);
const DICOMTag DICOMBeamDoseSpecificationPoint (0x300a, 0x0082);
const DICOMTag DICOMBeamDose (0x300a, 0x0084);
const DICOMTag DICOMBeamMeterset (0x300a, 0x0086);
const DICOMTag DICOMBeamDosePointDepth (0x300a, 0x0088);
const DICOMTag DICOMBeamDosePointEquivalentDepth (0x300a, 0x0089);
const DICOMTag DICOMBeamDosePointSSD (0x300a, 0x008a);
const DICOMTag DICOMNumberOfBrachyApplicationSetups (0x300a, 0x00a0);
const DICOMTag DICOMBrachyApplicationSetupDoseSpecificationPoint (0x300a, 0x00a2);
const DICOMTag DICOMBrachyApplicationSetupDose (0x300a, 0x00a4);
const DICOMTag DICOMBeamSequence (0x300a, 0x00b0);
const DICOMTag DICOMTreatmentMachineName (0x300a, 0x00b2);
const DICOMTag DICOMPrimaryDosimeterUnit (0x300a, 0x00b3);
const DICOMTag DICOMSourceAxisDistance (0x300a, 0x00b4);
const DICOMTag DICOMBeamLimitingDeviceSequence (0x300a, 0x00b6);
const DICOMTag DICOMRTBeamLimitingDeviceType (0x300a, 0x00b8);
const DICOMTag DICOMSourceToBeamLimitingDeviceDistance (0x300a, 0x00ba);
const DICOMTag DICOMIsocenterToBeamLimitingDeviceDistance (0x300a, 0x00bb);
const DICOMTag DICOMNumberOfLeafJawPairs (0x300a, 0x00bc);
const DICOMTag DICOMLeafPositionBoundaries (0x300a, 0x00be);
const DICOMTag DICOMBeamNumber (0x300a, 0x00c0);
const DICOMTag DICOMBeamName (0x300a, 0x00c2);
const DICOMTag DICOMBeamDescription (0x300a, 0x00c3);
const DICOMTag DICOMBeamType (0x300a, 0x00c4);
const DICOMTag DICOMRadiationType (0x300a, 0x00c6);
const DICOMTag DICOMHighDoseTechniqueType (0x300a, 0x00c7);
const DICOMTag DICOMReferenceImageNumber (0x300a, 0x00c8);
const DICOMTag DICOMPlannedVerificationImageSequence (0x300a, 0x00ca);
const DICOMTag DICOMImagingDeviceSpecificAcquisitionParameters (0x300a, 0x00cc);
const DICOMTag DICOMTreatmentDeliveryType (0x300a, 0x00ce);
const DICOMTag DICOMNumberOfWedges (0x300a, 0x00d0);
const DICOMTag DICOMWedgeSequence (0x300a, 0x00d1);
const DICOMTag DICOMWedgeNumber (0x300a, 0x00d2);
const DICOMTag DICOMWedgeType (0x300a, 0x00d3);
const DICOMTag DICOMWedgeID (0x300a, 0x00d4);
const DICOMTag DICOMWedgeAngle (0x300a, 0x00d5);
const DICOMTag DICOMWedgeFactor (0x300a, 0x00d6);
const DICOMTag DICOMTotalWedgeTrayWaterEquivalentThickness (0x300a, 0x00d7);
const DICOMTag DICOMWedgeOrientation (0x300a, 0x00d8);
const DICOMTag DICOMIsocenterToWedgeTrayDistance (0x300a, 0x00d9);
const DICOMTag DICOMSourceToWedgeTrayDistance (0x300a, 0x00da);
const DICOMTag DICOMWedgeThinEdgePosition (0x300a, 0x00db);
const DICOMTag DICOMBolusID (0x300a, 0x00dc);
const DICOMTag DICOMBolusDescription (0x300a, 0x00dd);
const DICOMTag DICOMNumberOfCompensators (0x300a, 0x00e0);
const DICOMTag DICOMMaterialID (0x300a, 0x00e1);
const DICOMTag DICOMTotalCompensatorTrayFactor (0x300a, 0x00e2);
const DICOMTag DICOMCompensatorSequence (0x300a, 0x00e3);
const DICOMTag DICOMCompensatorNumber (0x300a, 0x00e4);
const DICOMTag DICOMCompensatorID (0x300a, 0x00e5);
const DICOMTag DICOMSourceToCompensatorTrayDistance (0x300a, 0x00e6);
const DICOMTag DICOMCompensatorRows (0x300a, 0x00e7);
const DICOMTag DICOMCompensatorColumns (0x300a, 0x00e8);
const DICOMTag DICOMCompensatorPixelSpacing (0x300a, 0x00e9);
const DICOMTag DICOMCompensatorPosition (0x300a, 0x00ea);
const DICOMTag DICOMCompensatorTransmissionData (0x300a, 0x00eb);
const DICOMTag DICOMCompensatorThicknessData (0x300a, 0x00ec);
const DICOMTag DICOMNumberOfBoli (0x300a, 0x00ed);
const DICOMTag DICOMCompensatorType (0x300a, 0x00ee);
const DICOMTag DICOMCompensatorTrayID (0x300a, 0x00ef);
const DICOMTag DICOMNumberOfBlocks (0x300a, 0x00f0);
const DICOMTag DICOMTotalBlockTrayFactor (0x300a, 0x00f2);
const DICOMTag DICOMTotalBlockTrayWaterEquivalentThickness (0x300a, 0x00f3);
const DICOMTag DICOMBlockSequence (0x300a, 0x00f4);
const DICOMTag DICOMBlockTrayID (0x300a, 0x00f5);
const DICOMTag DICOMSourceToBlockTrayDistance (0x300a, 0x00f6);
const DICOMTag DICOMIsocenterToBlockTrayDistance (0x300a, 0x00f7);
const DICOMTag DICOMBlockType (0x300a, 0x00f8);
const DICOMTag DICOMAccessoryCode (0x300a, 0x00f9);
const DICOMTag DICOMBlockDivergence (0x300a, 0x00fa);
const DICOMTag DICOMBlockMountingPosition (0x300a, 0x00fb);
const DICOMTag DICOMBlockNumber (0x300a, 0x00fc);
const DICOMTag DICOMBlockName (0x300a, 0x00fe);
const DICOMTag DICOMBlockThickness (0x300a, 0x0100);
const DICOMTag DICOMBlockTransmission (0x300a, 0x0102);
const DICOMTag DICOMBlockNumberOfPoints (0x300a, 0x0104);
const DICOMTag DICOMBlockData (0x300a, 0x0106);
const DICOMTag DICOMApplicatorSequence (0x300a, 0x0107);
const DICOMTag DICOMApplicatorID (0x300a, 0x0108);
const DICOMTag DICOMApplicatorType (0x300a, 0x0109);
const DICOMTag DICOMApplicatorDescription (0x300a, 0x010a);
const DICOMTag DICOMCumulativeDoseReferenceCoefficient (0x300a, 0x010c);
const DICOMTag DICOMFinalCumulativeMetersetWeight (0x300a, 0x010e);
const DICOMTag DICOMNumberOfControlPoints (0x300a, 0x0110);
const DICOMTag DICOMControlPointSequence (0x300a, 0x0111);
const DICOMTag DICOMControlPointIndex (0x300a, 0x0112);
const DICOMTag DICOMNominalBeamEnergy (0x300a, 0x0114);
const DICOMTag DICOMDoseRateSet (0x300a, 0x0115);
const DICOMTag DICOMWedgePositionSequence (0x300a, 0x0116);
const DICOMTag DICOMWedgePosition (0x300a, 0x0118);
const DICOMTag DICOMBeamLimitingDevicePositionSequence (0x300a, 0x011a);
const DICOMTag DICOMLeafJawPositions (0x300a, 0x011c);
const DICOMTag DICOMGantryAngle (0x300a, 0x011e);
const DICOMTag DICOMGantryRotationDirection (0x300a, 0x011f);
const DICOMTag DICOMBeamLimitingDeviceAngle (0x300a, 0x0120);
const DICOMTag DICOMBeamLimitingDeviceRotationDirection (0x300a, 0x0121);
const DICOMTag DICOMPatientSupportAngle (0x300a, 0x0122);
const DICOMTag DICOMPatientSupportRotationDirection (0x300a, 0x0123);
const DICOMTag DICOMTableTopEccentricAxisDistance (0x300a, 0x0124);
const DICOMTag DICOMTableTopEccentricAngle (0x300a, 0x0125);
const DICOMTag DICOMTableTopEccentricRotationDirection (0x300a, 0x0126);
const DICOMTag DICOMTableTopVerticalPosition (0x300a, 0x0128);
const DICOMTag DICOMTableTopLongitudinalPosition (0x300a, 0x0129);
const DICOMTag DICOMTableTopLateralPosition (0x300a, 0x012a);
const DICOMTag DICOMIsocenterPosition (0x300a, 0x012c);
const DICOMTag DICOMSurfaceEntryPoint (0x300a, 0x012e);
const DICOMTag DICOMSourceToSurfaceDistance (0x300a, 0x0130);
const DICOMTag DICOMCumulativeMetersetWeight (0x300a, 0x0134);
const DICOMTag DICOMTableTopPitchAngle (0x300a, 0x0140);
const DICOMTag DICOMTableTopPitchRotationDirection (0x300a, 0x0142);
const DICOMTag DICOMTableTopRollAngle (0x300a, 0x0144);
const DICOMTag DICOMTableTopRollRotationDirection (0x300a, 0x0146);
const DICOMTag DICOMHeadFixationAngle (0x300a, 0x0148);
const DICOMTag DICOMGantryPitchAngle (0x300a, 0x014a);
const DICOMTag DICOMGantryPitchRotationDirection (0x300a, 0x014c);
const DICOMTag DICOMGantryPitchAngleTolerance (0x300a, 0x014e);
const DICOMTag DICOMPatientSetupSequence (0x300a, 0x0180);
const DICOMTag DICOMPatientSetupNumber (0x300a, 0x0182);
const DICOMTag DICOMPatientSetupLabel (0x300a, 0x0183);
const DICOMTag DICOMPatientAdditionalPosition (0x300a, 0x0184);
const DICOMTag DICOMFixationDeviceSequence (0x300a, 0x0190);
const DICOMTag DICOMFixationDeviceType (0x300a, 0x0192);
const DICOMTag DICOMFixationDeviceLabel (0x300a, 0x0194);
const DICOMTag DICOMFixationDeviceDescription (0x300a, 0x0196);
const DICOMTag DICOMFixationDevicePosition (0x300a, 0x0198);
const DICOMTag DICOMFixationDevicePitchAngle (0x300a, 0x0199);
const DICOMTag DICOMFixationDeviceRollAngle (0x300a, 0x019a);
const DICOMTag DICOMShieldingDeviceSequence (0x300a, 0x01a0);
const DICOMTag DICOMShieldingDeviceType (0x300a, 0x01a2);
const DICOMTag DICOMShieldingDeviceLabel (0x300a, 0x01a4);
const DICOMTag DICOMShieldingDeviceDescription (0x300a, 0x01a6);
const DICOMTag DICOMShieldingDevicePosition (0x300a, 0x01a8);
const DICOMTag DICOMSetupTechnique (0x300a, 0x01b0);
const DICOMTag DICOMSetupTechniqueDescription (0x300a, 0x01b2);
const DICOMTag DICOMSetupDeviceSequence (0x300a, 0x01b4);
const DICOMTag DICOMSetupDeviceType (0x300a, 0x01b6);
const DICOMTag DICOMSetupDeviceLabel (0x300a, 0x01b8);
const DICOMTag DICOMSetupDeviceDescription (0x300a, 0x01ba);
const DICOMTag DICOMSetupDeviceParameter (0x300a, 0x01bc);
const DICOMTag DICOMSetupReferenceDescription (0x300a, 0x01d0);
const DICOMTag DICOMTableTopVerticalSetupDisplacement (0x300a, 0x01d2);
const DICOMTag DICOMTableTopLongitudinalSetupDisplacement (0x300a, 0x01d4);
const DICOMTag DICOMTableTopLateralSetupDisplacement (0x300a, 0x01d6);
const DICOMTag DICOMBrachyTreatmentTechnique (0x300a, 0x0200);
const DICOMTag DICOMBrachyTreatmentType (0x300a, 0x0202);
const DICOMTag DICOMTreatmentMachineSequence (0x300a, 0x0206);
const DICOMTag DICOMSourceSequence (0x300a, 0x0210);
const DICOMTag DICOMSourceNumber (0x300a, 0x0212);
const DICOMTag DICOMSourceType (0x300a, 0x0214);
const DICOMTag DICOMSourceManufacturer (0x300a, 0x0216);
const DICOMTag DICOMActiveSourceDiameter (0x300a, 0x0218);
const DICOMTag DICOMActiveSourceLength (0x300a, 0x021a);
const DICOMTag DICOMSourceEncapsulationNominalThickness (0x300a, 0x0222);
const DICOMTag DICOMSourceEncapsulationNominalTransmission (0x300a, 0x0224);
const DICOMTag DICOMSourceIsotopeName (0x300a, 0x0226);
const DICOMTag DICOMSourceIsotopeHalfLife (0x300a, 0x0228);
const DICOMTag DICOMSourceStrengthUnits (0x300a, 0x0229);
const DICOMTag DICOMReferenceAirKermaRate (0x300a, 0x022a);
const DICOMTag DICOMSourceStrength (0x300a, 0x022b);
const DICOMTag DICOMSourceStrengthReferenceDate (0x300a, 0x022c);
const DICOMTag DICOMSourceStrengthReferenceTime (0x300a, 0x022e);
const DICOMTag DICOMApplicationSetupSequence (0x300a, 0x0230);
const DICOMTag DICOMApplicationSetupType (0x300a, 0x0232);
const DICOMTag DICOMApplicationSetupNumber (0x300a, 0x0234);
const DICOMTag DICOMApplicationSetupName (0x300a, 0x0236);
const DICOMTag DICOMApplicationSetupManufacturer (0x300a, 0x0238);
const DICOMTag DICOMTemplateNumber (0x300a, 0x0240);
const DICOMTag DICOMTemplateType (0x300a, 0x0242);
const DICOMTag DICOMTemplateName (0x300a, 0x0244);
const DICOMTag DICOMTotalReferenceAirKerma (0x300a, 0x0250);
const DICOMTag DICOMBrachyAccessoryDeviceSequence (0x300a, 0x0260);
const DICOMTag DICOMBrachyAccessoryDeviceNumber (0x300a, 0x0262);
const DICOMTag DICOMBrachyAccessoryDeviceID (0x300a, 0x0263);
const DICOMTag DICOMBrachyAccessoryDeviceType (0x300a, 0x0264);
const DICOMTag DICOMBrachyAccessoryDeviceName (0x300a, 0x0266);
const DICOMTag DICOMBrachyAccessoryDeviceNominalThickness (0x300a, 0x026a);
const DICOMTag DICOMBrachyAccessoryDeviceNominalTransmission (0x300a, 0x026c);
const DICOMTag DICOMChannelSequence (0x300a, 0x0280);
const DICOMTag DICOMChannelNumber (0x300a, 0x0282);
const DICOMTag DICOMChannelLength (0x300a, 0x0284);
const DICOMTag DICOMChannelTotalTime (0x300a, 0x0286);
const DICOMTag DICOMSourceMovementType (0x300a, 0x0288);
const DICOMTag DICOMNumberOfPulses (0x300a, 0x028a);
const DICOMTag DICOMPulseRepetitionInterval (0x300a, 0x028c);
const DICOMTag DICOMSourceApplicatorNumber (0x300a, 0x0290);
const DICOMTag DICOMSourceApplicatorID (0x300a, 0x0291);
const DICOMTag DICOMSourceApplicatorType (0x300a, 0x0292);
const DICOMTag DICOMSourceApplicatorName (0x300a, 0x0294);
const DICOMTag DICOMSourceApplicatorLength (0x300a, 0x0296);
const DICOMTag DICOMSourceApplicatorManufacturer (0x300a, 0x0298);
const DICOMTag DICOMSourceApplicatorWallNominalThickness (0x300a, 0x029c);
const DICOMTag DICOMSourceApplicatorWallNominalTransmission (0x300a, 0x029e);
const DICOMTag DICOMSourceApplicatorStepSize (0x300a, 0x02a0);
const DICOMTag DICOMTransferTubeNumber (0x300a, 0x02a2);
const DICOMTag DICOMTransferTubeLength (0x300a, 0x02a4);
const DICOMTag DICOMChannelShieldSequence (0x300a, 0x02b0);
const DICOMTag DICOMChannelShieldNumber (0x300a, 0x02b2);
const DICOMTag DICOMChannelShieldID (0x300a, 0x02b3);
const DICOMTag DICOMChannelShieldName (0x300a, 0x02b4);
const DICOMTag DICOMChannelShieldNominalThickness (0x300a, 0x02b8);
const DICOMTag DICOMChannelShieldNominalTransmission (0x300a, 0x02ba);
const DICOMTag DICOMFinalCumulativeTimeWeight (0x300a, 0x02c8);
const DICOMTag DICOMBrachyControlPointSequence (0x300a, 0x02d0);
const DICOMTag DICOMControlPointRelativePosition (0x300a, 0x02d2);
const DICOMTag DICOMControlPoint3DPosition (0x300a, 0x02d4);
const DICOMTag DICOMCumulativeTimeWeight (0x300a, 0x02d6);
const DICOMTag DICOMCompensatorDivergence (0x300a, 0x02e0);
const DICOMTag DICOMCompensatorMountingPosition (0x300a, 0x02e1);
const DICOMTag DICOMSourceToCompensatorDistance (0x300a, 0x02e2);
const DICOMTag DICOMTotalCompensatorTrayWaterEquivalentThickness (0x300a, 0x02e3);
const DICOMTag DICOMIsocenterToCompensatorTrayDistance (0x300a, 0x02e4);
const DICOMTag DICOMCompensatorColumnOffset (0x300a, 0x02e5);
const DICOMTag DICOMIsocenterToCompensatorDistances (0x300a, 0x02e6);
const DICOMTag DICOMCompensatorRelativeStoppingPowerRatio (0x300a, 0x02e7);
const DICOMTag DICOMCompensatorMillingToolDiameter (0x300a, 0x02e8);
const DICOMTag DICOMIonRangeCompensatorSequence (0x300a, 0x02ea);
const DICOMTag DICOMCompensatorDescription (0x300a, 0x02eb);
const DICOMTag DICOMRadiationMassNumber (0x300a, 0x0302);
const DICOMTag DICOMRadiationAtomicNumber (0x300a, 0x0304);
const DICOMTag DICOMRadiationChargeState (0x300a, 0x0306);
const DICOMTag DICOMScanMode (0x300a, 0x0308);
const DICOMTag DICOMVirtualSourceAxisDistances (0x300a, 0x030a);
const DICOMTag DICOMSnoutSequence (0x300a, 0x030c);
const DICOMTag DICOMSnoutPosition (0x300a, 0x030d);
const DICOMTag DICOMSnoutID (0x300a, 0x030f);
const DICOMTag DICOMNumberOfRangeShifters (0x300a, 0x0312);
const DICOMTag DICOMRangeShifterSequence (0x300a, 0x0314);
const DICOMTag DICOMRangeShifterNumber (0x300a, 0x0316);
const DICOMTag DICOMRangeShifterID (0x300a, 0x0318);
const DICOMTag DICOMRangeShifterType (0x300a, 0x0320);
const DICOMTag DICOMRangeShifterDescription (0x300a, 0x0322);
const DICOMTag DICOMNumberOfLateralSpreadingDevices (0x300a, 0x0330);
const DICOMTag DICOMLateralSpreadingDeviceSequence (0x300a, 0x0332);
const DICOMTag DICOMLateralSpreadingDeviceNumber (0x300a, 0x0334);
const DICOMTag DICOMLateralSpreadingDeviceID (0x300a, 0x0336);
const DICOMTag DICOMLateralSpreadingDeviceType (0x300a, 0x0338);
const DICOMTag DICOMLateralSpreadingDeviceDescription (0x300a, 0x033a);
const DICOMTag DICOMLateralSpreadingDeviceWaterEquivalentThickness (0x300a, 0x033c);
const DICOMTag DICOMNumberOfRangeModulators (0x300a, 0x0340);
const DICOMTag DICOMRangeModulatorSequence (0x300a, 0x0342);
const DICOMTag DICOMRangeModulatorNumber (0x300a, 0x0344);
const DICOMTag DICOMRangeModulatorID (0x300a, 0x0346);
const DICOMTag DICOMRangeModulatorType (0x300a, 0x0348);
const DICOMTag DICOMRangeModulatorDescription (0x300a, 0x034a);
const DICOMTag DICOMBeamCurrentModulationID (0x300a, 0x034c);
const DICOMTag DICOMPatientSupportType (0x300a, 0x0350);
const DICOMTag DICOMPatientSupportID (0x300a, 0x0352);
const DICOMTag DICOMPatientSupportAccessoryCode (0x300a, 0x0354);
const DICOMTag DICOMFixationLightAzimuthalAngle (0x300a, 0x0356);
const DICOMTag DICOMFixationLightPolarAngle (0x300a, 0x0358);
const DICOMTag DICOMMetersetRate (0x300a, 0x035a);
const DICOMTag DICOMRangeShifterSettingsSequence (0x300a, 0x0360);
const DICOMTag DICOMRangeShifterSetting (0x300a, 0x0362);
const DICOMTag DICOMIsocenterToRangeShifterDistance (0x300a, 0x0364);
const DICOMTag DICOMRangeShifterWaterEquivalentThickness (0x300a, 0x0366);
const DICOMTag DICOMLateralSpreadingDeviceSettingsSequence (0x300a, 0x0370);
const DICOMTag DICOMLateralSpreadingDeviceSetting (0x300a, 0x0372);
const DICOMTag DICOMIsocenterToLateralSpreadingDeviceDistance (0x300a, 0x0374);
const DICOMTag DICOMRangeModulatorSettingsSequence (0x300a, 0x0380);
const DICOMTag DICOMRangeModulatorGatingStartValue (0x300a, 0x0382);
const DICOMTag DICOMRangeModulatorGatingStopValue (0x300a, 0x0384);
const DICOMTag DICOMRangeModulatorGatingStartWaterEquivalentThickness (0x300a, 0x0386);
const DICOMTag DICOMRangeModulatorGatingStopWaterEquivalentThickness (0x300a, 0x0388);
const DICOMTag DICOMIsocenterToRangeModulatorDistance (0x300a, 0x038a);
const DICOMTag DICOMScanSpotTuneID (0x300a, 0x0390);
const DICOMTag DICOMNumberOfScanSpotPositions (0x300a, 0x0392);
const DICOMTag DICOMScanSpotPositionMap (0x300a, 0x0394);
const DICOMTag DICOMScanSpotMetersetWeights (0x300a, 0x0396);
const DICOMTag DICOMScanningSpotSize (0x300a, 0x0398);
const DICOMTag DICOMNumberOfPaintings (0x300a, 0x039a);
const DICOMTag DICOMIonToleranceTableSequence (0x300a, 0x03a0);
const DICOMTag DICOMIonBeamSequence (0x300a, 0x03a2);
const DICOMTag DICOMIonBeamLimitingDeviceSequence (0x300a, 0x03a4);
const DICOMTag DICOMIonBlockSequence (0x300a, 0x03a6);
const DICOMTag DICOMIonControlPointSequence (0x300a, 0x03a8);
const DICOMTag DICOMIonWedgeSequence (0x300a, 0x03aa);
const DICOMTag DICOMIonWedgePositionSequence (0x300a, 0x03ac);
const DICOMTag DICOMReferencedSetupImageSequence (0x300a, 0x0401);
const DICOMTag DICOMSetupImageComment (0x300a, 0x0402);
const DICOMTag DICOMMotionSynchronizationSequence (0x300a, 0x0410);
const DICOMTag DICOMControlPointOrientation (0x300a, 0x0412);
const DICOMTag DICOMGeneralAccessorySequence (0x300a, 0x0420);
const DICOMTag DICOMGeneralAccessoryID (0x300a, 0x0421);
const DICOMTag DICOMGeneralAccessoryDescription (0x300a, 0x0422);
const DICOMTag DICOMGeneralAccessoryType (0x300a, 0x0423);
const DICOMTag DICOMGeneralAccessoryNumber (0x300a, 0x0424);
const DICOMTag DICOMApplicatorGeometrySequence (0x300a, 0x0431);
const DICOMTag DICOMApplicatorApertureShape (0x300a, 0x0432);
const DICOMTag DICOMApplicatorOpening (0x300a, 0x0433);
const DICOMTag DICOMApplicatorOpeningX (0x300a, 0x0434);
const DICOMTag DICOMApplicatorOpeningY (0x300a, 0x0435);
const DICOMTag DICOMSourceToApplicatorMountingPositionDistance (0x300a, 0x0436);
const DICOMTag DICOMReferencedRTPlanSequence (0x300c, 0x0002);
const DICOMTag DICOMReferencedBeamSequence (0x300c, 0x0004);
const DICOMTag DICOMReferencedBeamNumber (0x300c, 0x0006);
const DICOMTag DICOMReferencedReferenceImageNumber (0x300c, 0x0007);
const DICOMTag DICOMStartCumulativeMetersetWeight (0x300c, 0x0008);
const DICOMTag DICOMEndCumulativeMetersetWeight (0x300c, 0x0009);
const DICOMTag DICOMReferencedBrachyApplicationSetupSequence (0x300c, 0x000a);
const DICOMTag DICOMReferencedBrachyApplicationSetupNumber (0x300c, 0x000c);
const DICOMTag DICOMReferencedSourceNumber (0x300c, 0x000e);
const DICOMTag DICOMReferencedFractionGroupSequence (0x300c, 0x0020);
const DICOMTag DICOMReferencedFractionGroupNumber (0x300c, 0x0022);
const DICOMTag DICOMReferencedVerificationImageSequence (0x300c, 0x0040);
const DICOMTag DICOMReferencedReferenceImageSequence (0x300c, 0x0042);
const DICOMTag DICOMReferencedDoseReferenceSequence (0x300c, 0x0050);
const DICOMTag DICOMReferencedDoseReferenceNumber (0x300c, 0x0051);
const DICOMTag DICOMBrachyReferencedDoseReferenceSequence (0x300c, 0x0055);
const DICOMTag DICOMReferencedStructureSetSequence (0x300c, 0x0060);
const DICOMTag DICOMReferencedPatientSetupNumber (0x300c, 0x006a);
const DICOMTag DICOMReferencedDoseSequence (0x300c, 0x0080);
const DICOMTag DICOMReferencedToleranceTableNumber (0x300c, 0x00a0);
const DICOMTag DICOMReferencedBolusSequence (0x300c, 0x00b0);
const DICOMTag DICOMReferencedWedgeNumber (0x300c, 0x00c0);
const DICOMTag DICOMReferencedCompensatorNumber (0x300c, 0x00d0);
const DICOMTag DICOMReferencedBlockNumber (0x300c, 0x00e0);
const DICOMTag DICOMReferencedControlPointIndex (0x300c, 0x00f0);
const DICOMTag DICOMReferencedControlPointSequence (0x300c, 0x00f2);
const DICOMTag DICOMReferencedStartControlPointIndex (0x300c, 0x00f4);
const DICOMTag DICOMReferencedStopControlPointIndex (0x300c, 0x00f6);
const DICOMTag DICOMReferencedRangeShifterNumber (0x300c, 0x0100);
const DICOMTag DICOMReferencedLateralSpreadingDeviceNumber (0x300c, 0x0102);
const DICOMTag DICOMReferencedRangeModulatorNumber (0x300c, 0x0104);
const DICOMTag DICOMApprovalStatus (0x300e, 0x0002);
const DICOMTag DICOMReviewDate (0x300e, 0x0004);
const DICOMTag DICOMReviewTime (0x300e, 0x0005);
const DICOMTag DICOMReviewerName (0x300e, 0x0008);
const DICOMTag DICOMACR_NEMA_TextGroupLength (0x4000, 0x0000);
const DICOMTag DICOMRETIREDArbitrary (0x4000, 0x0010);
const DICOMTag DICOMRETIREDTextComments (0x4000, 0x4000);
const DICOMTag DICOMRETIREDResultsID (0x4008, 0x0040);
const DICOMTag DICOMRETIREDResultsIDIssuer (0x4008, 0x0042);
const DICOMTag DICOMRETIREDReferencedInterpretationSequence (0x4008, 0x0050);
const DICOMTag DICOMRETIREDReportProductionStatusTrial (0x4008, 0x00ff);
const DICOMTag DICOMRETIREDInterpretationRecordedDate (0x4008, 0x0100);
const DICOMTag DICOMRETIREDInterpretationRecordedTime (0x4008, 0x0101);
const DICOMTag DICOMRETIREDInterpretationRecorder (0x4008, 0x0102);
const DICOMTag DICOMRETIREDReferenceToRecordedSound (0x4008, 0x0103);
const DICOMTag DICOMRETIREDInterpretationTranscriptionDate (0x4008, 0x0108);
const DICOMTag DICOMRETIREDInterpretationTranscriptionTime (0x4008, 0x0109);
const DICOMTag DICOMRETIREDInterpretationTranscriber (0x4008, 0x010a);
const DICOMTag DICOMRETIREDInterpretationText (0x4008, 0x010b);
const DICOMTag DICOMRETIREDInterpretationAuthor (0x4008, 0x010c);
const DICOMTag DICOMRETIREDInterpretationApproverSequence (0x4008, 0x0111);
const DICOMTag DICOMRETIREDInterpretationApprovalDate (0x4008, 0x0112);
const DICOMTag DICOMRETIREDInterpretationApprovalTime (0x4008, 0x0113);
const DICOMTag DICOMRETIREDPhysicianApprovingInterpretation (0x4008, 0x0114);
const DICOMTag DICOMRETIREDInterpretationDiagnosisDescription (0x4008, 0x0115);
const DICOMTag DICOMRETIREDInterpretationDiagnosisCodeSequence (0x4008, 0x0117);
const DICOMTag DICOMRETIREDResultsDistributionListSequence (0x4008, 0x0118);
const DICOMTag DICOMRETIREDDistributionName (0x4008, 0x0119);
const DICOMTag DICOMRETIREDDistributionAddress (0x4008, 0x011a);
const DICOMTag DICOMRETIREDInterpretationID (0x4008, 0x0200);
const DICOMTag DICOMRETIREDInterpretationIDIssuer (0x4008, 0x0202);
const DICOMTag DICOMRETIREDInterpretationTypeID (0x4008, 0x0210);
const DICOMTag DICOMRETIREDInterpretationStatusID (0x4008, 0x0212);
const DICOMTag DICOMRETIREDImpressions (0x4008, 0x0300);
const DICOMTag DICOMRETIREDResultsComments (0x4008, 0x4000);
const DICOMTag DICOMLowEnergyDetectors (0x4010, 0x0001);
const DICOMTag DICOMHighEnergyDetectors (0x4010, 0x0002);
const DICOMTag DICOMDetectorGeometrySequence (0x4010, 0x0004);
const DICOMTag DICOMThreatROIVoxelSequence (0x4010, 0x1001);
const DICOMTag DICOMThreatROIBase (0x4010, 0x1004);
const DICOMTag DICOMThreatROIExtents (0x4010, 0x1005);
const DICOMTag DICOMThreatROIBitmap (0x4010, 0x1006);
const DICOMTag DICOMRouteSegmentID (0x4010, 0x1007);
const DICOMTag DICOMGantryType (0x4010, 0x1008);
const DICOMTag DICOMOOIOwnerType (0x4010, 0x1009);
const DICOMTag DICOMRouteSegmentSequence (0x4010, 0x100a);
const DICOMTag DICOMPotentialThreatObjectID (0x4010, 0x1010);
const DICOMTag DICOMThreatSequence (0x4010, 0x1011);
const DICOMTag DICOMThreatCategory (0x4010, 0x1012);
const DICOMTag DICOMThreatCategoryDescription (0x4010, 0x1013);
const DICOMTag DICOMATDAbilityAssessment (0x4010, 0x1014);
const DICOMTag DICOMATDAssessmentFlag (0x4010, 0x1015);
const DICOMTag DICOMATDAssessmentProbability (0x4010, 0x1016);
const DICOMTag DICOMMass (0x4010, 0x1017);
const DICOMTag DICOMDensity (0x4010, 0x1018);
const DICOMTag DICOMZEffective (0x4010, 0x1019);
const DICOMTag DICOMBoardingPassID (0x4010, 0x101a);
const DICOMTag DICOMCenterOfMass (0x4010, 0x101b);
const DICOMTag DICOMCenterOfPTO (0x4010, 0x101c);
const DICOMTag DICOMBoundingPolygon (0x4010, 0x101d);
const DICOMTag DICOMRouteSegmentStartLocationID (0x4010, 0x101e);
const DICOMTag DICOMRouteSegmentEndLocationID (0x4010, 0x101f);
const DICOMTag DICOMRouteSegmentLocationIDType (0x4010, 0x1020);
const DICOMTag DICOMAbortReason (0x4010, 0x1021);
const DICOMTag DICOMVolumeOfPTO (0x4010, 0x1023);
const DICOMTag DICOMAbortFlag (0x4010, 0x1024);
const DICOMTag DICOMRouteSegmentStartTime (0x4010, 0x1025);
const DICOMTag DICOMRouteSegmentEndTime (0x4010, 0x1026);
const DICOMTag DICOMTDRType (0x4010, 0x1027);
const DICOMTag DICOMInternationalRouteSegment (0x4010, 0x1028);
const DICOMTag DICOMThreatDetectionAlgorithmandVersion (0x4010, 0x1029);
const DICOMTag DICOMAssignedLocation (0x4010, 0x102a);
const DICOMTag DICOMAlarmDecisionTime (0x4010, 0x102b);
const DICOMTag DICOMAlarmDecision (0x4010, 0x1031);
const DICOMTag DICOMNumberOfTotalObjects (0x4010, 0x1033);
const DICOMTag DICOMNumberOfAlarmObjects (0x4010, 0x1034);
const DICOMTag DICOMPTORepresentationSequence (0x4010, 0x1037);
const DICOMTag DICOMATDAssessmentSequence (0x4010, 0x1038);
const DICOMTag DICOMTIPType (0x4010, 0x1039);
const DICOMTag DICOMDICOSVersion (0x4010, 0x103a);
const DICOMTag DICOMOOIOwnerCreationTime (0x4010, 0x1041);
const DICOMTag DICOMOOIType (0x4010, 0x1042);
const DICOMTag DICOMOOISize (0x4010, 0x1043);
const DICOMTag DICOMAcquisitionStatus (0x4010, 0x1044);
const DICOMTag DICOMBasisMaterialsCodeSequence (0x4010, 0x1045);
const DICOMTag DICOMPhantomType (0x4010, 0x1046);
const DICOMTag DICOMOOIOwnerSequence (0x4010, 0x1047);
const DICOMTag DICOMScanType (0x4010, 0x1048);
const DICOMTag DICOMItineraryID (0x4010, 0x1051);
const DICOMTag DICOMItineraryIDType (0x4010, 0x1052);
const DICOMTag DICOMItineraryIDAssigningAuthority (0x4010, 0x1053);
const DICOMTag DICOMRouteID (0x4010, 0x1054);
const DICOMTag DICOMRouteIDAssigningAuthority (0x4010, 0x1055);
const DICOMTag DICOMInboundArrivalType (0x4010, 0x1056);
const DICOMTag DICOMCarrierID (0x4010, 0x1058);
const DICOMTag DICOMCarrierIDAssigningAuthority (0x4010, 0x1059);
const DICOMTag DICOMSourceOrientation (0x4010, 0x1060);
const DICOMTag DICOMSourcePosition (0x4010, 0x1061);
const DICOMTag DICOMBeltHeight (0x4010, 0x1062);
const DICOMTag DICOMAlgorithmRoutingCodeSequence (0x4010, 0x1064);
const DICOMTag DICOMTransportClassification (0x4010, 0x1067);
const DICOMTag DICOMOOITypeDescriptor (0x4010, 0x1068);
const DICOMTag DICOMTotalProcessingTime (0x4010, 0x1069);
const DICOMTag DICOMDetectorCalibrationData (0x4010, 0x106c);
const DICOMTag DICOMMACParametersSequence (0x4ffe, 0x0001);
const DICOMTag DICOMSharedFunctionalGroupsSequence (0x5200, 0x9229);
const DICOMTag DICOMPerFrameFunctionalGroupsSequence (0x5200, 0x9230);
const DICOMTag DICOMWaveformSequence (0x5400, 0x0100);
const DICOMTag DICOMChannelMinimumValue (0x5400, 0x0110);
const DICOMTag DICOMChannelMaximumValue (0x5400, 0x0112);
const DICOMTag DICOMWaveformBitsAllocated (0x5400, 0x1004);
const DICOMTag DICOMWaveformSampleInterpretation (0x5400, 0x1006);
const DICOMTag DICOMWaveformPaddingValue (0x5400, 0x100a);
const DICOMTag DICOMWaveformData (0x5400, 0x1010);
const DICOMTag DICOMFirstOrderPhaseCorrectionAngle (0x5600, 0x0010);
const DICOMTag DICOMSpectroscopyData (0x5600, 0x0020);
const DICOMTag DICOMPixelData (0x7fe0, 0x0010);
const DICOMTag DICOMRETIREDCoefficientsSDVN (0x7fe0, 0x0020);
const DICOMTag DICOMRETIREDCoefficientsSDHN (0x7fe0, 0x0030);
const DICOMTag DICOMRETIREDCoefficientsSDDN (0x7fe0, 0x0040);
const DICOMTag DICOMDigitalSignaturesSequence (0xfffa, 0xfffa);
const DICOMTag DICOMDataSetTrailingPadding (0xfffc, 0xfffc);
const DICOMTag DICOMItem (0xfffe, 0xe000);
const DICOMTag DICOMItemDelimitationItem (0xfffe, 0xe00d);
const DICOMTag DICOMSequenceDelimitationItem (0xfffe, 0xe0dd);

// Tags where the group/element can vary (repeating tags).
// Number of entries: 78
const DICOMTag DICOMOverlayRows (0x6000, 0x0010);                                       // (0x6000-0x60ff,0x0010)
const DICOMTag DICOMOverlayColumns (0x6000, 0x0011);                                    // (0x6000-0x60ff,0x0011)
const DICOMTag DICOMNumberOfFramesInOverlay (0x6000, 0x0015);                           // (0x6000-0x60ff,0x0015)
const DICOMTag DICOMOverlayDescription (0x6000, 0x0022);                                // (0x6000-0x60ff,0x0022)
const DICOMTag DICOMOverlayType (0x6000, 0x0040);                                       // (0x6000-0x60ff,0x0040)
const DICOMTag DICOMOverlaySubtype (0x6000, 0x0045);                                    // (0x6000-0x60ff,0x0045)
const DICOMTag DICOMOverlayOrigin (0x6000, 0x0050);                                     // (0x6000-0x60ff,0x0050)
const DICOMTag DICOMImageFrameOrigin (0x6000, 0x0051);                                  // (0x6000-0x60ff,0x0051)
const DICOMTag DICOMOverlayBitsAllocated (0x6000, 0x0100);                              // (0x6000-0x60ff,0x0100)
const DICOMTag DICOMOverlayBitPosition (0x6000, 0x0102);                                // (0x6000-0x60ff,0x0102)
const DICOMTag DICOMOverlayActivationLayer (0x6000, 0x1001);                            // (0x6000-0x60ff,0x1001)
const DICOMTag DICOMROIArea (0x6000, 0x1301);                                           // (0x6000-0x60ff,0x1301)
const DICOMTag DICOMROIMean (0x6000, 0x1302);                                           // (0x6000-0x60ff,0x1302)
const DICOMTag DICOMROIStandardDeviation (0x6000, 0x1303);                              // (0x6000-0x60ff,0x1303)
const DICOMTag DICOMOverlayLabel (0x6000, 0x1500);                                      // (0x6000-0x60ff,0x1500)
const DICOMTag DICOMOverlayData (0x6000, 0x3000);                                       // (0x6000-0x60ff,0x3000)
const DICOMTag DICOMACR_NEMA_2C_VariablePixelDataGroupLength (0x7f00, 0x0000);          // (0x7f00-0x7fff,0x0000)
const DICOMTag DICOMPrivateGroupLength (0x0009, 0x0000);                                // (0x0009-o-0xffff,0x0000)
const DICOMTag DICOMRETIREDOverlayCompressionCode (0x6000, 0x0060);                     // (0x6000-0x60ff,0x0060)
const DICOMTag DICOMRETIREDOverlayCompressionOriginator (0x6000, 0x0061);               // (0x6000-0x60ff,0x0061)
const DICOMTag DICOMRETIREDOverlayCompressionLabel (0x6000, 0x0062);                    // (0x6000-0x60ff,0x0062)
const DICOMTag DICOMRETIREDOverlayCompressionDescription (0x6000, 0x0063);              // (0x6000-0x60ff,0x0063)
const DICOMTag DICOMRETIREDOverlayCompressionStepPointers (0x6000, 0x0066);             // (0x6000-0x60ff,0x0066)
const DICOMTag DICOMRETIREDOverlayRepeatInterval (0x6000, 0x0068);                      // (0x6000-0x60ff,0x0068)
const DICOMTag DICOMRETIREDOverlayBitsGrouped (0x6000, 0x0069);                         // (0x6000-0x60ff,0x0069)
const DICOMTag DICOMRETIREDVariablePixelData (0x7f00, 0x0010);                          // (0x7f00-0x7fff,0x0010)
const DICOMTag DICOMRETIREDVariableNextDataGroup (0x7f00, 0x0011);                      // (0x7f00-0x7fff,0x0011)
const DICOMTag DICOMRETIREDVariableCoefficientsSDVN (0x7f00, 0x0020);                   // (0x7f00-0x7fff,0x0020)
const DICOMTag DICOMRETIREDVariableCoefficientsSDHN (0x7f00, 0x0030);                   // (0x7f00-0x7fff,0x0030)
const DICOMTag DICOMRETIREDVariableCoefficientsSDDN (0x7f00, 0x0040);                   // (0x7f00-0x7fff,0x0040)
const DICOMTag DICOMRETIREDNumberOfPoints (0x5000, 0x0010);                             // (0x5000-0x50ff,0x0010)
const DICOMTag DICOMRETIREDTypeOfData (0x5000, 0x0020);                                 // (0x5000-0x50ff,0x0020)
const DICOMTag DICOMRETIREDCurveDescription (0x5000, 0x0022);                           // (0x5000-0x50ff,0x0022)
const DICOMTag DICOMRETIREDAxisUnits (0x5000, 0x0030);                                  // (0x5000-0x50ff,0x0030)
const DICOMTag DICOMRETIREDAxisLabels (0x5000, 0x0040);                                 // (0x5000-0x50ff,0x0040)
const DICOMTag DICOMRETIREDOverlayPlanes (0x6000, 0x0012);                              // (0x6000-0x60ff,0x0012)
const DICOMTag DICOMRETIREDOverlayPlaneOrigin (0x6000, 0x0052);                         // (0x6000-0x60ff,0x0052)
const DICOMTag DICOMPrivateCreator (0x0009, 0x0010);                                    // (0x0009-o-0xffff,0x0010-u-0x00ff)
const DICOMTag DICOMIllegalGroupLength (0x0001, 0x0000);                                // (0x0001-o-0x0007,0x0000)
const DICOMTag DICOMIllegalPrivateCreator (0x0001, 0x0010);                             // (0x0001-o-0x0007,0x0010-u-0x00ff)
const DICOMTag DICOMGenericGroupLength (0x0000, 0x0000);                                // (0x0000-u-0xffff,0x0000)
const DICOMTag DICOMRETIREDSourceImageIDs (0x0020, 0x3100);                             // (0x0020,0x3100-0x31ff)
const DICOMTag DICOMRETIREDOverlayFormat (0x6000, 0x0110);                              // (0x6000-0x60ff,0x0110)
const DICOMTag DICOMRETIREDOverlayLocation (0x6000, 0x0200);                            // (0x6000-0x60ff,0x0200)
const DICOMTag DICOMRETIREDOverlayComments (0x6000, 0x4000);                            // (0x6000-0x60ff,0x4000)
const DICOMTag DICOMRETIREDOverlayCodeLabel (0x6000, 0x0800);                           // (0x6000-0x60ff,0x0800)
const DICOMTag DICOMRETIREDOverlayNumberOfTables (0x6000, 0x0802);                      // (0x6000-0x60ff,0x0802)
const DICOMTag DICOMRETIREDOverlayCodeTableLocation (0x6000, 0x0803);                   // (0x6000-0x60ff,0x0803)
const DICOMTag DICOMRETIREDOverlayBitsForCodeWord (0x6000, 0x0804);                     // (0x6000-0x60ff,0x0804)
const DICOMTag DICOMRETIREDCurveDimensions (0x5000, 0x0005);                            // (0x5000-0x50ff,0x0005)
const DICOMTag DICOMRETIREDDataValueRepresentation (0x5000, 0x0103);                    // (0x5000-0x50ff,0x0103)
const DICOMTag DICOMRETIREDMinimumCoordinateValue (0x5000, 0x0104);                     // (0x5000-0x50ff,0x0104)
const DICOMTag DICOMRETIREDMaximumCoordinateValue (0x5000, 0x0105);                     // (0x5000-0x50ff,0x0105)
const DICOMTag DICOMRETIREDCurveRange (0x5000, 0x0106);                                 // (0x5000-0x50ff,0x0106)
const DICOMTag DICOMRETIREDCurveDataDescriptor (0x5000, 0x0110);                        // (0x5000-0x50ff,0x0110)
const DICOMTag DICOMRETIREDCoordinateStartValue (0x5000, 0x0112);                       // (0x5000-0x50ff,0x0112)
const DICOMTag DICOMRETIREDCoordinateStepValue (0x5000, 0x0114);                        // (0x5000-0x50ff,0x0114)
const DICOMTag DICOMRETIREDCurveActivationLayer (0x5000, 0x1001);                       // (0x5000-0x50ff,0x1001)
const DICOMTag DICOMRETIREDAudioType (0x5000, 0x2000);                                  // (0x5000-0x50ff,0x2000)
const DICOMTag DICOMRETIREDAudioSampleFormat (0x5000, 0x2002);                          // (0x5000-0x50ff,0x2002)
const DICOMTag DICOMRETIREDNumberOfChannels (0x5000, 0x2004);                           // (0x5000-0x50ff,0x2004)
const DICOMTag DICOMRETIREDNumberOfSamples (0x5000, 0x2006);                            // (0x5000-0x50ff,0x2006)
const DICOMTag DICOMRETIREDSampleRate (0x5000, 0x2008);                                 // (0x5000-0x50ff,0x2008)
const DICOMTag DICOMRETIREDTotalTime (0x5000, 0x200a);                                  // (0x5000-0x50ff,0x200a)
const DICOMTag DICOMRETIREDAudioSampleData (0x5000, 0x200c);                            // (0x5000-0x50ff,0x200c)
const DICOMTag DICOMRETIREDAudioComments (0x5000, 0x200e);                              // (0x5000-0x50ff,0x200e)
const DICOMTag DICOMRETIREDCurveLabel (0x5000, 0x2500);                                 // (0x5000-0x50ff,0x2500)
const DICOMTag DICOMRETIREDCurveReferencedOverlaySequence (0x5000, 0x2600);             // (0x5000-0x50ff,0x2600)
const DICOMTag DICOMRETIREDCurveReferencedOverlayGroup (0x5000, 0x2610);                // (0x5000-0x50ff,0x2610)
const DICOMTag DICOMRETIREDCurveData (0x5000, 0x3000);                                  // (0x5000-0x50ff,0x3000)
const DICOMTag DICOMRETIREDOverlayDescriptorGray (0x6000, 0x1100);                      // (0x6000-0x60ff,0x1100)
const DICOMTag DICOMRETIREDOverlayDescriptorRed (0x6000, 0x1101);                       // (0x6000-0x60ff,0x1101)
const DICOMTag DICOMRETIREDOverlayDescriptorGreen (0x6000, 0x1102);                     // (0x6000-0x60ff,0x1102)
const DICOMTag DICOMRETIREDOverlayDescriptorBlue (0x6000, 0x1103);                      // (0x6000-0x60ff,0x1103)
const DICOMTag DICOMRETIREDOverlaysGray (0x6000, 0x1200);                               // (0x6000-0x60ff,0x1200)
const DICOMTag DICOMRETIREDOverlaysRed (0x6000, 0x1201);                                // (0x6000-0x60ff,0x1201)
const DICOMTag DICOMRETIREDOverlaysGreen (0x6000, 0x1202);                              // (0x6000-0x60ff,0x1202)
const DICOMTag DICOMRETIREDOverlaysBlue (0x6000, 0x1203);                               // (0x6000-0x60ff,0x1203)
}
#endif // UDGDICOMDICTIONARYH
